# Drupal TDD Enforcer

Ensures every PHP file in your custom modules has a corresponding test file. Fails the pipeline if any are missing.

## Usage

Add to your `.gitlab-ci.yml`:

```yaml
include:
  - component: gitlab.bluefly..io/bluefly/ci-components/bfcicomponents/drupal-tdd-enforcer@main
```

## Inputs

- `custom_module_path`: Path to custom modules (default: `web/modules/custom`)
- `test_path`: Path to tests (default: `tests/src`)

## How it works

- Scans all PHP files in your custom modules.
- Checks for a corresponding test file in your test directory (e.g., `Foo.php` → `FooTest.php`).
- Fails if any are missing.

## Best Practice

Use with TDD and enforce before merge to main/staging. 