# Roadmap

_Generated on 2025-05-30_

Found 1123 TODO items in the codebase.

## BUG Items (5)

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

### subchannel-call.js

- **Line 209:** reports indicate that Node synthesizes a NGHTTP2_CANCEL

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### agent.js

- **Line 212:** The session may be never created when:

## FIXME Items (15)

### temp.js

- **Line 48:** Rough and quick attempt at detecting ok lengths
- **Line 51:** No truncable part detected, can't really do much without also changing the parent path, which is unsafe, hoping for the best here
- **Line 53:** The truncable part might be shorter than needed here

### temp.ts

- **Line 78:** This doesn't really always work, the actual filesystem limits must be detected for this to be implemented correctly

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### hook.js

- **Line 12:** Typescript extensions are added temporarily until we find a better

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### attemptify.js

- **Line 2:** The return type of these functions is wrong, it doesn't account for returning "undefined", but a correct type cannot be written because generics cannot be extended properly, it seems

### retryify.js

- **Line 4:** There are a boatload of anys here, but apparently generics cannot be extended properly, so...

## HACK Items (9)

### schema.js

- **Line 35:** Delete the OpenAPI schema IDs because ZSchema can't resolve them

### extend-error.js

- **Line 58:** We have to cast the errors to `any` so we can use symbol indexers.

### isomorphic.node.js

- **Line 27:** We have to cast the objects to `any` so we can use symbol indexers.

### Observable.ts

- **Line 38:** Since TypeScript inherits static properties too, we have to

### AsyncAction.ts

- **Line 122:** Since code elsewhere is relying on the "truthiness" of the

### QueueAction.ts

- **Line 38:** In the past, this was returning `void`. However, `void` isn't a valid

### types.ts

- **Line 337:** As of TS 4.2.2, The provided types for the iterator results of a `ReadableStreamDefaultReader`

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

## NOTE Items (539)

### build.js

- **Line 30:** In a real implementation, you'd use execa with stdio: 'inherit' for watch mode

### init.js

- **Line 310:** This check relies on the package manager lock file existing *before* normalizeOptions is called.

### GitLabEvent.js

- **Line 24:** (comment) events

### command-definitions.d.ts

- **Line 14:** This structure might be simplified or replaced by direct command definitions

### self-healing.js

- **Line 266:** This works only if the consumer code uses the fixed data

### index.js

- **Line 87:** According to the JSON Reference spec, these should already be URLs,

### resolve-external.js

- **Line 38:** We only care about EXTERNAL references here. INTERNAL references are only relevant when dereferencing.

### index.js

- **Line 154:** This is safe to do, because we haven't dereferenced circular $refs yet

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### changesets-assemble-release-plan.esm.js

- **Line 170:** this is intended to be called recursively

### changesets-cli.cjs.js

- **Line 474:** Getting the changed packages is best effort as it's only being used for easier selection
- **Line 782:** that the `--json` output is always printed at the end so this should work
- **Line 838:** we're not awaiting this here, we want this request to happen in parallel with getUnpublishedPackages

### changesets-git.esm.js

- **Line 37:** it's important we use the -m flag to create annotated tag otherwise 'git push --follow-tags' won't actually push

### index.test.ts

- **Line 295:** a file:// URL is needed in order to make a shallow clone of

### changesets-write.esm.js

- **Line 82:** The quotation marks in here are really important even though they are

### emotion-cache.browser.development.esm.js

- **Line 474:** this very very intentionally targets all style elements regardless of the key to ensure

### constants.js

- **Line 48:** This enum is not currently used in any implemented API in this

### load-balancer-child-handler.js

- **Line 133:** state updates are only propagated from the child balancer if that

### metadata.js

- **Line 175:** Node <8.9 formats http2 headers incorrectly.

### server-interceptors.js

- **Line 486:** response compression is currently not supported, so this

### index.js

- **Line 24:** The bind call isn't strictly required. But we need it for our mocks to work as expected.

### conversion.module.js

- **Line 28:** Date.UTC() interprets one and two-digit years as being in the

### types.d.ts

- **Line 459:** that eras before 1868 (Gregorian) are not currently supported by this implementation.

### NumberParser.module.js

- **Line 196:** some locale's don't add a group symbol until there is a ten thousands place

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### extend-error.js

- **Line 54:** We specifically exclude properties that we have already set on the new error.

### ts-path.js

- **Line 261:** The order of these checks matter!

### Attributes.d.ts

- **Line 4:** only the own enumerable keys are counted as valid attribute keys.

### utils.js

- **Line 28:** we intentionally don't URI-encode the metadata - that responsibility falls on the metadata implementation

### environment.js

- **Line 64:** falling back to `false` instead of `undefined` as required by the specification.

### otlp-grpc-env-configuration.js

- **Line 138:** the spec does not make any exception for

### grpc-exporter-transport.d.ts

- **Line 12:** Ensure that you're only importing/requiring gRPC inside the function providing the channel credentials,
- **Line 21:** Ensure that you're only importing/requiring gRPC inside the function providing the metadata,

### ConsoleLogRecordExporter.js

- **Line 22:** This [@link LogRecordExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### util.js

- **Line 17:** other languages provide this as a built in function. This is

### ExponentialHistogram.js

- **Line 345:** this should be impossible. If we get here it's because

### types.d.ts

- **Line 25:** that we'll always have n+1 buckets, where n is the number of boundaries.

### ConsoleMetricExporter.d.ts

- **Line 13:** This [@link PushMetricExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### AsyncMetricStorage.d.ts

- **Line 27:** This is a stateful operation and may reset any interval-related

### ConsoleSpanExporter.d.ts

- **Line 8:** This [@link SpanExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### SimpleSpanProcessor.d.ts

- **Line 12:** This [@link SpanProcessor] exports every ended span individually instead of batching spans together, which causes significant performance overhead with most exporters. For production use, please consider using the [@link BatchSpanProcessor] instead.

### experimental_metrics.js

- **Line 1654:** that the total slab memory is not constant and may vary over time.

### SemanticResourceAttributes.d.ts

- **Line 22:** Availability zones are called &#34;zones&#34; on Alibaba Cloud and Google Cloud.
- **Line 30:** The prefix of the service SHOULD match the one specified in `cloud.provider`.
- **Line 80:** Multiple log groups must be supported for cases like multi-container applications, where a single application has sidecar containers, and each write to their own log group.
- **Line 88:** See the [log group ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format).
- **Line 102:** See the [log stream ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format). One log group can contain several log streams, so these ARNs necessarily identify both a log group and a log stream.
- **Line 146:** The device identifier MUST only be defined using the values outlined below. This value is not an advertising identifier and MUST NOT be used as such. On iOS (Swift or Objective-C), this value MUST be equal to the [vendor identifier](https://developer.apple.com/documentation/uikit/uidevice/1620059-identifierforvendor). On Android (Java or Kotlin), this value MUST be equal to the Firebase Installation ID or a globally unique UUID which is persisted across sessions in your application. More information can be found [here](https://developer.android.com/training/articles/user-data-ids) on best practices and exact implementation details. Caution should be taken when storing personal data or anything which can identify a user. GDPR and data protection laws may apply, ensure you do your own due diligence.
- **Line 154:** It&#39;s recommended this value represents a machine readable version of the model identifier rather than the market or consumer-friendly name of the device.
- **Line 162:** It&#39;s recommended this value represents a human readable version of the device model rather than a machine readable alternative.
- **Line 170:** This is the name of the function as configured/deployed on the FaaS platform and is usually different from the name of the callback function (which may be stored in the [`code.namespace`/`code.function`](../../trace/semantic_conventions/span-general.md#source-code-attributes) span attributes).
- **Line 178:** Depending on the cloud provider, use:
- **Line 199:** Depending on the cloud provider and platform, use:
- **Line 215:** * **AWS Lambda:** Use the (full) log stream name.
- **Line 223:** It&#39;s recommended to set this attribute since e.g. too little memory can easily stop a Java AWS Lambda function from working correctly. On AWS Lambda, the environment variable `AWS_LAMBDA_FUNCTION_MEMORY_SIZE` provides this information.
- **Line 471:** MUST be the same for all instances of horizontally scaled services. If the value was not specified, SDKs MUST fallback to `unknown_service:` concatenated with [`process.executable.name`](process.md#process), e.g. `unknown_service:bash`. If `process.executable.name` is not available, the value MUST be set to `unknown_service`.
- **Line 479:** A string value having a meaning that helps to distinguish a group of services, for example the team name that owns a group of services. `service.name` is expected to be unique within the same namespace. If `service.namespace` is not specified in the Resource then `service.name` is expected to be unique for all services that have no explicit namespace defined (so the empty/unspecified namespace is simply one more valid namespace). Zero-length namespace string is assumed equal to unspecified namespace.
- **Line 487:** MUST be unique for each instance of the same `service.namespace,service.name` pair (in other words `service.namespace,service.name,service.instance.id` triplet MUST be globally unique). The ID helps to distinguish instances of the same service that exist at the same time (e.g. instances of a horizontally scaled service). It is preferable for the ID to be persistent and stay the same for the lifetime of the service instance, however it is acceptable that the ID is ephemeral and changes during important lifetime events for the service (e.g. service restarts). If the service has no inherent unique ID that can be used as the value of this attribute it is recommended to generate a random Version 1 or Version 4 RFC 4122 UUID (services aiming for reproducible UUIDs may also use Version 5, see RFC 4122 for more recommendations).

### SemanticAttributes.js

- **Line 156:** This may be different from `faas.id` if an alias is involved.
- **Line 188:** In some SQL databases, the database name to be used is called &#34;schema name&#34;.
- **Line 196:** The value may be sanitized to exclude sensitive information.
- **Line 204:** When setting this to an SQL keyword, it is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if the operation name is provided by the library being instrumented. If the SQL statement has an ambiguous operation, or performs more than one operation, this value may be omitted.
- **Line 212:** If setting a `db.mssql.instance_name`, `net.peer.port` is no longer required (but still recommended if non-standard).
- **Line 238:** This mirrors the db.sql.table attribute but references cassandra rather than sql. It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 288:** It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 314:** An exception is considered to have escaped (or left) the scope of a span,
- **Line 391:** SHOULD be equal to the `faas.name` resource attribute of the invoked function.
- **Line 399:** SHOULD be equal to the `cloud.provider` resource attribute of the invoked function.
- **Line 407:** SHOULD be equal to the `cloud.region` resource attribute of the invoked function.
- **Line 559:** `http.url` MUST NOT contain credentials passed via URL in form of `https://username:password@www.example.com/`. In such case the attribute&#39;s value should be `https://www.example.com/`.
- **Line 573:** When the header is present but empty the attribute SHOULD be set to the empty string. Note that this is a valid situation that is expected in certain cases, according the aforementioned [section of RFC 7230](https://tools.ietf.org/html/rfc7230#section-5.4). When the header is not set the attribute MUST NOT be set.
- **Line 593:** If `net.transport` is not specified, it can be assumed to be `IP.TCP` except if `http.flavor` is `QUIC`, in which case `IP.UDP` is assumed.
- **Line 631:** `http.url` is usually not readily available on the server side but would have to be assembled in a cumbersome and sometimes lossy process from other information (see e.g. open-telemetry/opentelemetry-python/pull/148). It is thus preferred to supply the raw data that is available.
- **Line 645:** This is not necessarily the same as `net.peer.ip`, which would
- **Line 879:** If the key type is not string, it&#39;s string representation has to be supplied for the attribute. If the key has no unambiguous, canonical string form, don&#39;t include its value.
- **Line 917:** This is the logical name of the service from the RPC interface perspective, which can be different from the name of any implementing class. The `code.namespace` attribute may be used to store the latter (despite the attribute name, it may include a class name; e.g., class with method actually executing the call on the server side, RPC client stub class on the client side).
- **Line 925:** This is the logical name of the method from the RPC interface perspective, which can be different from the name of any implementing method/function. The `code.function` attribute may be used to store the latter (e.g., method actually executing the call on the server side, RPC client stub method on the client side).
- **Line 969:** This way we guarantee that the values will be consistent between different implementations.

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### _call_super.js

- **Line 11:** This doesn't work if this.__proto__.constructor has been modified.

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 1022:** calling res.set() after res.append() will reset the previously-set header value.

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 105:** that [per RFC](https://httpwg.org/specs/rfc8246.html#the-immutable-cache-control-extension)

### index.d.ts

- **Line 461:** the property name that the schema is testing will always be a string.

### array.d.ts

- **Line 333:** This method mutates array.
- **Line 925:** Unlike _.without, this method mutates array.
- **Line 953:** ** Unlike `_.difference`, this method mutates `array`.
- **Line 991:** ** Unlike `_.differenceBy`, this method mutates `array`.
- **Line 1038:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 1084:** Unlike _.at, this method mutates array.
- **Line 1113:** Unlike _.filter, this method mutates array.
- **Line 1138:** ** This method mutates `array` and is based on

### collection.d.ts

- **Line 778:** As with other "Collections" methods, objects with a "length" property are iterated like arrays. To

### common.d.ts

- **Line 221:** key should be string, not keyof T, because the actual object may contain extra properties that were not specified in the type.
- **Line 279:** keys of objects at run time are always strings, even when a NumericDictionary is being iterated.

### function.d.ts

- **Line 86:** Unlike native Function#bind this method does not set the "length" property of bound functions.
- **Line 412:** If leading and trailing options are true, func is invoked on the trailing edge of the timeout only
- **Line 1303:** This method is based on the rest parameter.
- **Line 1328:** This method is based on the spread operator.
- **Line 1365:** If leading and trailing options are true, func is invoked on the trailing edge of the timeout only if

### lang.d.ts

- **Line 86:** This method is loosely based on the structured clone algorithm and supports cloning arrays,
- **Line 207:** This method is equivalent to _.conforms when source is partially applied.
- **Line 599:** ** This method supports comparing arrays, array buffers, booleans,
- **Line 708:** This method is based on Number.isFinite.
- **Line 754:** ** This method is based on [`Number.isInteger`](https://mdn.io/Number/isInteger).
- **Line 792:** ** This function is loosely based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
- **Line 853:** ** This method supports comparing the same values as `_.isEqual`.
- **Line 934:** This method is not the same as isNaN which returns true for undefined and other non-numeric values.
- **Line 1035:** To exclude Infinity, -Infinity, and NaN, which are classified as numbers, use the _.isFinite method.
- **Line 1120:** This method assumes objects created by the Object constructor have no inherited enumerable properties.
- **Line 1167:** ** This method is based on [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).
- **Line 1510:** ** This function is loosely based on [`ToInteger`](http://www.ecma-international.org/ecma-262/6.0/#sec-tointeger).
- **Line 1549:** ** This method is based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).

### object.d.ts

- **Line 10:** ** This method mutates `object` and is loosely based on
- **Line 477:** This method mutates object.
- **Line 1547:** Non-object values are coerced to objects. See the ES spec for more details.
- **Line 1570:** Non-object values are coerced to objects.

### string.d.ts

- **Line 98:** No other characters are escaped. To escape additional characters use a third-party library like he.
- **Line 296:** This method aligns with the ES5 implementation of parseInt.
- **Line 345:** This method is based on String#replace.
- **Line 402:** This method is based on String#split.
- **Line 494:** In the development build _.template utilizes
- **Line 697:** No other HTML entities are unescaped. To unescape additional HTML entities use a third-party library

### util.d.ts

- **Line 32:** This method does not set the "length" property of bound functions.
- **Line 490:** This method supports comparing arrays, booleans, Date objects, numbers, Object objects, regexes, and
- **Line 613:** Use _.runInContext to create a pristine lodash function to avoid conflicts caused by modifying

### dns.d.ts

- **Line 32:** This namespace provides design-time support for util.promisify. Exported members do not exist at runtime.

### index.d.ts

- **Line 40:** These definitions support NodeJS and TypeScript 3.7.

### net.d.ts

- **Line 38:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### readline.d.ts

- **Line 23:** According to the documentation:

### stream.d.ts

- **Line 225:** Duplex extends both Readable and Writable.

### tls.d.ts

- **Line 244:** Works only with client TLS sockets.
- **Line 256:** Can be used to request peer's certificate after the secure connection has been established.
- **Line 288:** The format of the output is identical to the output of `openssl s_client

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 718:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 1:** Users of the `experimental` builds of React should add a reference

### experimental.d.ts

- **Line 59:** that SuspenseList require more than one child;

### index.d.ts

- **Line 1405:** its presence prevents any of the deprecated lifecycle methods from being invoked
- **Line 1425:** the presence of this method prevents any of the deprecated
- **Line 1442:** the presence of [@link NewLifecycle.getSnapshotBeforeUpdate getSnapshotBeforeUpdate]
- **Line 1503:** You cannot call [@link Component.setState] here.
- **Line 1623:** String refs can be forwarded. We can't fix this bug without breaking a bunch of libraries now though.
- **Line 1855:** callbacks are _only_ allowed to return either void, or a destructor.
- **Line 1966:** without the ReducerState indirection, TypeScript would reduce S to be the most common
- **Line 1981:** that `useRef()` is useful for more than the `ref` attribute. It’s handy for keeping any mutable
- **Line 2040:** this does not accept strings, but this will have to be fixed by removing strings from type Ref<T>
- **Line 2075:** We don’t recommend adding debug values to every custom hook.

### index.d.ts

- **Line 31:** this check is done on the path itself without checking if the path actually exists on the disk.

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### eslint-recommended-raw.js

- **Line 2:** this file is isolated to be shared across legacy and flat configs.

### raw-plugin.js

- **Line 70:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### await-thenable.js

- **Line 97:** that this suggestion causes broken code for sync iterables

### consistent-type-exports.js

- **Line 172:** it is valid to export values as types. We will avoid reporting errors

### consistent-type-imports.js

- **Line 238:** - in TS 5.0 `experimentalDecorators` became the legacy option,

### member-ordering.js

- **Line 665:** Not all members have names

### naming-convention.js

- **Line 10:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 72:** that bigint cannot have + prefixed to it

### no-unnecessary-condition.js

- **Line 50:** that this differs from [@link isNullableType] in that it doesn't consider
- **Line 331:** It's also unnecessary if the types that don't overlap at all

### prefer-find.js

- **Line 219:** we're always looking for array member access to be "computed",

### prefer-nullish-coalescing.js

- **Line 528:** This does not imply that the nodes are runtime-equivalent.

### compareNodes.js

- **Line 192:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 33:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.d.ts

- **Line 10:** This is wrong

### getOperatorPrecedence.js

- **Line 15:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 27:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 40:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### createProjectService.js

- **Line 124:** The inferred projects API is not intended for source files when a tsconfig

### Referencer.js

- **Line 138:** Not referring variableScope. It is intended.
- **Line 313:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### FunctionScope.js

- **Line 11:** Arrow functions never have an arguments objects.

### GlobalScope.js

- **Line 11:** this is accessed in used in the legacy eslint-scope tests, so it can't be true private

### ESLintScopeVariable.js

- **Line 16:** that this isn't a typo - ESlint uses this spelling here

### isUnsafeAssignment.js

- **Line 44:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 470:** that this is neither up to date nor fully correct.

### convert.js

- **Line 1767:** - NewExpression cannot have an optional chain in it

### getScriptKind.js

- **Line 45:** - we only respect the user's jsx setting for unknown extensions

### node-utils.js

- **Line 591:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 54:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 127:** When used with [@link projectService], full project reloads may occur.
- **Line 142:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,
- **Line 153:** that [@link projectService] is now preferred.

### createParseSettings.js

- **Line 57:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 45:** - we initialize the global cache based on the first config we encounter.

### useProgramFromProjectService.js

- **Line 166:** triggers a full project reload when changes are detected

### LegacyESLint.d.ts

- **Line 23:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 64:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### index.d.ts

- **Line 94:** Setting this option to `false` (or a function that returns `false`)
- **Line 110:** If `initialFocus` is `false` (or a function that returns `false`),

### index.d.ts

- **Line 150:** ** this is only applicable for single selection

### index.d.ts

- **Line 21:** Must be a valid CSS color string, not a css variable.

### index.d.ts

- **Line 59:** ** This is ignored if `multiple` is `true`.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### jtd-schema.ts

- **Line 33:** see the end of
- **Line 80:** relies on the fact that tuples don't have an index at 0.5, but arrays

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### arrtree.js

- **Line 43:** the ones-complement will always be < 0

### index.js

- **Line 511:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### index.js

- **Line 179:** Change prototype *after* Buffer.from is defined to workaround Chrome bug:
- **Line 325:** cannot use `length < K_MAX_LENGTH` here because that fails when

### report.js

- **Line 282:** requires Node.js 13+

### index.d.ts

- **Line 132:** ** Running `updateInterfaceInfo()` will trigger `clear()` only on network interface removal.

### mbcs.js

- **Line 112:** This assumes that there are no 4-byte common chars.

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### index.js

- **Line 49:** this will only work on the server since it attempts to read the map file

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### main.d.ts

- **Line 691:** These declarations exist to avoid type errors when you omit "dom" from

### referencer.js

- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### request.js

- **Line 192:** remember that ranges are inclusive, so for example "Range: users=0-3"
- **Line 295:** X-Forwarded-Proto is normally only ever a
- **Line 413:** X-Forwarded-Host is normally only ever a

### double.d.ts

- **Line 16:** Excluding min=Number.NEGATIVE_INFINITY would result into having min set to -Number.MAX_VALUE.
- **Line 29:** Excluding max=Number.POSITIVE_INFINITY would result into having max set to Number.MAX_VALUE.
- **Line 49:** -infinity and +infinity, or NaN can stil be generated except if you rejected them via another constraint.

### float.d.ts

- **Line 16:** Excluding min=Number.NEGATIVE_INFINITY would result into having min set to -3.4028234663852886e+38.
- **Line 29:** Excluding max=Number.POSITIVE_INFINITY would result into having max set to 3.4028234663852886e+38.

### gen.d.ts

- **Line 17:** Prefer fc.array(fc.integer(), {maxLength: 10}) if you want to produce such array

### limitShrink.d.ts

- **Line 12:** Although limiting the shrinking capabilities can speed up your CI when failures occur, we do not recommend this approach.

### string.d.ts

- **Line 19:** ** Graphemes produced by this unit are designed to remain visually distinct when joined together.

### Parameters.d.ts

- **Line 61:** Relies on `Date.now()`.
- **Line 105:** Relies on `fc.stringify` to check the equality.

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### copy.js

- **Line 92:** that The initial srcStat.atime cannot be trusted

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### types.d.ts

- **Line 331:** ** Only Got options are merged! Custom user options should be defined via [`options.context`](#context).

### hoist-non-react-statics.js

- **Line 87:** its typeof might be other than 'symbol' or 'number' if it's a polyfill.

### index.js

- **Line 37:** This implementation does not understand partial responses (206).
- **Line 675:** that stale cache may be useful sometimes, see `evaluateRequest()`.

### client-request.js

- **Line 274:** that wrapping the raw stream in a Proxy instance won't improve the performance (already tested it).

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### extend-node.js

- **Line 3:** not polyfilled with safer-buffer on a purpose, as overrides Buffer
- **Line 12:** this does use older Buffer API on a purpose

### dbcs-codec.js

- **Line 284:** '>>> 0' keeps 32-bit num positive.

### utf32.js

- **Line 123:** codepoint is a signed int32 and can be negative.
- **Line 124:** We copied this block from below to help V8 optimize it (it works with array, not buffer).
- **Line 156:** codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.

### index.js

- **Line 135:** Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add

### streams.js

- **Line 5:** Due to 'stream' module being pretty large (~100Kb, significant in browser environments),

### hook.js

- **Line 87:** that the expected `line` isn't 100% valid ESM. It is derived

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.d.ts

- **Line 5:** Currently unimplemented
- **Line 144:** Required Jest version >=23

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### ky.d.ts

- **Line 119:** that response will be `undefined` in case `ky.stop` is returned.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### index.js

- **Line 1123:** ** This function only supports comparing values with tags of
- **Line 1780:** ** Non-object values are coerced to objects. See the

### index.js

- **Line 526:** ** The cache is exposed as the `cache` property on the memoized

### index.js

- **Line 1679:** ** This method is loosely based on
- **Line 1856:** ** Non-object values are coerced to objects.
- **Line 1889:** ** This method mutates `object`.

### _initCloneByTag.js

- **Line 32:** ** This function only supports cloning values with tags of

### _setData.js

- **Line 7:** ** If this function becomes hot, i.e. is invoked a lot in a short

### bindAll.js

- **Line 11:** ** This method doesn't set the "length" property of bound functions.

### conforms.js

- **Line 12:** ** The created function is equivalent to `_.conformsTo` with

### core.js

- **Line 1705:** ** This method is used instead of
- **Line 1919:** ** Unlike `_.remove`, this method returns a new array.
- **Line 2002:** ** As with other "Collections" methods, objects with a "length"
- **Line 2271:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 2405:** ** This method is loosely based on the
- **Line 2868:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 3413:** ** No other characters are escaped. To escape additional
- **Line 3515:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 3522:** ** Multiple values can be checked by combining several matchers
- **Line 3554:** ** Use `_.runInContext` to create a pristine `lodash` function to

### curryRight.js

- **Line 13:** ** This method doesn't set the "length" property of curried functions.

### debounce.js

- **Line 23:** ** If `leading` and `trailing` options are `true`, `func` is

### difference.js

- **Line 12:** ** Unlike `_.pullAll`, this method returns a new array.

### differenceBy.js

- **Line 15:** ** Unlike `_.pullAllBy`, this method returns a new array.

### every.js

- **Line 12:** ** This method returns `true` for

### fill.js

- **Line 8:** ** This method mutates `array`.

### isInteger.js

- **Line 6:** ** This method is based on

### lodash.js

- **Line 7059:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 11196:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 11867:** ** This method is equivalent to `_.matches` when `source` is
- **Line 11970:** ** This method can't reliably detect native functions in the presence
- **Line 14741:** ** In the development build `_.template` utilizes

### matchesProperty.js

- **Line 12:** ** Partial comparisons will match empty array and empty object

### omit.js

- **Line 19:** ** This method is considerably slower than `_.pick`.

### parseInt.js

- **Line 15:** ** This method aligns with the

### partial.js

- **Line 17:** ** This method doesn't set the "length" property of partially

### pull.js

- **Line 9:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`

### pullAt.js

- **Line 12:** ** Unlike `_.at`, this method mutates `array`.

### range.js

- **Line 9:** ** JavaScript follows the IEEE-754 standard for resolving

### remove.js

- **Line 9:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`

### rest.js

- **Line 12:** ** This method is based on the

### unescape.js

- **Line 13:** ** No other HTML entities are unescaped. To unescape additional

### without.js

- **Line 10:** ** Unlike `_.pull`, this method returns a new array.

### wrapperReverse.js

- **Line 9:** ** This method mutates the wrapped array.

### index.js

- **Line 174:** that we must ALWAYS check specially whether those values are MIN_VALUE
- **Line 424:** the compiler should inline these constant values below and then remove these variables, so there should be

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### index.js

- **Line 37:** We cannot override the `name` property, as that is `readOnly`

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### index.d.ts

- **Line 878:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 495:** that we might know *something* about it if there has been a previous
- **Line 640:** even on case-sensitive systems, it is **not** safe to test the
- **Line 856:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1678:** As of Node 19, this is very slow, compared to other methods of

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### protobuf.js

- **Line 1071:** that this uses `end`, not `pos`
- **Line 1553:** that the casts below are theoretically unnecessary as of today, but older statically

### protobuf.js

- **Line 2117:** that values inherit valuesById on their prototype which makes them a TypeScript-
- **Line 7484:** Extension fields aren't actual fields on the declaring type, but nested objects.

### index.js

- **Line 117:** Printing of WeakMap is hard to inspect and not very readable
- **Line 380:** that proxy-polyfill can't polyfill everything.

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### index.d.ts

- **Line 268:** that typing information for null values is lost

### index.js

- **Line 160:** we intentionally leave the stream paused,

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### Reflect.js

- **Line 1349:** not a real clear, just makes the previous data unreachable

### ReflectNoConflict.js

- **Line 720:** This is an approximation as we cannot check for [[Call]] internal method.
- **Line 726:** This is an approximation as we cannot check for [[Construct]] internal method.

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### AjaxResponse.d.ts

- **Line 23:** It is advised not to hold this in memory, as it will retain references to all of it's event handlers

### types.d.ts

- **Line 39:** this is only honored if the request is asynchronous (`async` is `true`).
- **Line 92:** that, by default, RxJS will add the following headers under certain conditions:
- **Line 141:** that the type of `"document"` (such as an XML document) is ignored if the global context is
- **Line 154:** This AJAX implementation relies on the built-in serialization and setting

### webSocket.d.ts

- **Line 68:** that both messages will be sent as returned by the functions, they are by default serialized using JSON.stringify, just
- **Line 108:** that at least one consumer has to subscribe to the created subject - otherwise "nexted" values will be just buffered and not sent,

### timer.d.ts

- **Line 97:** that this observable will never complete.

### concatAll.d.ts

- **Line 21:** `concatAll` is equivalent to `mergeAll` with concurrency parameter set

### connect.d.ts

- **Line 29:** that using a [@link takeUntil] inside of `connect`'s `selector` _might_ mean you were looking

### OperatorSubscriber.d.ts

- **Line 34:** This currently **ONLY** exists to support the strange behavior of [@link groupBy], where unsubscription

### refCount.d.ts

- **Line 12:** that using the [@link share] operator is exactly the same as using the `multicast(() => new Subject())` operator

### repeat.d.ts

- **Line 30:** that `repeat` will _not_ catch errors. Use [@link retry] for that.
- **Line 76:** that the second repeat cannot be called until the first

### timeInterval.d.ts

- **Line 28:** The values will never be this precise,

### asap.d.ts

- **Line 17:** that using `asap` scheduler does not necessarily mean that your task will be first to process

### Subscription.d.ts

- **Line 65:** THIS ASSUMES THAT [@link _hasParent] HAS ALREADY BEEN CHECKED.
- **Line 77:** that `Subscription` instances, when unsubscribed, will automatically remove themselves

### types.d.ts

- **Line 5:** This will add Symbol.observable globally for all TypeScript users,

### ajax.ts

- **Line 443:** that download load handling is a bit different below, because it has

### AnyCatcher.ts

- **Line 2:** that we cannot apply the `internal` tag here because the declaration

### bindCallback.ts

- **Line 56:** that the Observable created by the output function will always emit a single value

### bindNodeCallback.ts

- **Line 41:** that `func` will not be called at the same time output function is,
- **Line 58:** that `bindNodeCallback` can be used in non-Node.js environments as well.
- **Line 73:** that even if error parameter is technically present in callback, but its value

### concat.ts

- **Line 35:** that if some input Observable never completes, `concat` will also never complete

### fetch.ts

- **Line 151:** that any error that comes from our selector will be

### fromEvent.ts

- **Line 135:** that if event target calls registered function with more than one argument, second
- **Line 211:** optional configuration parameter which will be passed to addEventListener

### fromEventPattern.ts

- **Line 98:** that we return the token here...

### generate.ts

- **Line 350:** that folks not using TypeScript may trip over this.

### onErrorResumeNext.ts

- **Line 28:** that there is no way to handle any errors thrown by sources via the result of

### timer.ts

- **Line 149:** that this *could* be negative, in which case

### using.ts

- **Line 42:** Optional chaining did not work here.

### concatMap.ts

- **Line 41:** `concatMap` is equivalent to `mergeMap` with concurrency parameter set

### concatMapTo.ts

- **Line 38:** `concatMapTo` is equivalent to `mergeMapTo` with concurrency parameter

### endWith.ts

- **Line 20:** Passing a last argument of a Scheduler is _deprecated_, and may result in incorrect

### mergeInternals.ts

- **Line 110:** that this call will increment `active` ahead of the

### onErrorResumeNextWith.ts

- **Line 37:** that you do not get any access to errors emitted by the Observables. In particular do not

### publishBehavior.ts

- **Line 21:** that this has *never* supported the selector function.

### publishLast.ts

- **Line 71:** that this has *never* supported a selector function like `publish` and `publishReplay`.

### share.ts

- **Line 61:** that resetting on error or complete of the source Observable does not behave like a transparent retry or restart

### skipLast.ts

- **Line 55:** that it is the _same size_ as the skip count.

### timeout.ts

- **Line 308:** The default for `scheduler` will be the `scheduler` argument if it exists, or

### Subject.ts

- **Line 41:** This must be here to obscure Observable's constructor.

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### index.d.ts

- **Line 58:** commands supplied in this way support a restricted set of characters

### response.d.ts

- **Line 336:** ignored files will not be added to the `files` array, and will not be included in the

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### index.d.ts

- **Line 2716:** It is intentional that this is not a type guard.
- **Line 2887:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### index.d.ts

- **Line 1:** named reexports are used instead of `export *` because

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### get.d.ts

- **Line 150:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 11:** The return value has to be `any` and not `unknown` so it can match `void`.

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### uri.all.js

- **Line 1178:** We do not parse query strings for HTTP URIs

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### validator.js

- **Line 1837:** Permitted IBAN characters are: digits [0-9] and the 26 latin alphabetic [A-Z]

### parser.js

- **Line 53:** May modify input array

### types.d.ts

- **Line 88:** this is required if nodeClass is not provided.

### ZSchema-browser-test.js

- **Line 6540:** this doesn't actually make an http request.
- **Line 7585:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 7890:** that this may be asynchronous, or synchronous.  Yes, it is
- **Line 8911:** 0 is a valid value, means that we always return false if
- **Line 10639:** that any invalid chars are also handled, but these

### schemas.js

- **Line 784:** `Missing required key: "Key"`,

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### index.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

### apidog-integration.test.ts

- **Line 810:** This would require implementing retry logic in the actual implementation

### command-validation.test.ts

- **Line 187:** This test will depend on what parameters are actually required

### EnhancedBaseCommand.test.ts

- **Line 191:** execution time is set by handleResult, so we test the structure
- **Line 273:** JSON output goes to console.log, but we're testing structure
- **Line 401:** Arguments are stored differently in Commander.js

### TestLocalCommand.test.ts

- **Line 256:** Testing private methods via public interface is preferred

### api-endpoints.test.ts

- **Line 170:** This depends on API server availability and authentication

## OPTIMIZE Items (5)

### bundle.js

- **Line 101:** all $refs in the schema), and then crawls the resolved value.

### create-logger.js

- **Line 91:** the hot-path which is the single object.

### logger.js

- **Line 224:** for the hotpath of logging JSON literals

### ZSchema-browser-test.js

- **Line 2232:** the case of one listener. Don't need the extra array object.

### index.js

- **Line 91:** for Arrays. Big arrays could kill the performance otherwise!

## REVIEW Items (2)

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

### ZSchema-browser-test.js

- **Line 10760:** our test case against browsers more comprehensively.

## TODO Items (531)

### index.ts

- **Line 244:** Implement remote config loading (Consul, etcd, etc.)
- **Line 279:** Implement config validation against schema

### pipeline-healer.js

- **Line 14:** Replace with actual EnhancedLangChainAgent import and usage if available
- **Line 107:** Add function documentation

### lint.js

- **Line 3:** Implement docs linting functionality

### propagate.js

- **Line 3:** Implement docs propagation functionality

### index.js

- **Line 11:** Restore dynamic and legacy command registration after fixing dependencies

### init.js

- **Line 56:** Use loaded config defaults if options are not provided
- **Line 79:** Validate profile existence later
- **Line 91:** Validate site name format later
- **Line 104:** Use a dedicated ErrorCode (e.g., ErrorCodes.DESTINATION_NOT_EMPTY)
- **Line 107:** Add check to ensure destination directory is writable
- **Line 112:** Validate profile existence/format (Test Case: validate parameter values)
- **Line 113:** Validate siteName format (Test Case: validate parameter values)
- **Line 119:** Use environment from loaded config if not explicitly set via flag
- **Line 122:** Pass configManager to validateEnvironment
- **Line 127:** Use a dedicated ErrorCode (e.g., ErrorCodes.INVALID_ARGUMENT_VALUE)
- **Line 241:** Add options for runTests utility and throw accliError
- **Line 280:** Implement more sophisticated error handling and reporting via a dedicated error handling utility.
- **Line 286:** Perform cleanup on success if necessary (e.g., temporary files)
- **Line 302:** Consider moving this logic to a place where it's actually needed, perhaps cache it after installDependencies.
- **Line 313:** Fix the flow: determine packageManagerCmd after installDependencies and pass it to relevant methods.
- **Line 335:** Support SSH cloning based on configuration or detection.
- **Line 336:** More sophisticated check to verify if the existing repo is the *correct* profile repository.
- **Line 346:** Use a dedicated ErrorCode (e.g., ErrorCodes.DESTINATION_NOT_EMPTY_NOT_GIT)
- **Line 356:** More robust remote URL comparison (handle ssh vs https, .git suffix, etc.)
- **Line 362:** Use a dedicated ErrorCode (e.g., ErrorCodes.DESTINATION_INCORRECT_GIT_REMOTE)
- **Line 368:** Make branch configurable (e.g., 'main' or 'master')
- **Line 460:** Add configurable depth/branch
- **Line 514:** Add other common service configurations (e.g., health endpoints, timeouts) if needed in .env from service config\n        }\n        envContent += '\n'; // Add newline after service variables\n    }\n
- **Line 552:** Use configManager to determine if Docker is required\n    spinner.text = 'Checking if Docker is running...';\n    logger.info('Checking if Docker is running...');\n    try {\n      // isDockerRunning utility throws accliError if the check fails or Docker is not running\n      await isDockerRunning(logger); // Pass logger. This will throw if Docker isn't installed/running or check fails.\n      spinner.succeed('Docker is running.');\n      logger.info('Docker is running.');\n      spinner.start(); // Restart spinner\n    } catch (error) {\n      // Catch the accliError thrown by isDockerRunning (e.g., not installed, daemon down, permission error)\n      spinner.fail(`Docker is not running or not accessible: [error.message]`);\n      logger.error(`Docker is not running or not accessible`, { error });\n      // Re-throw the accliError to stop initialization if Docker is required\n      throw error; // Re-throw the accliError\n    }\n\n    // Setup required containers
- **Line 591:** Use configManager to determine if Docker is required
- **Line 703:** Add options for the install command if needed (e.g., --production)
- **Line 746:** Add try-catch around startDdev call in utility
- **Line 753:** Make fallback logic explicit here if not fully handled by installDrupal utility and throw accliError if fallback fails
- **Line 763:** Refine installDrupal utility to explicitly handle DDEV vs Drush based on ddevAvailable flag and throw accliError
- **Line 834:** Fix any type if possible
- **Line 937:** Conditionally add 'docker' if --with-docker is used and check/throw accliError
- **Line 938:** Conditionally add 'ddev' if it's the preferred Drupal setup method and check/throw accliError
- **Line 950:** Use a dedicated ErrorCode (e.g., ErrorCodes.MISSING_DEPENDENCY)
- **Line 973:** Implement more granular cleanup based on what was actually created/modified:
- **Line 1013:** Add config option to force stop all *known* services regardless of tracking?
- **Line 1023:** Stop/remove Docker containers ONLY if they were started by this command (needs tracking in state)
- **Line 1029:** Implement removeContainer utility similar to stopContainer\n                               // await removeContainer(containerName, logger); // Need removeContainer utility\n                               logger.warn('removeContainer utility not implemented yet. Skipping container removal.', [containerName]);\n                               spinner.warn(`Container removal for [containerName] skipped (utility not implemented).`);\n                           } else { // 'stop'\n                               await stopContainer(containerName, logger); // Call the utility to stop the container\n                               logger.info(`Container [containerName] stopped.`, { containerName });\n                           }\n                       } catch (containerCleanupError) {\n                            logger.warn(`Failed to [dockerCleanupConfig] container [containerName]: [containerCleanupError.message]`, { containerName, action: dockerCleanupConfig, error: containerCleanupError });\n                            // Continue attempting to cleanup other containers\n                       }\n                  }\n                   spinner.succeed(`Attempted to [dockerCleanupConfig] Docker containers.`); // Indicate attempt\n                   logger.info(`Attempted to [dockerCleanupConfig] Docker containers on failure.`);\n             }\n              spinner.start(); // Restart spinner\n         } else {\n            logger.debug('No Docker containers were tracked as started by this command.');\n         }\n\n        // Remove destination directory ONLY if it was created by this command AND installation failed.
- **Line 1037:** Double-check this only removes if created by THIS command, perhaps via a marker file or tracking in state
- **Line 1053:** Add success cleanup logic here if needed.
- **Line 1054:** Implement success cleanup logic (e.g., remove temp profile zip if downloaded, clean up git clone artifacts)

### impact.js

- **Line 135:** Implement consumer registry loading

### migrate.js

- **Line 202:** Implement endpoint migration logic
- **Line 206:** Implement schema migration logic
- **Line 210:** Implement parameter migration logic

### registry.js

- **Line 65:** Implement detailed diff analysis

### CommandFixer.js

- **Line 274:** Implement;command logic\n}'
- **Line 302:** Rename;command to include category (e.g., "category: name;")'
- **Line 319:** Fix;option names to use proper format (--option-name)'
- **Line 430:** Set;appropriate category'
- **Line 468:** Implement;or remove dependency on [dep]`

### CommandGenerator.js

- **Line 116:** Implement;command logic

### load.js

- **Line 82:** Replace oclif/core usage with Commander.js or plain argument parsing

### package-standards.js

- **Line 25:** expand to all packages if opts.all

### add-todos-service.js

- **Line 20:** [MCP] Pass model context and lineage to LLM adapter for richer docstrings.
- **Line 21:** [Drupal] Use Drupal entity metadata for context-aware documentation.
- **Line 26:** Documentfunction;Name\n`;
- **Line 27:** Addparameter;and return type documentation based on signature
- **Line 31:** Documentclass;Name\n`;
- **Line 35:** Documentinterface;Name\n`;
- **Line 43:** Documentexported;variable [varName]\n`;
- **Line 46:** Documentexported;variable\n';
- **Line 157:** [OpenAPI] Allow remote triggering of docstring/codegen via OpenAPI endpoint.
- **Line 158:** [Analytics] Log LLM usage and feedback for dashboard integration.
- **Line 202:** Add;function documentation */ function createAddTodosService() {

### api-service.js

- **Line 233:** Implement remote validation
- **Line 243:** Implement API specification fixing

### apikey-service.js

- **Line 17:** Implement interactive prompt for secure input
- **Line 33:** Implement Vault write operation
- **Line 38:** Implement writing to a .env file (e.g., at project root or user home)
- **Line 44:** Implement writing key=value pair to the file (ensure permissions are restricted)
- **Line 71:** Implement Vault read operation
- **Line 76:** Implement reading from a .env file
- **Line 84:** Implement reading key=value pair from the file
- **Line 124:** Implement Vault delete operation
- **Line 133:** Implement removing key=value pair from the file
- **Line 155:** Add function documentation */ function createApiKeyService() {

### build-manager.js

- **Line 2:** Implement;build logic;

### ci-service.js

- **Line 121:** Implement;CI configuration fixing;
- **Line 137:** Implement;GitLab API validation;
- **Line 162:** Implement;pipeline triggering;
- **Line 203:** Implement;pipeline status retrieval;
- **Line 229:** Implement;latest pipeline retrieval;
- **Line 242:** Implement;job status retrieval;
- **Line 255:** Implement;job logs retrieval;
- **Line 264:** Add;function documentation */ function createCiService() {

### deploy-service.js

- **Line 165:** Interactwith;GitLab API to update environment status/URL
- **Line 170:** Usekubectl;apply or Kubernetes client library
- **Line 174:** Add;function documentation */ function createDeployService() {

### deployment-manager.js

- **Line 2:** Implement;deployment validation logic

### dev-manager.js

- **Line 2:** Implement;dev server logic;

### docker-service.js

- **Line 93:** Implementvalidation;(e.g., lint Dockerfile, check layers, run trivy scan)
- **Line 127:** Add;function documentation */ function createDockerService() {

### docs-service.js

- **Line 62:** [MCP] Pass model context and lineage to LLM adapter for README/docstring generation.
- **Line 63:** [Drupal] Use Drupal entity metadata for context-aware README/docstrings.
- **Line 64:** [Analytics] Log prompt/response and docstring/README outcome for dashboard.
- **Line 282:** Implement link validation using a suitable library
- **Line 291:** Implement image validation
- **Line 300:** Implement code example validation (e.g., linting, type checking snippets)
- **Line 469:** [Drupal] Add Drupal entity metadata for context-aware documentation

### enhanced-langchain.js

- **Line 10:** Fix the import path for EnhancedLangChainAgent if the file exists

### gitlab-service.js

- **Line 22:** Implement GitLab API call to get project details
- **Line 26:** Implement GitLab API call to create MR
- **Line 30:** Implement GitLab API call to get MR details
- **Line 34:** Implement GitLab API call to approve MR
- **Line 38:** Implement GitLab API call to merge MR
- **Line 42:** Implement GitLab API call to list MRs (with filters)
- **Line 46:** Implement GitLab API call to get file content
- **Line 50:** Implement checks for branch protection, variables, etc.
- **Line 54:** Implement checks based on predefined templates or rules
- **Line 58:** Implement logic to apply standard configurations
- **Line 62:** Implement checks for required variables
- **Line 66:** Combine info from repo, MRs, pipelines
- **Line 70:** Combine various checks (structure, config, variables)

### inference-service.js

- **Line 74:** Implementlogic;to find and kill the server process(es)
- **Line 79:** Implementmodel;optimization/quantization steps (e.g., using AutoAWQ, AutoGPTQ)
- **Line 142:** Integratewith;deployment system (Kubernetes, etc.) to manage exposed endpoints

### init-manager.js

- **Line 2:** Implement;project initialization logic;

### lint-service.js

- **Line 112:** Add;function documentation */ function createLintService() {

### model-service.js

- **Line 20:** ImplementGitLab;Model Registry API call to create a model
- **Line 24:** ImplementGitLab;Model Registry API call to list models
- **Line 28:** ImplementGitLab;Model Registry API call to get model details
- **Line 35:** ImplementGitLab;Model Registry API calls:
- **Line 45:** ImplementGitLab;Model Registry API calls to download model artifacts
- **Line 49:** Implement API calls to get/update model version metadata using GitLab API
- **Line 53:** Implement logic to manage model input/output schemas using GitLab artifacts

### npm-package-service.js

- **Line 213:** Implement glob pattern matching for workspace packages

### obs-service.js

- **Line 12:** Implementlogic;to fetch logs from the configured backend
- **Line 18:** Implementlogic;to fetch traces from the configured backend
- **Line 23:** Implementlogic;to query metrics from the configured backend
- **Line 28:** Implementlogic;to fetch performance metrics (SLOs, latency percentiles)
- **Line 33:** Implementlog;streaming (e.g., kubectl logs -f or API streaming)
- **Line 37:** Implementlogic;to open Grafana/Jaeger/Langfuse UI in browser (requires platform knowledge)
- **Line 43:** Add;function documentation */ function createObsService() {

### openapi-service.js

- **Line 16:** Implementgeneration;logic if spec is built from code annotations (e.g., using NestJS/Swagger or TSOA)

### project-manager.js

- **Line 2:** Implement;project addition logic;

### project-service.js

- **Line 224:** Implement component addition
- **Line 243:** Implement project setup
- **Line 259:** Implement dependency installation

### rules-service.js

- **Line 25:** Implement;validation using ajv or similar
- **Line 39:** Implement;validation specific to the custom engine
- **Line 65:** Implement;testing: Load;schema, load rules, load input, validate input against schema/rules
- **Line 78:** Implement;testing specific to the custom engine
- **Line 90:** Implement;logic to interact with a rules repository or deployment mechanism
- **Line 94:** Add;function documentation */ function createRulesService() {

### system-service.js

- **Line 127:** Add fix suggestions if options.fix is true
- **Line 139:** Combinediagnostics with project-specific validations (e.g., llmcli project validate for all projects)
- **Line 143:** Implement automated fixes for common issues (e.g., installing missing deps)
- **Line 147:** Add function documentation */ function createSystemService() {

### typescript-service.js

- **Line 80:** Optionally update existing tsconfig based on options?
- **Line 150:** Add function documentation */ function createTypeScriptService() {

### ui-service.js

- **Line 43:** Add;port configuration if possible via script args?
- **Line 58:** Add;output path configuration?
- **Line 74:** Implement;component generation (e.g., copy template files)
- **Line 78:** Implement;template generation

### loaders.js

- **Line 216:** Implement etcd loader
- **Line 226:** Implement AWS Parameter Store loader
- **Line 237:** Handle certificate authentication
- **Line 240:** Handle IAM authentication
- **Line 334:** Validate merged config

### config.js

- **Line 4:** Refactor config module. Comment out or remove import/export if './config.ts' does not exist or is not a default export.

### drupal.js

- **Line 135:** Implement template replacement logic based on drupalOptions
- **Line 201:** Implement more robust templating if needed, e.g., replacing {recipe}
- **Line 252:** Implement more robust templating if needed, e.g., replacing [modules]

### environment.js

- **Line 102:** Consider validating tool versions if specified in config

### self-healing.js

- **Line 104:** [MCP] Pass model context and lineage to LLM adapter for healing suggestions.
- **Line 105:** [Drupal] Use Drupal context for targeted self-healing.
- **Line 106:** [Analytics] Log prompt/response and healing outcome for dashboard.
- **Line 500:** [Drupal] Add Drupal entity metadata for context-aware healing
- **Line 504:** [MCP] Add model context and lineage
- **Line 524:** [Analytics] Send to analytics dashboard

### services.js

- **Line 87:** Implement a proper log capturing/streaming mechanism
- **Line 96:** Look for specific readiness patterns in logs if health check is not sufficient or available
- **Line 107:** Implement logic to alert or handle unexpected service shutdowns
- **Line 240:** Fix type for timeout if needed

### testing.d.ts

- **Line 45:** Use proper ConfigManager type

### testing.js

- **Line 20:** Use proper Logger type
- **Line 128:** Refine parseNodejsTestResults to handle potential combined output from root test runner

### APIChangeDashboard.js

- **Line 16:** Replace with actual API call

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### core-js-compat.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### changesets-assemble-release-plan.esm.js

- **Line 466:** remove `refined*` in the next major version of this package

### changesets-cli.cjs.js

- **Line 263:** Make this wording better
- **Line 264:** take objects and be fancy with matching

### changesets-config.esm.js

- **Line 102:** it might be possible to remove this if improvements to `Array.isArray` ever land
- **Line 312:** consider enabling this by default in the next major version

### changesets-pre.cjs.js

- **Line 83:** verify that the pre state isn't broken

### emotion-cache.browser.development.esm.js

- **Line 181:** consider changing this comment placement in the next major version

### index.ts

- **Line 133:** Other constants as well

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### promise-polyfill.js

- **Line 4:** Remove this class once Node 22 becomes the minimum supported version.

### theme.js

- **Line 12:** use figure

### index.js

- **Line 158:** What to do if no results are found? Should we display a message?

### CalendarDate.module.js

- **Line 224:** Is this a bad idea??

### queries.main.js

- **Line 126:** invalidate this somehow?
- **Line 192:** use Intl.Locale for this once browsers support the weekInfo property

### NumberFormatter.module.js

- **Line 55:** implement signDisplay for formatToParts

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### tracestate-impl.js

- **Line 37:** Benchmark the different approaches(map vs list) and
- **Line 79:** Consider to add warning log

### internal.js

- **Line 80:** this is duplicated in basic tracer. Consolidate on a common helper in core
- **Line 113:** SDK types don't provide resource schema URL at this time

### ResourceImpl.js

- **Line 36:** Consider to add check/validation on attributes.

### MetricReader.js

- **Line 25:** use BindOncePromise here once a new version of @opentelemetry/core is available.

### DeltaMetricProcessor.js

- **Line 28:** find a reasonable mean to clean the memo;

### MeterSelector.js

- **Line 30:** semver filter? no spec yet.

### index.js

- **Line 20:** Replace wildcard export with named exports before next major version

### sdk.js

- **Line 274:** This is a workaround to fix https://github.com/open-telemetry/opentelemetry-js/issues/3609

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### index.d.ts

- **Line 105:** handling for regex parameters
- **Line 109:** Remove old `?` handling when Express 5 is promoted to "latest"

### object.d.ts

- **Line 1901:** Probably should just put all these methods on Object and forget about it.

### async_hooks.d.ts

- **Line 207:** Apply generic vararg once available

### cluster.d.ts

- **Line 99:** cluster.schedulingPolicy

### events.d.ts

- **Line 35:** These should be described using static getter/setter pairs:

### globals.d.ts

- **Line 194:** change to `type NodeRequireFunction = (id: string) => any;` in next mayor version.

### repl.d.ts

- **Line 364:** unique symbol

### wasi.d.ts

- **Line 46:** avoid DOM dependency until WASM moved to own lib.
- **Line 53:** Narrow to DOM types

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 775:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### worker_threads.d.ts

- **Line 100:** remove in a future major @types/node version.

### index.d.ts

- **Line 57:** Upstream to microsoft/TypeScript-DOM-lib-generator -> w3c/webref
- **Line 80:** These should only be allowed with `as: 'image'` but it's not trivial to write tests against the full TS support matrix.

### index.d.ts

- **Line 3780:** Move to react-dom

### index.d.ts

- **Line 4324:** Check impact of making React.ElementType<P = any> = React.JSXElementConstructor<P>

### index.d.ts

- **Line 202:** Remove the string ref special case from `PropsWithRef` once we remove LegacyRef
- **Line 522:** generalize this to everything in `keyof ReactHTML`, not just "input"
- **Line 1970:** double-check if this weird overload logic is necessary. It is possible it's either a bug
- **Line 2178:** change any to unknown when moving to TS v3
- **Line 4462:** It is SVGAnimateElement but is not in TypeScript's lib.dom.d.ts for now.
- **Line 4464:** It is SVGAnimateTransformElement but is not in TypeScript's lib.dom.d.ts for now.

### eslint-recommended-raw.js

- **Line 24:** - remove this once we no longer support ESLint v8

### no-floating-promises.js

- **Line 110:** #5439

### no-inferrable-types.js

- **Line 128:** - if we add more references

### no-misused-promises.js

- **Line 481:** - Once we're able to use `checker.isTypeAssignableTo` (v8), we can check an index

### no-mixed-enums.js

- **Line 154:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 79:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 237:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 199:** - we could break down the spread and compare the array type against each argument
- **Line 238:** - handle generic iterable case

### no-unused-vars.js

- **Line 585:** ######

### prefer-nullish-coalescing.js

- **Line 364:** also account for = in the ternary clause

### analyzeChain.js

- **Line 208:** - we could further reduce the false-positive rate of this check by
- **Line 428:** - #7170

### compareNodes.js

- **Line 145:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 650:** we have to compare to 0n if the type is bigint
- **Line 655:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 123:** Do we need to investigate the precedence here?
- **Line 156:** JSXElement?
- **Line 220:** Should prefix `++` and `--` be moved to the `Update` precedence?

### createProjectService.js

- **Line 40:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 43:** see getWatchProgramsForProjects

### getContextualType.js

- **Line 74:** - support return statement checking

### isUnsafeAssignment.js

- **Line 74:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 24:** - delete this in next major

### convert.js

- **Line 1788:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 66:** Support Windows CRLF

### getWatchProgramsForProjects.js

- **Line 208:** file issue on TypeScript to suggest making optional?

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 272:** rename to 'tokens'

### index.js

- **Line 143:** Revisit this

### index.js

- **Line 304:** Revise this

### index.js

- **Line 251:** Move this to `props` in next major version

### code.js

- **Line 124:** do not allow arrays here

### index.js

- **Line 34:** refactor - remove compilations
- **Line 38:** if getFullPath removed 1 tests fails
- **Line 58:** can its length be used as dataLevel if nil is removed?
- **Line 135:** maybe localRefs should hold SchemaEnv
- **Line 162:** returns AnySchemaObject (if the schema can be inlined) or validation function
- **Line 178:** `Object.keys(root.schema).length > 0` should not be needed - but removing breaks 2 tests
- **Line 223:** PREVENT_SCOPE_CHANGE could be defined in keyword def?

### parse.js

- **Line 270:** loopEnum

### resolve.js

- **Line 7:** refactor to use keyword definitions

### util.js

- **Line 6:** refactor to use Set
- **Line 164:** maybe use global escapePointer

### boolSchema.js

- **Line 37:** maybe some other interface should be used for non-keyword validation errors...

### dataType.js

- **Line 126:** use gen.property

### index.js

- **Line 76:** maybe some hook to execute it in the end to check whether props/items are Name, as in assignEvaluated
- **Line 165:** assign unevaluated
- **Line 185:** typecast
- **Line 210:** make it "ok" call?
- **Line 427:** value.code for standalone

### keyword.js

- **Line 93:** add tests

### subschema.js

- **Line 56:** something is possibly wrong here with not changing parentDataProperty and not appending dataPathArr

### core.js

- **Line 374:** return type should be Ajv
- **Line 455:** atm it is allowed to overwrite schemas without id (instead of not adding them)
- **Line 501:** tests fail without this line

### additionalItems.js

- **Line 35:** var

### dependencies.js

- **Line 15:** change to reference

### oneOf.js

- **Line 26:** possibly fail straight away (with warning or exception) if there are two empty always valid schemas

### ref.js

- **Line 71:** will not work with async, it has to be returned with the result
- **Line 87:** tagged
- **Line 95:** refactor

### dynamicRef.js

- **Line 26:** the assumption here is that `recursiveRef: #` always points to the root

### format.js

- **Line 31:** simplify

### properties.js

- **Line 130:** maybe an option instead of hard-coded 8?

### pattern.js

- **Line 17:** regexp should be wrapped in try/catchs

### index.ts

- **Line 78:** possibly, it should be readonly

### subschema.ts

- **Line 8:** use Optional? align with SchemCxt property types

### core.ts

- **Line 394:** allow passing schema URI

### jtd-schema.ts

- **Line 138:** we can't actually check that everything in the union was specified
- **Line 187:** currently allows descriminator to be present in schema
- **Line 205:** these should only be allowed at the top level

### dependencies.ts

- **Line 19:** change to string[]

### formatter.js

- **Line 10:** add [additonal formatters][1]

### constants.js

- **Line 16:** Fetch the real limit from the filesystem //TODO: Fetch the whole-path length limit too
- **Line 17:** Fetch the real limit from the filesystem

### scheduler.js

- **Line 5:** Maybe publish this as a standalone package

### built-in-definitions.js

- **Line 337:** We should introduce overloaded instance methods definition
- **Line 360:** add async iterator dependencies when we support sub-dependencies

### json.js

- **Line 62:** maybe make this configurable or part of "strict" option

### check-coverage.js

- **Line 14:** this is a workaround until yargs gets upgraded to v17, see https://github.com/bcoe/c8/pull/332#discussion_r721636191

### parse-args.js

- **Line 176:** enable once yargs upgraded to v17: https://github.com/bcoe/c8/pull/332#discussion_r721636191

### report.js

- **Line 15:** switch back to @c88/v8-coverage once patch is landed.

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### iso2022.js

- **Line 35:** refactor me

### mbcs.js

- **Line 90:** Do we really need this?
- **Line 201:** This set of data comes from the character frequency-

### sbcs.js

- **Line 69:** 0x20 might not be a space in all character sets...
- **Line 79:** Is this OK? The buffer could have ended in the middle of a word...
- **Line 84:** - This is a bit of a hack to take care of a case

### unicode.js

- **Line 20:** Do some statistics to check for unsigned UTF-16BE
- **Line 41:** Do some statistics to check for unsigned UTF-16LE

### lexer.js

- **Line 196:** <!-- XML comment support

### cell.js

- **Line 169:** cells should always exist - some tests don't fill it in though

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### index.js

- **Line 13:** Remove this when targeting Node.js 12.

### index.d.ts

- **Line 78:** Allow providing value type after https://github.com/Microsoft/TypeScript/issues/5413 is resolved.
- **Line 103:** Remove this for the next major release.

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 287:** Backslashes with no effect should not be escaped

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### Value.d.ts

- **Line 28:** - Do we want to clone it too?

### uri-js.test.js

- **Line 734:** Verify this

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### win32.js

- **Line 13:** expand to include the rest

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### index.js

- **Line 15:** Remove the `.reduce` call.

### index.js

- **Line 246:** Make it return a web stream at some point.

### index.js

- **Line 276:** Remove this when targeting Node.js >= 12
- **Line 313:** Move this to `_destroy()`
- **Line 377:** Deprecate URL options in Got 12.
- **Line 560:** remove this when `cacheable-request` supports async request functions.
- **Line 804:** Fix decompress-response
- **Line 1001:** Remove `utils/url-to-options.ts` when `cacheable-request` is fixed
- **Line 1004:** Fix this ignore.
- **Line 1010:** Fix `cacheable-response`
- **Line 1332:** What happens if it's from cache? Then this[kRequest] won't be defined.
- **Line 1379:** Remove the next `if` when these get fixed:

### get-buffer.js

- **Line 3:** Update https://github.com/sindresorhus/get-stream

### create.js

- **Line 91:** Remove this in Got 12.
- **Line 158:** Remove this `@ts-expect-error` when upgrading to TypeScript 4.
- **Line 176:** Throw when result is not an instance of Response

### index.js

- **Line 78:** Set this to `true` when Got 12 gets released

### hoist-non-react-statics.js

- **Line 72:** We don't use AsyncMode or ConcurrentMode anymore. They were temporary

### index.js

- **Line 130:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### agent.js

- **Line 163:** decreasing `maxFreeSessions` should close some sessions
- **Line 370:** Maybe the streams should have a "Session timed out" error?
- **Line 500:** Close last recently used (or least used?) session

### dbcs-codec.js

- **Line 348:** What if we have no default? (resCode == undefined)
- **Line 472:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### extend-node.js

- **Line 169:** Set _charsWritten.

### register.js

- **Line 5:** should this be a Set?

### constants.js

- **Line 3:** increment this version if there are schema changes

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### merge.js

- **Line 35:** Make this strongly-typed (no `any`).

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### index.js

- **Line 108:** Enable semi-caching, both when the first interpolated value is `outdent`, and when it's not
- **Line 140:** is this necessary?

### index.d.ts

- **Line 30:** remove this in the next major version, refactor the whole definition to:

### index.js

- **Line 8:** remove this in the next major version

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### doc.js

- **Line 1246:** Remove this in v4

### index.d.ts

- **Line 155:** Promise?

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### protobuf.js

- **Line 3874:** Replace with embedded proto.

### test.js

- **Line 105:** Should we be stricter and perform validation?

### utils.js

- **Line 219:** RFC1738 format

### index.d.ts

- **Line 427:** Use the below instead when the following TS issues are fixed:

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### fromSubscribable.d.ts

- **Line 8:** Discuss ObservableInput supporting "Subscribable".

### errorContext.d.ts

- **Line 5:** Remove in v8

### Notification.ts

- **Line 8:** When this enum is removed, replace it with a type alias. See #4556.
- **Line 175:** consider removing this check. The only way to cause this would be to

### NotificationFactories.ts

- **Line 31:** This is only exported to support a crazy legacy test in `groupBy`.

### generate.ts

- **Line 346:** Remove this as we move away from deprecated signatures

### finalize.ts

- **Line 67:** This try/finally was only added for `useDeprecatedSynchronousErrorHandling`.

### scan.ts

- **Line 9:** link to a "redux pattern" section in the guide (location TBD)

### switchScan.ts

- **Line 5:** Generate a marble diagram for these docs.

### windowCount.ts

- **Line 100:** We need to figure out if this really makes sense. We're technically

### withLatestFrom.ts

- **Line 66:** At somepoint, we should investigate the performance implications here, and look

### AsyncAction.ts

- **Line 124:** Clean this up when we refactor schedulers mid-version-8 or so.

### throwUnobservableError.ts

- **Line 6:** We should create error codes that can be looked up, so this can be less verbose.

### range.js

- **Line 489:** build?

### index.js

- **Line 44:** Remove the use of `.reduce` here.

### index.js

- **Line 72:** Use `/\p[RGI_Emoji]/v` when targeting Node.js 20.

### constants.js

- **Line 5:** Fetch the real limit from the filesystem, somehow

### index.js

- **Line 1195:** handle type-only imports

### init.js

- **Line 5:** see what's the best path for this

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### typescript.js

- **Line 13781:** don't use slice
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### update-notifier.js

- **Line 43:** Remove deprecated options at some point far into the future

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### index.d.ts

- **Line 15:** remove this in the next major version, refactor definition to:

### logger.js

- **Line 49:** add class description.

### rejection-handler.js

- **Line 29:** add contructor description
- **Line 86:** add method description
- **Line 99:** (indexzero): how do we configure this?

### tail-file.js

- **Line 23:** add function description.

### file.js

- **Line 276:** Refactor me.
- **Line 518:** add method description.
- **Line 614:** What should we do with errors here?

### index.js

- **Line 11:** add property description.

### Document-9b4560a1.js

- **Line 18:** Set true in v2

### Schema-88e323a7.js

- **Line 393:** deprecate/remove class check
- **Line 484:** remove in v2

### addPairToJSMap.js

- **Line 12:** Should drop this special case for bare << handling

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 14:** Use private class fields when targeting Node.js 12.

### index.js

- **Line 56:** Node.js 18.

### ZSchema-browser-test.js

- **Line 7141:** this
- **Line 9056:** defer error events consistently everywhere, not just the cb

### ZSchema-browser.js

- **Line 12214:** make sure this is only for remote schemas, not local ones

### schemas.d.ts

- **Line 58:** unions?

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### test-stable.js

- **Line 260:** This is a known limitation of the current implementation.

### index.js

- **Line 23:** Use `??=` when targeting Node.js 16.

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### index.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### create-command.js

- **Line 193:** Implement command logic

### metrics-dashboard.js

- **Line 23:** SystemMonitor temporarily disabled due to build errors

### audit-status.test.ts

- **Line 12:** Parse output and assert keys (analyze, tdd, recipe, todos, fixmes, lint, npmOutdated, lastCommit)

### init.test.ts

- **Line 9:** Implement test

### TypeScriptFormatCommand.ts

- **Line 47:** implement CLI options if needed */ }

### lint-service.ts

- **Line 131:** Add;function documentation

### model-service.ts

- **Line 11:** ImportGitLab;API client (@gitbeaker/node)

### commands.test.ts

- **Line 89:** Implement tes

## XXX Items (17)

### browser.js

- **Line 209:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 280:** DO NOT USE. This is a temporary stub function.
- **Line 281:** It WILL be removed in the next major release.

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### ast.js

- **Line 483:** abstract out this map method

### test.js

- **Line 354:** 80');
- **Line 355:** 1337');
- **Line 362:** 443');
- **Line 370:** 70');
- **Line 374:** 21');

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### tdigest.js

- **Line 775:** because mean and mean_cumn give rise to the same sort order

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

