# Roadmap

_Generated on 2025-05-30_

Found 272 TODO items in the codebase.

## BUG Items (1)

### dns.d.ts

- **Line 113:** in the name resolution service used by the operating system.

## HACK Items (1)

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

## NOTE Items (149)

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 19:** the list doesn't contain prefix-only modules like `node:test`.

### net.d.ts

- **Line 48:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 492:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 459:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 1199:** ** When you enable mocking for a specific timer, its associated
- **Line 1202:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1247:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1269:** ** After each test completes, this function is called on
- **Line 1282:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1386:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1657:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 215:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 677:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### get.d.ts

- **Line 86:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### command.js

- **Line 539:** using closure to access lots of lexical scoped variables.

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### escape.d.ts

- **Line 24:** that the output will be character-set dependent.

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### render-a11y-string-spec.js

- **Line 356:** this also affect HTML and MathML output

### auto-render.js

- **Line 177:** optionsCopy is mutated by this method. If it is ever exposed in the

### render-a11y-string.js

- **Line 97:** since we're importing types here these files won't actually be
- **Line 384:** Not sure if this is a safe assumption

### katex.js

- **Line 141:** Couldn't use `T` as the output type due to facebook/flow#5022.
- **Line 3350:** the `width` property may be undefined if fontMetricsData.js wasn't
- **Line 4789:** unicode-math maps \u21e2 to their own function \rightdasharrow.
- **Line 5313:** that we are using a bold font, but font metrics for regular Fraktur.
- **Line 5600:** this function mutates the argument.
- **Line 6144:** reverse the order of the return type union will cause a flow error.
- **Line 7114:** that we actually return a domTree element with a `<math>` inside it so
- **Line 7144:** The span class is not typed to have <math> nodes as children, and
- **Line 7486:** that we are returning span.depth = 0.
- **Line 7610:** Unlike most `htmlBuilder`s, this one handles not only "accent", but
- **Line 7648:** that our skew metrics are just the kern between each character
- **Line 7660:** that we now throw away baseGroup, because the layers we
- **Line 9446:** 1000:1 ratio of viewBox to document em width.
- **Line 10784:** Currently, `cell` is the last item added into `row`.
- **Line 11629:** that we assume \nomallineskiplimit to be zero,
- **Line 12479:** Unlike most `htmlBuilder`s, this one handles not only "horizBrace", but
- **Line 12545:** long note           long note
- **Line 13464:** Unlike most `htmlBuilder`s, this one handles not only "op", but also
- **Line 13656:** calling defineFunction with a type that's already been defined only
- **Line 13788:** Unlike most `htmlBuilder`s, this one handles not only
- **Line 15630:** Do not use `if (namespace.get(...))` to detect whether a macro
- **Line 18045:** that base may be empty (i.e. null) at this point.
- **Line 19018:** This method is not currently recommended for public use.
- **Line 19070:** These methods are not currently recommended for public use.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### markdown-it.js

- **Line 1213:** this is equivalent to unicode case folding; unicode normalization
- **Line 3004:** autocomplete count can be negative if user specifies more columns than header,
- **Line 5314:** this will cause links to behave incorrectly in the following case,

### index.cjs.js

- **Line 298:** that any invalid chars are also handled, but these

### attention.js

- **Line 52:** performance of this is fine on an mb of normal markdown, but it’s
- **Line 227:** `move` only works inside lines! It’s not possible to move past other

### definition.js

- **Line 72:** we don’t need to reset the way `markdown-rs` does.
- **Line 108:** whitespace is optional.
- **Line 174:** we don’t care about uniqueness.

### label-end.js

- **Line 240:** `markdown-rs` also parses GFM footnotes here, which for us is in
- **Line 292:** `markdown-rs` does a bunch of stuff here.

### index.js

- **Line 1:** more types exported from `index.d.ts`.

### syntax.js

- **Line 172:** normally we’d truncate trailing punctuation from the link.
- **Line 248:** we *check*, so we can discard the `www.` we parsed.
- **Line 532:** that’s GH says a dot is needed, but it’s not true:

### index.js

- **Line 1:** types are exported from `dev/index.d.ts`.

### syntax.js

- **Line 180:** the implementation of `markdown-rs` is different, because it houses

### html.js

- **Line 75:** we don’t set `slurpAllLineEndings` anymore, in delimiter rows,

### syntax.js

- **Line 70:** markdown-rs uses `whitespace` instead of `linePrefix`
- **Line 150:** in `markdown-rs`, we need to reset, in `micromark-js` we don‘t.
- **Line 253:** in `markdown-rs`, we need to handle piercing here too.
- **Line 442:** in markdown-rs`, a reset is needed here.
- **Line 481:** in `markdown-rs` we need to manually take care of a prefix,
- **Line 603:** correct end is set later.

### index.js

- **Line 1:** types exported from `index.d.ts`.

### index.js

- **Line 180:** in `markdown-rs`, `\0` exists in codes, in `micromark-js` it

### index.js

- **Line 113:** blank lines can’t exist in content.

### index.js

- **Line 205:** that this does handle micromark specific markdown whitespace characters.

### types.js

- **Line 12:** when changing the next record, you must also change `TokenTypeMap`
- **Line 226:** does not include the line ending.

### index.d.ts

- **Line 1:** this file is authored manually, not generated from `index.js`.
- **Line 1199:** when changing the next interface, you likely also have to change
- **Line 1205:** these are compiled away.

### document.js

- **Line 78:** this field is called `_closeFlow` but it also closes containers.
- **Line 87:** this algorithm for moving events around is similar to the

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### index.js

- **Line 1:** more types exposed from `index.d.ts`.

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### wordcut.js

- **Line 3998:** ending in / means that we'll get a final ''
- **Line 6531:** These type checking functions intentionally don't use `instanceof`

### lunr.js

- **Line 1661:** Using Object.keys here as this.edges is very likely
- **Line 1710:** As with the #toString method, we are using
- **Line 1953:** that although this function takes a callback parameter it is _not_ an

## OPTIMIZE Items (2)

### wordcut.js

- **Line 1383:** the case of one listener. Don't need the extra array object.
- **Line 5755:** `isFunction` if appropriate. Work around some typeof bugs in old v8,

## REVIEW Items (1)

### index.cjs.js

- **Line 390:** our test case against browsers more comprehensively.

## TODO Items (109)

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### formatter.js

- **Line 10:** add [additonal formatters][1]

### normalize.js

- **Line 592:** Type this properly

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 94:** Add `EventEmitter` close

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### constants.js

- **Line 3:** increment this version if there are schema changes

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### index.js

- **Line 46:** remove this in the next major version

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### index.js

- **Line 246:** Make it return a web stream at some point.

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### sl.js

- **Line 111:** Should we keep the original `message`?

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### render-a11y-string-spec.js

- **Line 221:** this result is ambiguous, we need to fix this
- **Line 229:** drop the parenthesis as they're not normally read
- **Line 317:** drop the "space"
- **Line 318:** collate m, o, d... we should fix this inside of KaTeX since
- **Line 327:** add begin/end to track argument of operators
- **Line 355:** collate strings so that this is "lim, sup"
- **Line 458:** this sounds ambiguous as well... we should probably say "start square root"

### render-a11y-string.js

- **Line 170:** add entries for all accents
- **Line 433:** double check that this is a no-op
- **Line 606:** handle other fonts
- **Line 638:** create a map for these.
- **Line 639:** differentiate between a body with a single atom, e.g.
- **Line 757:** callout the start/end of specific fonts
- **Line 758:** map \BBb[N] to "the naturals" or something like that
- **Line 811:** track which style we're using, e.g. display, text, etc.

### katex.js

- **Line 267:** automatically generate documentation
- **Line 268:** check all properties on Settings exist
- **Line 269:** check the type of a property on Settings matches
- **Line 421:** validate options
- **Line 692:** add halfwidth Katakana and Romanji glyphs
- **Line 3822:** In TeX these units are relative to the quad of the current
- **Line 3864:** refactor `span` and `anchor` into common superclass when
- **Line 5123:** In LaTeX, \pounds can generate a different character in text and math
- **Line 5237:** Add bold script when it is supported by a KaTeX font.
- **Line 5397:** make argument order closer to makeSpan
- **Line 5398:** add a separate argument for math class (e.g. `mop`, `mbin`), which
- **Line 6338:** These code assumes that a node's math class is the first element
- **Line 7119:** Make a pass thru the MathML similar to buildHTML.traverseNonSpaceNodes
- **Line 10092:** Fix this violation of the `span` type and possibly rename
- **Line 10496:** The value type of _environments should be a type union of all
- **Line 10693:** provide helpful error when \cr is used outside array environment
- **Line 13088:** \hskip and \mskip should support plus and minus in lengths
- **Line 13503:** When font glyphs are available, delete this code.
- **Line 14632:** Refactor to avoid duplicating styleMap in multiple places (e.g.
- **Line 15114:** Left-aligned tags.
- **Line 15876:** Optional arguments: \newcommand[\macro][args][default][definition]
- **Line 15904:** Should properly expand arg, e.g., ignore {}s
- **Line 16144:** If used in text mode, should expand to \textellipsis.
- **Line 16233:** math mode should use \thinmuskip
- **Line 16239:** \> and math mode of \: should use \medmuskip = 4mu plus 2mu minus 4mu
- **Line 16245:** math mode should use \thickmuskip = 5mu plus 5mu
- **Line 16255:** math mode should use \medmuskip
- **Line 16258:** math mode should use \thickmuskip
- **Line 16286:** math mode should use \medmuskip = 4mu plus 2mu minus 4mu
- **Line 16298:** Doesn't normally work in math mode because \@ fails.  KaTeX doesn't
- **Line 16441:** Create variable sized versions of the last two items. I believe that
- **Line 16514:** defineMacro("\\varcoppa", "\\\mbox[\\coppa]");
- **Line 18546:** find an alternative way to denote the end

### markdown-it.js

- **Line 5317:** remove this workaround when CM standard will allow nested links

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### range.js

- **Line 489:** build?

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### wordcut.js

- **Line 4282:** make this comparison case-insensitive on windows?

### lunr.ja.js

- **Line 161:** japanese stemmer

## XXX Items (9)

### browser.js

- **Line 209:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 280:** DO NOT USE. This is a temporary stub function.
- **Line 281:** It WILL be removed in the next major release.

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

