# Roadmap

_Generated on 2025-05-30_

Found 1436 TODO items in the codebase.

## BUG Items (5)

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

### subchannel-call.js

- **Line 209:** reports indicate that Node synthesizes a NGHTTP2_CANCEL

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### _stream_readable.js

- **Line 996:** in node.  Should never happen.

## FIXME Items (17)

### run_tests.js

- **Line 113:** unique NaN-handling is inconsistent between TFJS and TFPY

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### node.js

- **Line 200:** Should probably have an option in net.Socket to create a
- **Line 208:** Hack to have stream not keep the event loop alive.

### haml.js

- **Line 20:** these comments should be allowed to span indented lines

### less.js

- **Line 490:** it does not include dot for numbers like .5em :(

### r.js

- **Line 50:** Support Unicode identifiers.

### hook.js

- **Line 11:** Typescript extensions are added temporarily until we find a better

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### profile.js

- **Line 201:** Work around to not clear everything other than what we're setting

### query.js

- **Line 92:** Workspace support in query does not work as expected so this does not

## HACK Items (14)

### node.js

- **Line 178:** to have stream not keep the event loop alive.

### capnproto.js

- **Line 45:** eating everything after the first title

### htmlbars.js

- **Line 337:** This lets handlebars do the auto-detection if it's been loaded (by

### qml.js

- **Line 213:** prevents detection of keywords after dots

### stan.js

- **Line 507:** in range constraints, lower must follow "<"
- **Line 512:** in range constraints, upper must follow either , or <

### typescript.js

- **Line 556:** prevents detection of keywords in some circumstances

### display.js

- **Line 319:** Check if the argument looks like a run-script banner. This can be

### index.js

- **Line 650:** this is an option set in tests to stop the local prefix from being set

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### runmain-hack.js

- **Line 3:** to avoid Module.runMain on node 18.6.0

### bin.js

- **Line 59:** technically, this function is not marked @internal so it's possible
- **Line 462:** workaround node regression

## NOTE Items (737)

### emergence-detection-example.ts

- **Line 130:** This will not actually connect in this example

### security-framework-usage.ts

- **Line 156:** The security middleware has already:
- **Line 168:** The security middleware will automatically sanitize this response

### inline-callSuper-helpers.js

- **Line 43:** This doesn't work if this.__proto__.constructor has been modified.

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### constants.js

- **Line 48:** This enum is not currently used in any implemented API in this

### load-balancer-child-handler.js

- **Line 133:** state updates are only propagated from the child balancer if that

### metadata.js

- **Line 175:** Node <8.9 formats http2 headers incorrectly.

### server-interceptors.js

- **Line 486:** response compression is currently not supported, so this

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### versioning.js

- **Line 256:** path.normalize will not work because

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### index.d.ts

- **Line 3:** marking anything protected or private in the exported

### index.d.ts

- **Line 93:** encoding is not actually read-only, and setEncoding(enc)

### index.js

- **Line 225:** flushing CAN potentially switch us into not-flowing mode

### read-entry.js

- **Line 44:** gnutar and bsdtar treat unrecognized types as 'File'

### strip-absolute-path.js

- **Line 5:** that windows will think that //x/y/z/a has a "root" of //x/y, and in

### unpack.js

- **Line 106:** that on windows, we always drop the entire cache whenever a

### _md.js

- **Line 99:** sha512 requires length to be 128bit integer, but length in JS will overflow before that
- **Line 106:** we do division by 4 later, which should be fused in single op with modulo by JIT

### blake1.js

- **Line 215:** we cannot re-use compress from blake2s, since there is additional xor over u256[SIGMA[e]]

### blake2.js

- **Line 20:** V is LE here

### eskdf.js

- **Line 57:** that length here also repeats two lines below

### hkdf.js

- **Line 17:** some libraries treat zero-length array as 'not provided';

### sha3-addons.js

- **Line 18:** it is safe to use bigints here, since they used only for length encoding (not actual data).
- **Line 46:** second modulo is necessary since we don't need to add padding if current element takes whole block

### sha3.js

- **Line 51:** all indices are x2 since we store state as u32 instead of u64 (bigints to slow in js)
- **Line 96:** we accept arguments in bytes instead of bits here.

### types.d.ts

- **Line 441:** With [pagination](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
- **Line 738:** that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
- **Line 778:** ** This endpoint is only available to organizations with access to the enhanced billing platform. For more information, see "[About the enhanced billing platform](https://docs.github.com/billing/using-the-new-billing-platform)."
- **Line 3091:** that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 3150:** ** To prevent leaking sensitive information, the `bypass_actors` property is only returned if the user
- **Line 5075:** ** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
- **Line 5645:** that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 8042:** If making a request on behalf of a GitHub App you must also have permissions to write the contents of the head repository.
- **Line 8480:** there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
- **Line 9057:** **
- **Line 9192:** ** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
- **Line 9981:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
- **Line 86398:** ** A parameter can override this parameter. See `members_allowed_repository_creation_type` in this table for details.
- **Line 86410:** ** This parameter is closing down and will be removed in the future. Its return value ignores internal repositories. Using this parameter overrides values set in `members_can_create_repositories`. See the parameter deprecation notice in the operation description for details.
- **Line 93781:** ** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
- **Line 100520:** ** Providing `conclusion` will automatically set the `status` parameter to `completed`. You cannot change a check run conclusion to `stale`, only GitHub can set this.
- **Line 105563:** ** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
- **Line 110565:** ** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a hypermedia resource. For more information, see "[Getting started with the REST API](https://docs.github.com/rest/using-the-rest-api/getting-started-with-the-rest-api#hypermedia)."
- **Line 112101:** ** Topic `names` will be saved as lowercase.
- **Line 114779:** ** Alternatively, you can pass a single email address or an `array` of emails addresses directly, but we recommend that you pass an object using the `emails` key.

### Attributes.d.ts

- **Line 4:** only the own enumerable keys are counted as valid attribute keys.

### experimental_metrics.js

- **Line 1127:** that the total slab memory is not constant and may vary over time.

### util.js

- **Line 17:** other languages provide this as a built in function. This is

### ExponentialHistogram.js

- **Line 384:** this should be impossible. If we get here it's because

### types.d.ts

- **Line 24:** that we'll always have n+1 buckets, where n is the number of boundaries.

### AsyncMetricStorage.d.ts

- **Line 26:** This is a stateful operation and may reset any interval-related

### SemanticResourceAttributes.d.ts

- **Line 17:** Availability zones are called &#34;zones&#34; on Alibaba Cloud and Google Cloud.
- **Line 23:** The prefix of the service SHOULD match the one specified in `cloud.provider`.
- **Line 57:** Multiple log groups must be supported for cases like multi-container applications, where a single application has sidecar containers, and each write to their own log group.
- **Line 63:** See the [log group ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format).
- **Line 73:** See the [log stream ARN format documentation](https://docs.aws.amazon.com/AmazonCloudWatch/latest/logs/iam-access-control-overview-cwl.html#CWL_ARN_Format). One log group can contain several log streams, so these ARNs necessarily identify both a log group and a log stream.
- **Line 103:** The device identifier MUST only be defined using the values outlined below. This value is not an advertising identifier and MUST NOT be used as such. On iOS (Swift or Objective-C), this value MUST be equal to the [vendor identifier](https://developer.apple.com/documentation/uikit/uidevice/1620059-identifierforvendor). On Android (Java or Kotlin), this value MUST be equal to the Firebase Installation ID or a globally unique UUID which is persisted across sessions in your application. More information can be found [here](https://developer.android.com/training/articles/user-data-ids) on best practices and exact implementation details. Caution should be taken when storing personal data or anything which can identify a user. GDPR and data protection laws may apply, ensure you do your own due diligence.
- **Line 109:** It&#39;s recommended this value represents a machine readable version of the model identifier rather than the market or consumer-friendly name of the device.
- **Line 115:** It&#39;s recommended this value represents a human readable version of the device model rather than a machine readable alternative.
- **Line 121:** This is the name of the function as configured/deployed on the FaaS platform and is usually different from the name of the callback function (which may be stored in the [`code.namespace`/`code.function`](../../trace/semantic_conventions/span-general.md#source-code-attributes) span attributes).
- **Line 127:** Depending on the cloud provider, use:
- **Line 146:** Depending on the cloud provider and platform, use:
- **Line 160:** * **AWS Lambda:** Use the (full) log stream name.
- **Line 166:** It&#39;s recommended to set this attribute since e.g. too little memory can easily stop a Java AWS Lambda function from working correctly. On AWS Lambda, the environment variable `AWS_LAMBDA_FUNCTION_MEMORY_SIZE` provides this information.
- **Line 332:** MUST be the same for all instances of horizontally scaled services. If the value was not specified, SDKs MUST fallback to `unknown_service:` concatenated with [`process.executable.name`](process.md#process), e.g. `unknown_service:bash`. If `process.executable.name` is not available, the value MUST be set to `unknown_service`.
- **Line 338:** A string value having a meaning that helps to distinguish a group of services, for example the team name that owns a group of services. `service.name` is expected to be unique within the same namespace. If `service.namespace` is not specified in the Resource then `service.name` is expected to be unique for all services that have no explicit namespace defined (so the empty/unspecified namespace is simply one more valid namespace). Zero-length namespace string is assumed equal to unspecified namespace.
- **Line 344:** MUST be unique for each instance of the same `service.namespace,service.name` pair (in other words `service.namespace,service.name,service.instance.id` triplet MUST be globally unique). The ID helps to distinguish instances of the same service that exist at the same time (e.g. instances of a horizontally scaled service). It is preferable for the ID to be persistent and stay the same for the lifetime of the service instance, however it is acceptable that the ID is ephemeral and changes during important lifetime events for the service (e.g. service restarts). If the service has no inherent unique ID that can be used as the value of this attribute it is recommended to generate a random Version 1 or Version 4 RFC 4122 UUID (services aiming for reproducible UUIDs may also use Version 5, see RFC 4122 for more recommendations).

### SemanticAttributes.js

- **Line 21:** This may be different from `faas.id` if an alias is involved.
- **Line 43:** In some SQL databases, the database name to be used is called &#34;schema name&#34;.
- **Line 49:** The value may be sanitized to exclude sensitive information.
- **Line 55:** When setting this to an SQL keyword, it is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if the operation name is provided by the library being instrumented. If the SQL statement has an ambiguous operation, or performs more than one operation, this value may be omitted.
- **Line 61:** If setting a `db.mssql.instance_name`, `net.peer.port` is no longer required (but still recommended if non-standard).
- **Line 79:** This mirrors the db.sql.table attribute but references cassandra rather than sql. It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 113:** It is not recommended to attempt any client-side parsing of `db.statement` just to get this property, but it should be set if it is provided by the library being instrumented. If the operation is acting upon an anonymous table, or more than one table, this value MUST NOT be set.
- **Line 131:** An exception is considered to have escaped (or left) the scope of a span,
- **Line 188:** SHOULD be equal to the `faas.name` resource attribute of the invoked function.
- **Line 194:** SHOULD be equal to the `cloud.provider` resource attribute of the invoked function.
- **Line 200:** SHOULD be equal to the `cloud.region` resource attribute of the invoked function.
- **Line 302:** `http.url` MUST NOT contain credentials passed via URL in form of `https://username:password@www.example.com/`. In such case the attribute&#39;s value should be `https://www.example.com/`.
- **Line 312:** When the header is present but empty the attribute SHOULD be set to the empty string. Note that this is a valid situation that is expected in certain cases, according the aforementioned [section of RFC 7230](https://tools.ietf.org/html/rfc7230#section-5.4). When the header is not set the attribute MUST NOT be set.
- **Line 326:** If `net.transport` is not specified, it can be assumed to be `IP.TCP` except if `http.flavor` is `QUIC`, in which case `IP.UDP` is assumed.
- **Line 352:** `http.url` is usually not readily available on the server side but would have to be assembled in a cumbersome and sometimes lossy process from other information (see e.g. open-telemetry/opentelemetry-python/pull/148). It is thus preferred to supply the raw data that is available.
- **Line 362:** This is not necessarily the same as `net.peer.ip`, which would
- **Line 522:** If the key type is not string, it&#39;s string representation has to be supplied for the attribute. If the key has no unambiguous, canonical string form, don&#39;t include its value.
- **Line 548:** This is the logical name of the service from the RPC interface perspective, which can be different from the name of any implementing class. The `code.namespace` attribute may be used to store the latter (despite the attribute name, it may include a class name; e.g., class with method actually executing the call on the server side, RPC client stub class on the client side).
- **Line 554:** This is the logical name of the method from the RPC interface perspective, which can be different from the name of any implementing method/function. The `code.function` attribute may be used to store the latter (e.g., method actually executing the call on the server side, RPC client stub method on the client side).
- **Line 584:** This way we guarantee that the values will be consistent between different implementations.

### ConsoleMetricExporter.d.ts

- **Line 13:** This [@link PushMetricExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### ConsoleSpanExporter.d.ts

- **Line 8:** This [@link SpanExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### SimpleSpanProcessor.d.ts

- **Line 12:** This [@link SpanProcessor] exports every ended span individually instead of batching spans together, which causes significant performance overhead with most exporters. For production use, please consider using the [@link BatchSpanProcessor] instead.

### bedrock-runtime.js

- **Line 188:** We approximate the token count since this value is not directly available in the body

### instrumentation.js

- **Line 45:** If the Pino logger is configured with `nestedKey`, then

### log-sending-utils.js

- **Line 126:** A PINO_CONFIG event was added to pino (2024-04-04) to send config

### utils.js

- **Line 28:** we intentionally don't URI-encode the metadata - that responsibility falls on the metadata implementation

### environment.js

- **Line 64:** falling back to `false` instead of `undefined` as required by the specification.

### utils.js

- **Line 22:** that both of those functions are sync

### SemanticAttributes.js

- **Line 28:** The `error.type` SHOULD be predictable and SHOULD have low cardinality.
- **Line 52:** HTTP request method value SHOULD be &#34;known&#34; to the instrumentation.
- **Line 75:** The resend count SHOULD be updated each time an HTTP request gets resent by the client, regardless of what was the cause of the resending (e.g. redirection, authorization failure, 503 Server Unavailable, network issues, or any other).
- **Line 89:** MUST NOT be populated when this is not supported by the HTTP server framework as the route attribute should have low-cardinality and the URI path can NOT substitute it.
- **Line 104:** The value SHOULD be normalized to lowercase.
- **Line 110:** `network.protocol.version` refers to the version of the protocol used and might be different from the protocol client&#39;s version. If the HTTP client has a version of `0.27.2`, but sends HTTP version `1.1`, this attribute should be set to `1.1`.
- **Line 116:** When observed from the client side, and when communicating through an intermediary, `server.address` SHOULD represent the server address behind any intermediaries, for example proxies, if it&#39;s available.
- **Line 122:** When observed from the client side, and when communicating through an intermediary, `server.port` SHOULD represent the server port behind any intermediaries, for example proxies, if it&#39;s available.
- **Line 128:** For network calls, URL usually has `scheme://host[:port][path][?query][#fragment]` format, where the fragment is not transmitted over HTTP, but if it is known, it SHOULD be included nevertheless.
- **Line 140:** Sensitive content provided in query string SHOULD be scrubbed when instrumentations can identify it.

### undici.js

- **Line 306:** server errors are considered valid responses and it's the lib consumer
- **Line 314:** in `undici@6.3.0` when request aborted the error type changes from

### otlp-grpc-env-configuration.js

- **Line 138:** the spec does not make any exception for

### grpc-exporter-transport.d.ts

- **Line 12:** Ensure that you're only importing/requiring gRPC inside the function providing the channel credentials,
- **Line 21:** Ensure that you're only importing/requiring gRPC inside the function providing the metadata,

### ConsoleLogRecordExporter.js

- **Line 22:** This [@link LogRecordExporter] is intended for diagnostics use only, output rendered to the console may change at any time.

### index.js

- **Line 21:** This function currently is returning false-positives

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### octokit.js

- **Line 21:** replace with import ... assert { type: 'json' } once supported

### verify.js

- **Line 130:** we cannot check if the installation has all required permissions, it's

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### SparseSegmentReduction_impl.js

- **Line 23:** that the current implementation assumes that segmentIds values are
- **Line 35:** that we do not initialize the output buffer with a default value, so

### Unique_impl.js

- **Line 32:** that this is not the final output shape. This will be the shape for an

### concat_packed_gpu.js

- **Line 46:** the >= comparison below may seem unnecessary given the check

### gpgpu_context.js

- **Line 501:** We can't do binary search because Chrome expects us to explicitly

### Cum_impl.js

- **Line 37:** although the algorithm is called sum, it works for any associtative

### webgl_util.d.ts

- **Line 66:** that for performance reasons we use binding a texture to a framebuffer

### engine_test.js

- **Line 558:** This describe is purposefully not a describeWithFlags so that we

### globals.js

- **Line 143:** Variables do *not* get cleaned up when inside a tidy(). If you want to
- **Line 260:** this disposes the current backend, if any, as well as any tensors

### gradients.js

- **Line 291:** `saved.x` which points to the `x` we saved earlier.

### indexed_db_test.js

- **Line 139:** The following two assertions work only because there is

### local_storage_test.js

- **Line 123:** The following two assertions work only because there is no

### types.d.ts

- **Line 190:** this interface is used internally in IOHandlers.  For the file format

### string_n_grams_test.js

- **Line 192:** that in this case, because the bigram 'e|f' was already generated,

### tf-core.fesm.js

- **Line 7499:** that JSON.stringify doesn't write out keys that have undefined

### tf-core.node.js

- **Line 1179:** that the identifier globalNameSpace is scoped to this module, but will
- **Line 6927:** that a JavaScript string can contain wide characters, therefore the
- **Line 8579:** this op is called tf.identity in python. Hence the kernel name used
- **Line 14551:** This operation assumes that 'sortedSequence' is sorted along the
- **Line 14648:** This operation assumes that 'lowerBound' is sorted along the
- **Line 16083:** that dense dimensions cannot be modified by the shape argument.
- **Line 19839:** This operation assumes that 'upperBound' is sorted along the
- **Line 20133:** that this function is completely stateless and does not keep track of
- **Line 20361:** that on CPU, if an out of bound index is found, an error is returned. On
- **Line 25540:** This code snippet won't run properly without the actual file input
- **Line 26554:** fromPixels can be lossy in some cases, same image may result in
- **Line 27464:** this only works because we guaranteed one ellipsis.

### util.js

- **Line 134:** We explicitly type out what T extends instead of any so that

### input_layer.d.ts

- **Line 18:** You should provide only inputShape or batchInputShape (not both).
- **Line 50:** You should provide only shape or batchShape (not both).

### exports_layers.d.ts

- **Line 449:** if the input to the layer has a rank greater than 2, then it is
- **Line 1288:** on specifying the initial state of RNNs
- **Line 1299:** on passing external constants to RNNs

### exports.js

- **Line 145:** `input` is only necessary when using `model`. When using

### convolutional.d.ts

- **Line 76:** This function does not exist in the Python Keras Backend. This function

### cached_multihead_attention.d.ts

- **Line 78:** that caching is useful only during inference and should not be used
- **Line 83:** that during generative decoding, `T` is usually 1 (you are

### multihead_attention.js

- **Line 419:** Applying scalar multiply at the smaller end of einsum improves

### recurrent.d.ts

- **Line 459:** For superior performance, TensorFlow.js always uses implementation

### recurrent.js

- **Line 321:** inputShape will be an Array of Shapes of initial states and
- **Line 511:** that the .build() method of subclasses **must** define
- **Line 863:** For superior performance, TensorFlow.js always uses

### wrappers.js

- **Line 176:** When creating `this.forwardLayer`, the original Layer object
- **Line 322:** with initial states symbolic calls and non-symbolic calls to

### models.d.ts

- **Line 27:** this example serializes and deserializes only the topology
- **Line 150:** this code snippet will not work without the HTML elements in the
- **Line 249:** that the untrained model is random at this point.
- **Line 346:** Unlike `evaluate()`, this method is asynchronous (`async`).
- **Line 369:** the "step" mode of predict() is currently not supported.

### tf-layers.js

- **Line 1897:** that all kernels in Keras are standardized on the
- **Line 3749:** If the reference count is greater than 0 after the decrement, the
- **Line 20363:** that these two expressions can be combined into the following:
- **Line 22521:** This has Eager vs Graph Implications.
- **Line 22770:** that this function operates on one model output at a time. For a model

### user_defined_metadata.js

- **Line 58:** typeof `null` is 'object', and `null` is valid in JSON.

### callbacks.d.ts

- **Line 69:** that writing logs too often slows down the training.

### tf.fesm.js

- **Line 64498:** that this is not a deep copy: the memory locations of the underlying
- **Line 68392:** TypeScript provides no async map iteration, and regular map iteration
- **Line 68512:** we store the indices in the range 0 <= index < 2*capacity.
- **Line 68629:** that this operation necessarily scrambles the original order.
- **Line 69082:** this prefetches Promises, but makes no guarantees about when those
- **Line 69230:** this batch just groups items into row-wise element arrays.
- **Line 69313:** too that the transform function is responsible for tidying
- **Line 69452:** too that the transform function is responsible for tidying any
- **Line 69996:** If this dataset is a function of global state (e.g. a random number
- **Line 70257:** this means that, given an array of two datasets that produce dict
- **Line 71274:** the behavior: " ab ".split(' ') === ['', 'ab', '']
- **Line 71448:** if end > this.uint8Array.byteLength, we just get a small last
- **Line 71477:** if end > this.file.size, we just get a small last chunk.
- **Line 71509:** this class first downloads the entire file into memory before providing
- **Line 71688:** If isLabel in columnConfigs is `true` for at least one column, the
- **Line 71768:** that repeated iterations over this `Dataset` may produce different
- **Line 71861:** this code snippet only works when the device has a webcam. It will
- **Line 71895:** this code snippet only works when the device has a microphone. It will

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### api-gateway.d.ts

- **Line 5:** that although non-string types will be accepted, they will be
- **Line 12:** that this doesn't have to be a context from a custom lambda outhorizer, AWS also has a cognito

### cdk-custom-resource.d.ts

- **Line 32:** this is not to be confused with traditional CloudFormation custom resources.
- **Line 67:** If the name-value pairs contain sensitive information, you should use the `NoEcho` field to mask the output of the custom resource. Otherwise, the values are visible through APIs that surface property values (such as `DescribeStackEvents`).

### cloudformation-custom-resource.d.ts

- **Line 23:** responses are *not* returned from the Lambda handler but rather they are sent to the event ResponseURL.

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 517:** remember that ranges are inclusive, so for example "Range: users=0-3"
- **Line 1066:** calling res.set() after res.append() will reset the previously-set header value.

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### index.d.ts

- **Line 71:** the value will still be escaped if used as an identifier (??) by

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 718:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 490:** that LOBs in objects will be represented as Lob instances and will not be String or Buffer, regardless of any fetchAsString,
- **Line 990:** This property can only be used in the node-oracledb Thick mode. See Enabling node-oracledb Thick Mode.
- **Line 1017:** if you connect to Oracle Database 18, the version will only be accurate if node-oracledb is also using Oracle Database 18 client libraries.
- **Line 1933:** only non-pooled connections can be privileged.
- **Line 2150:** batchErrors can affect autocommit mode.
- **Line 2167:** that some classes of error will always return via the executeMany() callback error object,
- **Line 2276:** it is an asynchronous method and requires a round-trip to the database.
- **Line 2946:** that if the metadata of a collection is changed externally, the cache can get out of sync. If this happens, the cache can be cleared by calling pool.reconfigure({sodaMetadataCache: false}). See pool.reconfigure().
- **Line 3055:** that enqueued Strings are returned as UTF-8 encoded Buffers.
- **Line 3609:** that a commit should be performed before attempting to create an index.
- **Line 3630:** SODA operations do not commit an open transaction the way that SQL always does for DDL statements.
- **Line 3636:** you should never use SQL DROP TABLE command on the database table underlying a collection. This will
- **Line 3696:** SodaDocuments returned from sodaCollection.insertOneAndGet() or from sodaOperation.replaceOneAndGet()
- **Line 4081:** settings from skip() and limit() non-terminals are ignored because they only apply to read operations.

### index.d.ts

- **Line 33:** this check is done on the path itself without checking if the path actually exists on the disk.

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### eslint-recommended-raw.js

- **Line 2:** this file is isolated to be shared across legacy and flat configs.

### await-thenable.js

- **Line 97:** that this suggestion causes broken code for sync iterables

### consistent-type-exports.js

- **Line 172:** it is valid to export values as types. We will avoid reporting errors

### consistent-type-imports.js

- **Line 238:** - in TS 5.0 `experimentalDecorators` became the legacy option,

### member-ordering.js

- **Line 665:** Not all members have names

### naming-convention.js

- **Line 10:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 72:** that bigint cannot have + prefixed to it

### no-unnecessary-condition.js

- **Line 50:** that this differs from [@link isNullableType] in that it doesn't consider
- **Line 331:** It's also unnecessary if the types that don't overlap at all

### prefer-find.js

- **Line 219:** we're always looking for array member access to be "computed",

### prefer-nullish-coalescing.js

- **Line 528:** This does not imply that the nodes are runtime-equivalent.

### compareNodes.js

- **Line 192:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 33:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.d.ts

- **Line 10:** This is wrong

### getOperatorPrecedence.js

- **Line 15:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 27:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 40:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 313:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### GlobalScope.js

- **Line 11:** this is accessed in used in the legacy eslint-scope tests, so it can't be true private

### ESLintScopeVariable.js

- **Line 16:** that this isn't a typo - ESlint uses this spelling here

### isUnsafeAssignment.js

- **Line 44:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 470:** that this is neither up to date nor fully correct.

### convert.js

- **Line 1767:** - NewExpression cannot have an optional chain in it

### createProjectService.js

- **Line 120:** The inferred projects API is not intended for source files when a tsconfig

### getScriptKind.js

- **Line 45:** - we only respect the user's jsx setting for unknown extensions

### node-utils.js

- **Line 591:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 55:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 128:** When used with [@link projectService], full project reloads may occur.
- **Line 143:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,
- **Line 154:** that [@link projectService] is now preferred.

### createParseSettings.js

- **Line 56:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 45:** - we initialize the global cache based on the first config we encounter.

### useProgramFromProjectService.js

- **Line 166:** triggers a full project reload when changes are detected

### version.js

- **Line 4:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### LegacyESLint.d.ts

- **Line 23:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 64:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### index.d.ts

- **Line 994:** If [@link GPUAutoLayoutMode#"auto"] is used the pipeline cannot share [@link GPUBindGroup]s
- **Line 1027:** Some implementations require knowledge of the primitive restart value to compile
- **Line 1137:** It is recommended to prefer clearing; see [@link GPULoadOp#"clear"] for details.
- **Line 1371:** Comparison samplers may use filtering, but the sampling results will be
- **Line 1377:** Most implementations support [@link GPUSamplerDescriptor#maxAnisotropy] values in range
- **Line 1417:** Supplying information in [@link GPUShaderModuleDescriptor#hints] does not have any
- **Line 1822:** Canvases which are not displayed to the screen may or may not benefit from using this
- **Line 1864:** Adapter info values are returned with a Promise to give user agents an
- **Line 1893:** This is a value that represents the type of adapter. For example, it may be a
- **Line 1901:** Because no formatting is applied to [@link GPUAdapterInfo#description] attempting to parse
- **Line 1991:** It is valid to destroy a buffer multiple times.
- **Line 1992:** Since no further operations can be enqueued using this buffer, implementations can
- **Line 2031:** The same [@link GPUTexture] object will be returned by every
- **Line 2149:** Timestamp query values are written in nanoseconds, but how the value is determined is
- **Line 2211:** The [@link GPUCompilationMessage#message] should follow the best practices for language
- **Line 2363:** It is valid to destroy a device multiple times.
- **Line 2441:** Use of this method is preferred whenever possible, as it prevents blocking the
- **Line 2536:** This message is generally intended for application developers to debug their
- **Line 2538:** User agents should not include potentially machine-parsable details in this message,
- **Line 2541:** The [@link GPUError#message] should follow the best practices for language and
- **Line 2878:** The state is cleared, not restored to the previous state.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### arrtree.js

- **Line 43:** the ones-complement will always be < 0

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### extend-node.js

- **Line 3:** not polyfilled with safer-buffer on a purpose, as overrides Buffer
- **Line 12:** this does use older Buffer API on a purpose

### index.js

- **Line 160:** we intentionally leave the stream paused,

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### index.js

- **Line 646:** for future: we could return early if we found an action handler in parseArgs, as none of following code needed?

### context.d.ts

- **Line 58:** groups.

### get-set-record.js

- **Line 30:** If size is undefined, then numSize will be NaN

### es.string.replace.js

- **Line 115:** This is equivalent to

### es.string.split.js

- **Line 108:** This cannot be properly polyfilled in engines that don't support

### util.js

- **Line 22:** These type checking functions intentionally don't use `instanceof`

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### _stream_readable.js

- **Line 120:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 411:** that this may be asynchronous, or synchronous.  Yes, it is

### _stream_writable.js

- **Line 119:** 0 is a valid value, means that we always return false if

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### main.d.ts

- **Line 691:** These declarations exist to avoid type errors when you omit "dom" from

### referencer.js

- **Line 178:** Not referring variableScope. It is intended.
- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 660:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### request.js

- **Line 316:** X-Forwarded-Proto is normally only ever a
- **Line 434:** X-Forwarded-Host is normally only ever a

### node.js

- **Line 171:** stream._type is used for test-module-load-list.js

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### multipart.js

- **Line 17:** we (currently) support both multipart/form-data and multipart/related
- **Line 39:** that it's a good practice (but it's up to you) to use the `this.options` instead

### copy.js

- **Line 92:** that The initial srcStat.atime cannot be trusted

### gaxios.js

- **Line 414:** once the minimum version reaches Node 16,

### stringify.js

- **Line 24:** Be careful editing this code!  It's been tuned for performance

### index.js

- **Line 140:** node.js converts all incoming headers to lower case.

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### logging-utils.d.ts

- **Line 89:** that this interface may change at any time, as we're reserving the

### logging-utils.js

- **Line 264:** Google does not explicitly endorse or recommend this package; it's just
- **Line 328:** that these cached functions will need to deal with changes in the backend.

### descriptor_pb.js

- **Line 11114:** that Uint8Array is not supported on all browsers.

### handlebars.amd.js

- **Line 451:** for 5.0: Change to "obj == null" in 5.0
- **Line 917:** Using env.VM references rather than local var references throughout this section to allow

### index.d.ts

- **Line 198:** for backward compatibility of this typing

### python.js

- **Line 297:** no leading \b because floats can start with a decimal point

### swift.js

- **Line 159:** Contextual keywords are reserved only in specific contexts.

### typescript.js

- **Line 421:** this might not work how you think.  We don't actually always

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### hook.js

- **Line 86:** that the expected `line` isn't 100% valid ESM. It is derived

### errors.js

- **Line 322:** extra classes have been shaken out.
- **Line 361:** no need to implement `kIsNodeError` symbol, would be hard,

### get-format.js

- **Line 125:** we don’t implement WASM, so we don’t need

### package-json-reader.js

- **Line 132:** in Node, this is now a native module.

### resolve.js

- **Line 136:** from Node 15 onwards we can use `throwIfNoEntry: false` instead.
- **Line 140:** in Node code this returns `new Stats`,
- **Line 1082:** The Node code supports `base` as a string (in this internal API) too,
- **Line 1106:** actual code uses `canBeRequiredWithoutScheme`.
- **Line 1175:** this is from:

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### _equalByTag.js

- **Line 34:** ** This function only supports comparing values with tags of

### _initCloneByTag.js

- **Line 32:** ** This function only supports cloning values with tags of

### _setData.js

- **Line 7:** ** If this function becomes hot, i.e. is invoked a lot in a short

### assignInWith.js

- **Line 11:** ** This method mutates `object`.

### bindAll.js

- **Line 11:** ** This method doesn't set the "length" property of bound functions.

### conforms.js

- **Line 12:** ** The created function is equivalent to `_.conformsTo` with

### core.js

- **Line 1705:** ** This method is used instead of
- **Line 1919:** ** Unlike `_.remove`, this method returns a new array.
- **Line 2002:** ** As with other "Collections" methods, objects with a "length"
- **Line 2271:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 2405:** ** This method is loosely based on the
- **Line 2723:** ** This method is loosely based on
- **Line 2868:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 3076:** ** This method mutates `object` and is loosely based on
- **Line 3413:** ** No other characters are escaped. To escape additional
- **Line 3515:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 3522:** ** Multiple values can be checked by combining several matchers
- **Line 3554:** ** Use `_.runInContext` to create a pristine `lodash` function to

### curryRight.js

- **Line 13:** ** This method doesn't set the "length" property of curried functions.

### debounce.js

- **Line 23:** ** If `leading` and `trailing` options are `true`, `func` is

### difference.js

- **Line 12:** ** Unlike `_.pullAll`, this method returns a new array.

### differenceBy.js

- **Line 15:** ** Unlike `_.pullAllBy`, this method returns a new array.

### every.js

- **Line 12:** ** This method returns `true` for

### fill.js

- **Line 8:** ** This method mutates `array`.

### isEqual.js

- **Line 7:** ** This method supports comparing arrays, array buffers, booleans,

### isInteger.js

- **Line 6:** ** This method is based on

### keys.js

- **Line 8:** ** Non-object values are coerced to objects. See the

### lodash.js

- **Line 7059:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 7824:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 11196:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 11867:** ** This method is equivalent to `_.matches` when `source` is
- **Line 11970:** ** This method can't reliably detect native functions in the presence
- **Line 14741:** ** In the development build `_.template` utilizes

### matchesProperty.js

- **Line 12:** ** Partial comparisons will match empty array and empty object

### memoize.js

- **Line 13:** ** The cache is exposed as the `cache` property on the memoized

### omit.js

- **Line 19:** ** This method is considerably slower than `_.pick`.

### parseInt.js

- **Line 15:** ** This method aligns with the

### partial.js

- **Line 17:** ** This method doesn't set the "length" property of partially

### pull.js

- **Line 9:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`

### pullAll.js

- **Line 6:** ** Unlike `_.difference`, this method mutates `array`.

### pullAllBy.js

- **Line 9:** ** Unlike `_.differenceBy`, this method mutates `array`.

### pullAt.js

- **Line 12:** ** Unlike `_.at`, this method mutates `array`.

### range.js

- **Line 9:** ** JavaScript follows the IEEE-754 standard for resolving

### remove.js

- **Line 9:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`

### rest.js

- **Line 12:** ** This method is based on the

### reverse.js

- **Line 11:** ** This method mutates `array` and is based on

### unescape.js

- **Line 13:** ** No other HTML entities are unescaped. To unescape additional

### valuesIn.js

- **Line 8:** ** Non-object values are coerced to objects.

### without.js

- **Line 10:** ** Unlike `_.pull`, this method returns a new array.

### wrapperReverse.js

- **Line 9:** ** This method mutates the wrapped array.

### index.js

- **Line 174:** that we must ALWAYS check specially whether those values are MIN_VALUE
- **Line 424:** the compiler should inline these constant values below and then remove these variables, so there should be

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 543:** we can't clone the form-data object without having it as a dependency
- **Line 742:** per spec we have to first exhaust the lists then process them

### index.js

- **Line 147:** This could be implemented using a single negative lookbehind

### index.js

- **Line 27:** We cannot use the name property command file because in the case of

### update-notifier.js

- **Line 41:** that this isn't another http request over the network, because

### install.js

- **Line 93:** there used to be registry completion here,

### publish.js

- **Line 116:** that publishConfig might have changed as well!

### npm.js

- **Line 109:** that this might not be the actual name of the command
- **Line 154:** this MUST be shorter than the actual argv length, because it

### log-file.js

- **Line 16:** that each log event can write more than one line to the

### queryable.js

- **Line 141:** that occurrences of Symbol(append) will throw,

### reify-output.js

- **Line 23:** fails and crashes if we're running audit fix and there was an error

### build-ideal-tree.js

- **Line 37:** some of these symbols are shared so we can hit
- **Line 579:** any that can't be fixed at the root level without --force
- **Line 841:** this is the same "maximally naive" deduping tree-building
- **Line 1035:** that the virtual root will also have virtual copies of the
- **Line 1116:** that this WILL fetch bundled meta-deps which are also dependencies
- **Line 1269:** that the peers in the set can conflict either with each other,

### load-actual.js

- **Line 137:** hidden lockfile will be rejected if it's not the latest thing

### rebuild.js

- **Line 260:** that 'scripts' might be missing entirely, and the package may

### reify.js

- **Line 301:** that each rollback *also* calls the previous one when it's

### deepest-nesting-target.js

- **Line 7:** this will skip past the first target if edge is peer

### diff.js

- **Line 145:** that if ideal has integrity, and resolved doesn't, we treat
- **Line 189:** we DON'T diff fsChildren themselves, because they are either
- **Line 262:** that moving over a bundled dep will break the links to other

### edge.js

- **Line 110:** this condition means we explicitly do not support overriding

### node.js

- **Line 143:** this *only* works for non-file: deps, so we avoid even
- **Line 220:** this is _slightly_ less efficient for the initial tree
- **Line 853:** the subtle breaking change from v6: it is no longer possible
- **Line 994:** that there are cases where Arborist will opt to insert a node

### optional-set.js

- **Line 8:** that this is *only* going to work with trees where calcDepFlags

### place-dep.js

- **Line 90:** this sets the parent's canPlace as the parent of this
- **Line 301:** if the virtualRoot *doesn't* have the peer, then that means

### query-selector-all.js

- **Line 519:** this uses a Promise.all around a map without in-line concurrency handling
- **Line 861:** this runs over each node and should not throw

### shrinkwrap.js

- **Line 30:** that between this.add() and this.commit(), `this.data` will be out of
- **Line 86:** name is included if necessary, for alias packages

### definition.js

- **Line 178:** these are not quite the same as the description printed

### index.js

- **Line 393:** we pull registry without restricting to the current 'where' because we want to
- **Line 804:** not encrypted, no idea why we bothered to do this, but oh well

### set-envs.js

- **Line 99:** this doesn't afect the *current* node process, of course, since

### index.js

- **Line 89:** the first or second parameter must be a static version or range

### field_behavior.js

- **Line 11:** This enum **may** receive new values in the future.

### entry-index.js

- **Line 126:** - Cleverness ahoy!

### index.js

- **Line 59:** `iterator.next()` can be called many times in parallel.
- **Line 145:** We *must* do this for async iterators otherwise we'll spin up

### dbcs-codec.js

- **Line 284:** '>>> 0' keeps 32-bit num positive.

### utf32.js

- **Line 123:** codepoint is a signed int32 and can be negative.
- **Line 124:** We copied this block from below to help V8 optimize it (it works with array, not buffer).
- **Line 156:** codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.

### index.js

- **Line 135:** Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add

### streams.js

- **Line 5:** Due to 'stream' module being pretty large (~100Kb, significant in browser environments),

### entry.js

- **Line 15:** we will also store any request headers
- **Line 26:** we must not store the real response's age header, or when we load
- **Line 311:** we do not set the x-local-cache-hash header because we do not know
- **Line 394:** be sure to remove the headers property from the

### policy.js

- **Line 123:** this is a hack to avoid parsing the cache-control

### fetcher.js

- **Line 172:** that they should *not* calculate or check integrity or cache,
- **Line 189:** cacache will raise a EINTEGRITY error if the integrity doesn't match

### git.js

- **Line 169:** that this does mean that a dependency MAY in theory end up

### registry.js

- **Line 79:** this might be either an in-flight promise for a request,

### is-package-bin.js

- **Line 5:** this is not possible in remote or file fetchers, since

### tar-create-options.js

- **Line 16:** that npm-packlist is already filtering out

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### container.js

- **Line 121:** that this location is relative to the location of the first character

### socksclient.js

- **Line 34:** Supports callbacks and promises. Only supports the connect command.
- **Line 84:** Supports callbacks and promises. Only supports the connect method.
- **Line 85:** Implemented via createConnection() factory function.
- **Line 274:** If the Socks client is not BoundWaitingForConnection or Established, the connection will be closed.
- **Line 482:** As of Tor v0.3.5.7+, if user/pass auth is an option from the client, by default it will always take priority.
- **Line 537:** No auth and user/pass are currently supported.

### store.js

- **Line 169:** that an expired initial root is still considered valid.

### updater.js

- **Line 311:** This may be a slow operation if there are many delegated roles.

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### unicode.js

- **Line 99:** excluding NULL and ASCII whitespace

### preprocessor-mixin.js

- **Line 16:** avoid reporting error twice on advance/retreat

### parser-mixin.js

- **Line 43:** For cases like <p> <p> </p> - First 'p' closes without a closing
- **Line 86:** generate location info for elements
- **Line 103:** <body> and <html> are never popped from the stack, so we need to updated
- **Line 140:** _attachElementToTree is called from _appendElement, _insertElement and _insertTemplate methods.
- **Line 183:** store last foster parenting location, so we will be able to find inserted text
- **Line 209:** if we have location assigned by another token, then just update end position

### tokenizer-mixin.js

- **Line 93:** if we have pending character token make it's end location equal to the
- **Line 117:** if we have character token and it's location wasn't set in the _emitCurrentToken(),
- **Line 132:** patch initial states for each mode to obtain token start position

### preprocessor-mixin.js

- **Line 25:** LF should be in the last column of the line

### formatting-element-list.js

- **Line 59:** build attrs map for the new element so we can perform fast lookups
- **Line 81:** remove bottommost candidates until Noah's Ark condition will not be met

### index.js

- **Line 350:** use <template> element as a fragment context if context element was not provided,
- **Line 356:** create fake element which will be used as 'document' for fragment parsing.
- **Line 939:** store next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 1042:** do nothing =)
- **Line 1389:** If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
- **Line 1583:** here we assume that we always act as an user agent with enabled plugins, so we parse

### open-element-stack.js

- **Line 257:** here we assume that root <html> element is always first in the open element stack, so

### index.js

- **Line 163:** used in tests and by rewriting stream

### index.js

- **Line 176:** String.fromCharCode() function can handle only characters from BMP subset.
- **Line 434:** store emited start tag's tagName to determine is the following end tag token is appropriate.
- **Line 502:** used then we emit character explicitly. This is always a non-whitespace and a non-null character.
- **Line 522:** we use greedy search, so we continue lookup at this point
- **Line 1402:** sequence lookup can be abrupted by hibernation. In that case lookup
- **Line 2026:** matching can be abrupted by hibernation. In that case match

### named-entity-data.js

- **Line 3:** this file contains auto-generated array mapped radix tree that is used for the named entity references consumption

### preprocessor.js

- **Line 13:** HTML input preprocessing
- **Line 33:** err reporting is noop by default. Enabled by mixin.
- **Line 42:** try to peek a surrogate pair
- **Line 47:** we have a surrogate pair. Peek pair character and recalculate code point.
- **Line 50:** add gap that should be avoided during retreat
- **Line 57:** we are at the end of a chunk, therefore we can't infer surrogate pair yet.
- **Line 63:** isolated surrogate
- **Line 108:** any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character
- **Line 116:** all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 23:** the oid can be obtained via the following sql query:

### redact.bench.js

- **Line 33:** that "redact me." is the same amount of bytes as the censor: "[Redacted]"

### proto.js

- **Line 53:** use of class is satirical

### redaction.js

- **Line 52:** "b.z" is in both "a" and * arrays because "a" matches the wildcard.

### pino.d.ts

- **Line 98:** When browserified, this functionality will only be available if the `events` module has been required elsewhere
- **Line 123:** Does not overwrite bindings. Can potentially result in duplicate keys in log lines.

### protobuf.js

- **Line 1071:** that this uses `end`, not `pos`
- **Line 1553:** that the casts below are theoretically unnecessary as of today, but older statically

### protobuf.js

- **Line 2113:** that values inherit valuesById on their prototype which makes them a TypeScript-
- **Line 6959:** Extension fields aren't actual fields on the declaring type, but nested objects.

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### runtime.js

- **Line 231:** that simple async functions are implemented on top of
- **Line 340:** ["return"] must be used for ES3 parsing compatibility.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### rollup.d.ts

- **Line 128:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 389:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 6637:** this doesn't skip properties with defined getters/setters which we use to pack wrap booleans
- **Line 9618:** that class fields do not end up on the prototype
- **Line 12853:** that we use posix.join because:
- **Line 14336:** that unknown test values are always included

### index.js

- **Line 28:** 'error' and 'ready' events emitted below only relevant when sonic.sync===false

### HelperManager.js

- **Line 36:** that TypeScript and Babel do this differently; TypeScript does a simple existence

### flow.js

- **Line 351:** bracketL has already been consumed
- **Line 363:** both bracketL have already been consumed

### types.js

- **Line 26:** These "type casts" are *not* valid TS expressions.

### typescript.js

- **Line 75:** TypeScript's implementation is much more complicated because
- **Line 241:** In TypeScript implementation we must provide `yieldContext` and `awaitContext`,
- **Line 824:** TS uses parseLeftHandSideExpressionOrHigher,
- **Line 993:** this won't be called unless the keyword is allowed in `shouldParseExportDeclaration`.
- **Line 1466:** The reason we do this in `parseIdentifierStatement` and not `parseStatement`
- **Line 1544:** When the JSX plugin is on, type assertions (`<T> x`) aren't valid syntax.

### statement.js

- **Line 175:** falls through to _var
- **Line 265:** that this can happen either in place of a regular variable declaration

### RootTransformer.js

- **Line 80:** that we always want to enable the imports transformer, even when the import transform

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### request-base.js

- **Line 156:** we do not include ESOCKETTIMEDOUT because that is from `request` package
- **Line 159:** we do not include EADDRINFO because it was removed from libuv in 2014
- **Line 472:** that for this to work the origin must not be
- **Line 518:** as this method is designed to return a useful non-this value,

### get.d.ts

- **Line 125:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 5:** The return value has to be `any` and not `unknown` so it can match `void`.
- **Line 67:** The use of tuples in this first condition side-steps distributive conditional types

### bundle.min.js

- **Line 2125:** 1: It isn't allowed for yield* to close without an expression
- **Line 2126:** 2: If there is a nlb between yield and star, it is interpret as
- **Line 13427:** Lots of methods and functions are missing here, in case they aren't pure
- **Line 32095:** debug may be enabled as an empty string, which is falsey. Also treat passing 'true'

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### index.d.ts

- **Line 2716:** It is intentional that this is not a type guard.
- **Line 2887:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### node-internal-modules-esm-resolve.js

- **Line 258:** fs check redundances will be handled by Descriptor cache here.

### runmain-hack.js

- **Line 6:** that I attempted a try-catch around `Module._load`, but it poisons some sort of cache such that subsequent `import()` is impossible.

### bin.js

- **Line 41:** When transitioning into the child-process after `phase2`,
- **Line 147:** argv and restArgs may be overwritten by child process
- **Line 247:** When we transition to a child process for ESM, the entry-point script determined
- **Line 294:** that we need to explicitly re-resolve the entry-point information in the final
- **Line 316:** resolution relative to cwd option (not `process.cwd()`) is legacy backwards-compat; should be changed in next major: https://github.com/TypeStrong/ts-node/issues/1834
- **Line 470:** eval and repl may both run, but never with stdin.

### file-extensions.js

- **Line 108:** TS's resolver is only used by, and only required for, typechecking.

### index.js

- **Line 285:** fileURLToPath does not exist on early node v10

### repl.d.ts

- **Line 13:** typically, you will want to call `start()` instead of using this method.

### repl.js

- **Line 196:** `code` argument is deprecated
- **Line 205:** deprecated
- **Line 212:** should not be killing the process here, but this codepath is deprecated anyway
- **Line 388:** REPL does not respect sourcemaps!

### resolver-functions.js

- **Line 100:** seems to be called with empty typeDirectiveNames array for all files.

### ts-internals.js

- **Line 13:** This factory returns *only* functions which need a reference to the TS

### index.js

- **Line 245:** overwritten later (depends on usePolling)

### mapping-list.js

- **Line 41:** The order of the mappings is NOT guaranteed.

### read-wasm.js

- **Line 3:** This file is replaced with "read-wasm-browser.js" when this module is

### url.js

- **Line 9:** This file is overridden in the 'package.json#browser' field to

### index.js

- **Line 64:** that http://stackoverflow.com/a/4467559/3191 does NOT work for large modulos

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### output.js

- **Line 101:** includes "all" option

### propmangle.js

- **Line 190:** debug is either false (disabled), or a string of the debug suffix to use (enabled).
- **Line 191:** debug may be enabled as an empty string, which is falsy. Also treat passing 'true'

### uri.all.js

- **Line 1178:** We do not parse query strings for HTTP URIs

### v8-compile-cache.js

- **Line 228:** that this actually includes the newline character(s) in the

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### base.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

### schemas.js

- **Line 811:** `Missing required key: "Key"`,

### BasicTools.ts

- **Line 46:** In a production environment, this should be replaced with a safer evaluation method

### FederatedSwarmIntelligence.ts

- **Line 49:** We're using the EmergencePattern interface from EmergenceDetection.ts now

## OPTIMIZE Items (24)

### multimodal-content-usage.ts

- **Line 75:** the image for web

### lrn_gpu.js

- **Line 24:** pow(bias + alpha * sum, -beta)

### index.js

- **Line 91:** for Arrays. Big arrays could kill the performance otherwise!

### index.js

- **Line 249:** for compressibility

### bundle.min.js

- **Line 18393:** identity function

### ImageProcessor.ts

- **Line 399:** an image for web delivery

### model-registry.ts

- **Line 2274:** model tier assignments based on cost and performance

### ModelOptimizer.test.ts

- **Line 318:** the workflow for performance
- **Line 368:** the workflow for cost
- **Line 428:** the workflow for batching

### VLLMAdapter.ts

- **Line 205:** configuration based on hardware
- **Line 252:** tensor parallelism
- **Line 261:** configuration based on hardware capabilities
- **Line 267:** batch sizes based on available memory

### ModelOptimizer.ts

- **Line 365:** for hardware using VLLMOptimizer
- **Line 407:** workflow
- **Line 533:** model inference with the given prompt and options
- **Line 818:** workflow for a specific model and use case

### vllmOptimizer.ts

- **Line 315:** memory settings based on available VRAM
- **Line 333:** based on GPU capabilities
- **Line 367:** block size based on model architecture

### WorkflowOptimizer.test.ts

- **Line 384:** again with learning

### WorkflowOptimizer.ts

- **Line 111:** a workflow using specified strategies

### types.ts

- **Line 273:** resource allocation

## REVIEW Items (9)

### types.d.ts

- **Line 2861:** requests to access organization resources with fine-grained personal access tokens
- **Line 2870:** a request to access organization resources with a fine-grained personal access token
- **Line 4410:** custom deployment protection rules for a workflow run
- **Line 4472:** pending deployments for a workflow run
- **Line 7690:** comments are in ascending order by ID.
- **Line 24253:** Requested Issue Event
- **Line 24271:** Request Removed Issue Event
- **Line 24289:** Dismissed Issue Event

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

## TODO Items (554)

### index.js

- **Line 179:** Implement semantic comparison using embeddings

### meta_agent.ts

- **Line 63:** Integrate with OpenAPI schema validation using ajv

### agentPipeline.test.ts

- **Line 2:** Expand tests for more edge cases and error handling as workflow grows.

### createMR.ts

- **Line 20:** Implement real HTTP POST to GitLab Merge Request API

### filesystemAdapter.ts

- **Line 2:** Replace mock logic with real fs/promises operations and error handling.
- **Line 3:** Add OpenAPI contract validation and logging.

### runCI.ts

- **Line 2:** Replace mock logic with real HTTP POST to GitLab API.
- **Line 17:** Implement real HTTP POST to GitLab CI trigger endpoint

### updateNode.ts

- **Line 2:** Replace mock logic with real HTTP request to Drupal JSON:API endpoint.
- **Line 3:** Add error handling, logging, and OpenAPI contract validation.
- **Line 4:** Integrate with Drupal modules and Drupal-centric workflows.
- **Line 5:** Add OpenAPI/CI contract validation for Drupal workflows.
- **Line 6:** Document Drupal adapter usage in main docs.
- **Line 20:** Implement real HTTP PATCH/POST to Drupal JSON:API

### agentCli.ts

- **Line 3:** Integrate this logic into the main llmcli once CLI entrypoint is clarified.
- **Line 4:** Add support for more workflows and richer input/output handling.

### runCIAgent.ts

- **Line 9:** Replace with your project's logger if available
- **Line 51:** Add OpenAPI contract tests and CI validation for this agent node.
- **Line 52:** Extend with richer context, retry logic, or GitLab API response parsing as needed.

### schemas.ts

- **Line 2:** Integrate all schemas with CI validation (Spectral, Redocly, etc.)
- **Line 3:** Reference these schemas in Drupal ECA (Event-Condition-Action) rules for contract enforcement.
- **Line 4:** Extend this file as new Drupal workflows/agents are added.
- **Line 68:** Add and export schemas for all new Drupal workflows and agents here.

### submitterAgent.ts

- **Line 2:** Replace mock submission with real API call (e.g., POST to Drupal JSON:API, create GitLab MR, etc.)
- **Line 12:** Replace with actual submission logic (e.g., POST to Drupal)

### summarize_content.ts

- **Line 2:** Expand workflow for additional steps, branching, or error handling as needed.
- **Line 3:** Align workflow input/output with OpenAPI schema for API exposure.

### summarizerAgent.ts

- **Line 2:** Replace mock logic with actual LLM summarization (e.g., call OpenAI, vLLM, etc.)
- **Line 3:** Align input/output interfaces with OpenAPI schema for API exposure.
- **Line 9:** Replace with actual LLM summarization logic

### validatorAgent.ts

- **Line 2:** Expand validation logic (e.g., check for prohibited content, structure, etc.)

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### core-js-compat.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### source-map-support.js

- **Line 138:** un-copy these from resolve-uri; see if they can be exported from that lib
- **Line 392:** Remove now that windows path support was added to resolve-uri and thus trace-mapping?
- **Line 629:** is there a better way to reliably get an instance of NodeError?

### index.ts

- **Line 133:** Other constants as well

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### source-map.umd.js

- **Line 1213:** :: should this be duck-typed ?

### index.js

- **Line 36:** remove when Node v8 support drops

### mkdir.js

- **Line 4:** This should probably be a class, not functionally

### index.js

- **Line 129:** type `octokit.auth` based on passed options.authStrategy

### index.js

- **Line 48:** this is duplicated in basic tracer. Consolidate on a common helper in core
- **Line 92:** SDK types don't provide resource schema URL at this time

### Resource.js

- **Line 92:** Consider to add check/validation on attributes.

### MetricReader.js

- **Line 88:** use BindOncePromise here once a new version of @opentelemetry/core is available.

### DeltaMetricProcessor.js

- **Line 44:** find a reasonable mean to clean the memo;

### MeterSelector.js

- **Line 27:** semver filter? no spec yet.

### enums.js

- **Line 29:** Add these semantic attributes to:

### sns.js

- **Line 36:** Use SEMATTRS_MESSAGING_DESTINATION_NAME when implemented

### sqs.js

- **Line 90:** How should this be handled?

### instrumentation.js

- **Line 130:** instrument error handlers
- **Line 182:** Fix router spans (getRouterPath does not work properly) to

### instrumentation.js

- **Line 195:** what to do if we are pretty sure it's going to throw

### serverUtils.js

- **Line 73:** Investigate this call/signature – it was inherited from very old

### http.js

- **Line 518:** get error attributes for metrics

### utils.js

- **Line 353:** http.url attribute, it should substitute any parameters to avoid high cardinality.
- **Line 683:** http.target attribute, it should substitute any parameters to avoid high cardinality.

### instrumentation.js

- **Line 39:** : use semantic convention

### instrumentation.js

- **Line 190:** remove the `as ...` casts below when the TS version is upgraded.

### TraceState.js

- **Line 37:** Benchmark the different approaches(map vs list) and
- **Line 78:** Consider to add warning log

### index.js

- **Line 20:** Replace wildcard export with named exports before next major version

### sdk.js

- **Line 274:** This is a workaround to fix https://github.com/open-telemetry/opentelemetry-js/issues/3609

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### glob-assets.js

- **Line 18:** Temporary workaround for https://github.com/mrmlnc/fast-glob/issues/47

### index.js

- **Line 246:** Make it return a web stream at some point.

### mime_cli.ts

- **Line 13:** Use json imports to access package.json once "import attributes" are

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### tf-backend-cpu.fesm.js

- **Line 7023:** Support slice ops for complex type.
- **Line 7188:** Use matmul instead once it supports complex64 type.

### conv_packed_gpu.js

- **Line 82:** Ensure vec4 previous does not result in redundant sample,

### gpgpu_math.js

- **Line 301:** Remove the condition of !x.isUniform.
- **Line 360:** Remove the limitaion of rank <= 4.

### Abs.js

- **Line 25:** handle cases when x is complex. Once the cpu implementation

### Conv2D_impl.js

- **Line 92:** Once reduction ops are packed, batchMatMul will always be packed

### LinSpace.js

- **Line 22:** Use CPU implementation due to the precision problem in Safari.

### texture_manager.js

- **Line 148:** Assign non-null value (empty object) to textures after disposed.

### tf-backend-webgl.fesm.js

- **Line 1825:** support 5d and 6d
- **Line 8345:** handle cases when x is complex.
- **Line 8759:** Iterating through all binaries to build VAOs is supposed to be in

### flags_test.js

- **Line 39:** (yassogba) figure out why this spy is not working / fix this test.

### types.d.ts

- **Line 135:** (cais,yassogba) consider removing GraphDef as GraphDefs now

### kernel_registry_test.js

- **Line 55:** (yassogba) double registration happens now because a backend might be

### cumprod_test.js

- **Line 46:** once gradients are implemented, create tests something like this.

### min_test.js

- **Line 81:** Use skip() instead when it is implemented

### square_test.js

- **Line 60:** Use expectArraysClose when it supports epsilons scaled by the

### adagrad_optimizer_test.js

- **Line 47:** Fix numerical precision.

### log_sigmoid.js

- **Line 17:** update import path once op is modularized.

### tf-core.fesm.js

- **Line 6615:** Don't create a new array every loop.

### tf-core.node.js

- **Line 1504:** (yassogba) after 3.0 assess whether we need to keep this gated
- **Line 4713:** (yassogba) remove this option (Tensor) when node backend
- **Line 6720:** This is inefficient. Make getFloat16Decoder efficient.
- **Line 10731:** call broadcastTo kernel directly once backends implement broadcstTo
- **Line 12037:** move this logic to forward function when the broadcastTo op is
- **Line 12121:** Make this into its own kernel.
- **Line 14289:** Use Engine.runKernel when CPU/WebGL/WASM backends implement this.
- **Line 20780:** Transpose bias and preluActivationWeights properly for NCHW

### tf-layers.js

- **Line 22111:** raise exception when a `.computeMask()` call

### nodejs_kernel_backend.js

- **Line 170:** - what about ID in this case? Handle in write()??

### index.js

- **Line 168:** reuse sockets

### tf.fesm.js

- **Line 66761:** Turn validation on/off with tf env flag.
- **Line 66781:** Filter out more nodes when >=2 nodes are predefined in a path.

### formatter.js

- **Line 10:** add [additonal formatters][1]

### cli.ts

- **Line 90:** validate that all these paths exist.

### index.d.ts

- **Line 5:** export * from "./trigger/alexa";
- **Line 25:** export * from "./trigger/cognito-sync";
- **Line 28:** export * from "./trigger/config";

### index.d.ts

- **Line 101:** handling for regex parameters

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 759:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### eslint-recommended-raw.js

- **Line 24:** - remove this once we no longer support ESLint v8

### no-floating-promises.js

- **Line 110:** #5439

### no-inferrable-types.js

- **Line 128:** - if we add more references

### no-misused-promises.js

- **Line 481:** - Once we're able to use `checker.isTypeAssignableTo` (v8), we can check an index

### no-mixed-enums.js

- **Line 154:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 79:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 237:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 199:** - we could break down the spread and compare the array type against each argument
- **Line 238:** - handle generic iterable case

### no-unused-vars.js

- **Line 585:** ######

### prefer-nullish-coalescing.js

- **Line 364:** also account for = in the ternary clause

### analyzeChain.js

- **Line 208:** - we could further reduce the false-positive rate of this check by
- **Line 428:** - #7170

### compareNodes.js

- **Line 145:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 650:** we have to compare to 0n if the type is bigint
- **Line 655:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 123:** Do we need to investigate the precedence here?
- **Line 156:** JSXElement?

### getContextualType.js

- **Line 74:** - support return statement checking

### isUnsafeAssignment.js

- **Line 74:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 24:** - delete this in next major

### convert.js

- **Line 1788:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 66:** Support Windows CRLF

### createProjectService.js

- **Line 28:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 31:** see getWatchProgramsForProjects

### getWatchProgramsForProjects.js

- **Line 208:** file issue on TypeScript to suggest making optional?

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 272:** rename to 'tokens'

### index.js

- **Line 3:** remove this in the next major version

### constants.js

- **Line 3:** increment this version if there are schema changes

### built-in-definitions.js

- **Line 337:** We should introduce overloaded instance methods definition
- **Line 360:** add async iterator dependencies when we support sub-dependencies

### json.js

- **Line 77:** maybe make this configurable or part of "strict" option

### dbcs-codec.js

- **Line 348:** What if we have no default? (resCode == undefined)
- **Line 472:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### extend-node.js

- **Line 169:** Set _charsWritten.

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### fsevents-handler.js

- **Line 15:** real check
- **Line 503:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### cell.js

- **Line 169:** cells should always exist - some tests don't fill it in though

### index.js

- **Line 100:** add more term programs

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### array-group.js

- **Line 29:** Remove this block from `core-js@4`

### composite-key.js

- **Line 1:** in core-js@4, move /modules/ dependencies to public entries for better optimization by tools like `preset-env`

### fix-regexp-well-known-symbol-logic.js

- **Line 2:** Remove from `core-js@4` since it's moved to entry points

### numeric-range-iterator.js

- **Line 20:** Drop the first `typeof` check after removing legacy methods in `core-js@4`

### typed-array-constructor.js

- **Line 98:** add validation descriptor w/o calling accessors

### es.number.to-exponential.js

- **Line 74:** improve accuracy with big fraction digits

### es.number.to-fixed.js

- **Line 85:** ES2018 increased the maximum number of fraction digits to 100, need to improve the implementation

### es.regexp.constructor.js

- **Line 32:** Use only proper RegExpIdentifierName

### es.set.js

- **Line 1:** Remove this module from `core-js@4` since it's replaced to module below

### es.string.trim-start.js

- **Line 1:** Remove this line from `core-js@4`

### es.symbol.js

- **Line 1:** Remove this module from `core-js@4` since it's split to modules listed below

### esnext.set.intersection.js

- **Line 9:** Obsolete version, remove from `core-js@4`

### esnext.string.code-points.js

- **Line 16:** unify with String#@@iterator

### web.dom-exception.stack.js

- **Line 49:** fix export logic

### object-iteration.js

- **Line 1:** remove from `core-js@4` as withdrawn

### using-statement.js

- **Line 1:** Renamed, remove from `core-js@4`

### 0.js

- **Line 8:** Obsolete versions, remove from `core-js@4`:

### 2.js

- **Line 10:** Obsolete versions, remove from `core-js@4`

### 4.js

- **Line 1:** Remove this entry from `core-js@4`

### basic.d.ts

- **Line 24:** Make it this when targeting TypeScript 4.1:

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### _stream_writable.js

- **Line 289:** defer error events consistently everywhere, not just the cb

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### request.js

- **Line 452:** change req.host to return host in next major

### browser.js

- **Line 36:** add a `localStorage` variable to explicitly enable/disable colors

### test-stable.js

- **Line 260:** This is a known limitation of the current implementation.

### index.js

- **Line 10:** Remove the `...` when https://github.com/tc39/proposal-iterator-helpers is available.

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### Formidable.js

- **Line 323:** uncomment when switch tests to Jest
- **Line 483:** use Set/Map and pass plugin name instead of the `idx` index

### JSON.js

- **Line 13:** consider using a string decoder

### index.js

- **Line 5:** Document the `context` option and add to types when I know it's something I want to keep.

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### logging-utils.js

- **Line 189:** `fields` needs to be turned into a string here, one way or another.
- **Line 244:** `fields` needs to be turned into a string here.

### index.d.ts

- **Line 66:** replace Function with actual signature

### core.js

- **Line 653:** We need negative look-behind support to do this properly
- **Line 2221:** remove with version 11.0
- **Line 2253:** remove v12, deprecated
- **Line 2404:** remove with v12
- **Line 2474:** Remove with v12 API

### ada.js

- **Line 49:** These spaces are not required by the Ada syntax

### elm.js

- **Line 25:** other constructors (built-in, infix).

### haml.js

- **Line 9:** support filter tags like :javascript, support inline HTML

### haskell.js

- **Line 37:** other constructors (build-in, infix).
- **Line 158:** characters.

### java.js

- **Line 101:** can this be removed somehow?

### julia.js

- **Line 366:** neatly escape normal code in string literal

### less.js

- **Line 129:** find a better solution?

### llvm.js

- **Line 90:** split into different categories of keywords

### markdown.js

- **Line 48:** fix to allow these to work with sublanguage also

### powershell.js

- **Line 66:** 'validate[A-Z]+' can't work in keywords

### python.js

- **Line 159:** Could these be supplemented by a CamelCase matcher in certain

### r.js

- **Line 194:** replace with negative look-behind when available

### swift.js

- **Line 273:** The following characters are also allowed, but the regex isn't supported yet.
- **Line 475:** Update for leading `-` after lookbehind is supported everywhere
- **Line 809:** Interpolation can contain any expression, so there's room for improvement here.

### vbnet.js

- **Line 151:** Use `beforeMatch:` for leading spaces
- **Line 159:** Use `beforeMatch:` for indentation once available

### yaml.js

- **Line 141:** remove |$ hack when we have proper look-ahead support

### index.d.ts

- **Line 107:** Old API, remove with v12

### register.js

- **Line 5:** should this be a Set?

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### magic-string.cjs.js

- **Line 131:** is this block necessary?...
- **Line 830:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 1310:** there's a bunch of this sort of thing, needs cleaning up

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### index.d.ts

- **Line 1300:** Remove this in meow 14.

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### test.js

- **Line 46:** Uncomment once #157 is resolved

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### async.js

- **Line 2903:** size could be changed

### index.js

- **Line 151:** Replace everything below with `urlObject.pathname = urlObject.pathname.replace(/(?<!\b[a-z][a-z\d+\-.]{1,50}:)\/{2,}/g, '/');` when Safari supports negative lookbehind.

### npx-cli.js

- **Line 9:** remove the affordances for removed items in npm v9

### cache.js

- **Line 82:** - eventually...

### completion.js

- **Line 178:** this was dead code, leaving it in case we find some command we
- **Line 214:** Ignoring coverage, see 'non EPIPE errors cause failures' test.

### config.js

- **Line 128:** complete with valid values, if possible.

### doctor.js

- **Line 118:** when we have an in progress indicator that could go here
- **Line 328:** display layer should do this

### fund.js

- **Line 80:** add !workspacesEnabled option handling to libnpmfund

### link.js

- **Line 165:** write tests for unmatching version specs, this is hard to test

### ls.js

- **Line 300:** there is a LOT of overlap with lib/utils/explain-dep.js here

### outdated.js

- **Line 121:** normalize usage of edges and avoid looping through nodes here

### pkg.js

- **Line 77:** https://github.com/npm/cli/issues/5508 a raw mode has been requested similar

### rebuild.js

- **Line 34:** when extending ReifyCmd
- **Line 78:** add tests for a package with missing version

### npm.js

- **Line 89:** should we throw here?

### display.js

- **Line 390:** this could probably be moved to arborist now that display is refactored

### get-workspaces.js

- **Line 12:** we need a better error to be bubbled up here if this call fails

### reify-output.js

- **Line 19:** output JSON if flatOptions.json is true

### build-ideal-tree.js

- **Line 364:** make buildIdealTree() and loadActual handle a missing root path,
- **Line 533:** create synthetic test case to simulate realpath failure
- **Line 550:** provide a way to fix bundled deps by exposing metadata about
- **Line 1217:** post arborist refactor, will need to check for installStrategy=linked

### index.js

- **Line 94:** we only ever look at this.options.replaceRegistryHost, not
- **Line 110:** We should change these to static functions instead
- **Line 145:** why is includeWorkspaceRoot a param?
- **Line 146:** why is workspaces a param?

### isolated-reifier.js

- **Line 112:** this approach feels wrong
- **Line 166:** make sure that idealTree object exists
- **Line 168:** test workspaces having bundled deps
- **Line 264:** we should probably not reference this.idealTree
- **Line 277:** We should mock better the inventory object because it is used by audit-report.js ... maybe
- **Line 388:** we should no-op is an edge has already been created with the same fromKey and toKey

### load-actual.js

- **Line 58:** remove options param in next semver major

### rebuild.js

- **Line 371:** these run before they're awaited

### reify.js

- **Line 57:** tests should not be this deep into internals
- **Line 330:** rollbacks shouldn't be relied on to throw err
- **Line 1525:** this ignores options.save

### can-place-dep.js

- **Line 366:** represent peerPath in ERESOLVE error somehow?

### node.js

- **Line 122:** if this came from pacote.manifest we don't have to do this,

### query-selector-all.js

- **Line 724:** Need a test with an infinite loop
- **Line 805:** (future) loop over ancestry property

### shrinkwrap.js

- **Line 153:** limit concurrency here, this is recursive
- **Line 212:** what uses this?
- **Line 436:** emit a warning here or something if both are present.

### vuln.js

- **Line 62:** duped entries may require different fixes but the current

### definition.js

- **Line 5:** some kind of categorization system, so we can

### definitions.js

- **Line 87:** refactor these type definitions so that they are less
- **Line 89:** use better type definition/validation API, nopt's is so weird.
- **Line 2253:** this is a derived value, and should be reworked when we have a

### index.js

- **Line 6:** make these getters so that we only have to make dirty
- **Line 10:** move nerfdart auth stuff into a nested object that
- **Line 37:** when we switch off of nopt, use an arg parser that supports

### index.js

- **Line 1:** set the scope config from package.json or explicit cli config
- **Line 821:** evaluate removing 'email' from the credentials object returned here

### type-defs.js

- **Line 60:** make nopt less of a global beast so this kludge isn't necessary

### normalize.js

- **Line 446:** exports is much more complicated than this in verbose format

### diff.js

- **Line 113:** Remove the `+ 1` here to make behavior match Myers algorithm

### index.js

- **Line 81:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### init-package-json.js

- **Line 48:** test for non-default definitions

### ipv6.js

- **Line 301:** probably useful to have a numeric version of this too
- **Line 530:** Improve the semantics of this helper function
- **Line 549:** Make private?
- **Line 949:** revisit why this is necessary

### index.js

- **Line 1289:** allow reseeding after first request

### index.js

- **Line 7:** we test this condition in the diff command

### entry.js

- **Line 298:** if the cache write fails, log a warning but return the response anyway

### fetcher.js

- **Line 251:** check error class, once those are rolled out to our deps

### git.js

- **Line 225:** after cloning, create a tarball of the folder, and add to the cache

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### read.js

- **Line 16:** add tests for edit
- **Line 32:** add tests for timeout
- **Line 41:** add tests for edit + default
- **Line 57:** add tests for rejecting
- **Line 66:** add tests for silent
- **Line 73:** add tests for default
- **Line 79:** add tests for sigint

### cert.js

- **Line 142:** test coverage for this case

### entry.js

- **Line 23:** Remove this parameter once have completely switched to 'dsse' entries
- **Line 27:** Remove this conditional once have completely ditched "intoto" entries

### certificate.js

- **Line 113:** Add support for authorityCertIssuer/authorityCertSerialNumber

### index.js

- **Line 9:** this should really be a hardcoded list of algorithms we support,
- **Line 568:** - it's unclear _which_ of these Node will actually use as its name

### updater.js

- **Line 251:** use length for fetching

### redaction.js

- **Line 13:** should this be configurable?

### transport-stream.js

- **Line 19:** add support for the TSM modules loader ( https://github.com/lukeed/tsm ).
- **Line 25:** Support ES imports once tsc, tap & ts-node provide better compatibility guarantees.

### worker.js

- **Line 149:** Why split2 was not used for pipelines?
- **Line 152:** manage backpressure
- **Line 160:** handle backpressure

### pino.d.ts

- **Line 27:** https://github.com/pinojs/thread-stream/issues/24
- **Line 323:** why is this different from `obj: object` or `obj: any`?

### core.test.ts

- **Line 85:** add case for non-pipelined single target (needs changes in thread-stream)

### module-link.test.ts

- **Line 41:** make this test pass on Windows

### pino-top-export.test-d.ts

- **Line 30:** currently returns (aliased) `any`, waiting for strong typed `thread-stream`

### node-progress.js

- **Line 158:** the following assumes the user has one ':bar' token

### index.d.ts

- **Line 155:** Promise?

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### utils.js

- **Line 219:** RFC1738 format

### index.js

- **Line 86:** isn't this wrong?

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### rollup.js

- **Line 19065:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 139:** throws or warn? Currently just ignore, uses new event

### index.js

- **Line 85:** look into also checking the `bugs`/`homepage` URLs

### range.js

- **Line 489:** build?

### parse.js

- **Line 46:** Actually, everything is concatenated into one string

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### cli.js

- **Line 248:** read exclude

### typescript.js

- **Line 58:** actually a bit more complex in TypeScript, but shouldn't matter.
- **Line 78:** Would be nice to avoid lookahead. Want a hasLineBreakUpNext() method...

### TokenProcessor.js

- **Line 78:** We need to process escapes since technically you can have unicode escapes in variable

### JestHoistTransformer.js

- **Line 37:** This only works if imports transform is active, which it will be for jest.

### CJSImportTransformer.d.ts

- **Line 50:** This function has some awkward overlap with

### getImportExportSpecifierInfo.d.ts

- **Line 31:** There's some redundancy with the type detection here and the isType

### index.js

- **Line 1117:** unless buffering emit earlier to stream
- **Line 1173:** Add chunked encoding when no length (if err)

### request-base.js

- **Line 164:** expose these as configurable defaults
- **Line 169:** we would need to make this easily configurable before adding it in (e.g. some might want to add POST)

### response-base.js

- **Line 48:** moar!
- **Line 49:** make this a util

### index.js

- **Line 10:** Use `node:stream/promises` when targeting Node.js 16.

### bundle.min.js

- **Line 5251:** why do we need to crawl this last?
- **Line 5921:** a class might have a scope but it's not a scope */);
- **Line 12610:** string encoding stuff
- **Line 12931:** take propmangle into account
- **Line 13374:** this only works with AST_Defun, shouldn't it work for other ways of defining functions?
- **Line 18590:** this is sometimes undefined during compression.
- **Line 18597:** can we delete? AST_Catch is a block scope.

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### bench.js

- **Line 81:** figure out why it does not shut down

### index.js

- **Line 229:** (fix): Make private?
- **Line 230:** (fix): make private
- **Line 295:** write all .buf
- **Line 305:** handle deadlock
- **Line 524:** stream timeouts for some reason.

### index.js

- **Line 3:** use call-bind, is-date, is-regex, is-string, is-boolean-object, is-number-object
- **Line 12:** use isarray
- **Line 17:** use for-each?
- **Line 26:** use object-keys
- **Line 36:** use reflect.ownkeys and filter out non-enumerables
- **Line 52:** use object.hasown
- **Line 321:** replace with object.assign?

### super_deep.js

- **Line 52:** this one

### index.js

- **Line 1195:** handle type-only imports

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### node-internal-modules-cjs-helpers.js

- **Line 20:** Use this set when resolving pkg#exports conditions in loader.js.

### node-internal-modules-esm-resolve.js

- **Line 92:** receive cached fs implementations here

### node-options.js

- **Line 50:** handle errors somehow

### bin.js

- **Line 454:** this comes from BootstrapState

### configuration.js

- **Line 303:** technically, outDir is absolute path, but exclude should be relative glob pattern?
- **Line 304:** compute baseUrl

### esm.js

- **Line 103:** file://./foo sets `hostname` to `'.'`.  Perhaps we should special-case this.

### index.js

- **Line 227:** switch to getCanonicalFileName we already create later in scope
- **Line 390:** ordering of this with getScriptVersion?  Should they sync up?

### repl.js

- **Line 126:** Figure out how to handle completion here.
- **Line 156:** should evalCode API get the same error-handling benefits?
- **Line 203:** assert that `service` is set; remove all `service!` non-null assertions

### resolver-functions.js

- **Line 101:** consider using `ts.loadWithTypeDirectiveCache`

### swc.js

- **Line 107:** cache the results of this; slightly faster

### util.js

- **Line 135:** technically breaks if projectOption is path to a file, not a directory,

### rollup.js

- **Line 4335:** deprecate this? not really very useful

### handler.js

- **Line 70:** emit errors properly. Example: EMFILE on Macos.

### index.js

- **Line 107:** this is not equal to path-normalize module - investigate why
- **Line 109:** refactor
- **Line 203:** what if stats is undefined? remove !
- **Line 309:** (43081j): make this more efficient.

### index.js

- **Line 109:** make this more efficient

### url-state-machine.js

- **Line 1074:** If c is not a URL code point and not "%", parse error.
- **Line 1096:** Add: not a URL code point
- **Line 1121:** Use encoding override instead

### urlencoded.js

- **Line 107:** handle encoding override

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### URL-impl.js

- **Line 24:** query stuff

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### base.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### schemas.d.ts

- **Line 60:** unions?

### generate_agent_from_openapi.ts

- **Line 59:** Validate input against OpenAPI schema
- **Line 62:** Call API endpoint: [[method.toUpperCase()]] /path/to/resource
- **Line 65:** Validate output against OpenAPI schema

### ModelManager.ts

- **Line 16:** Implement model performance tracking with real-time metrics collection
- **Line 17:** Add automatic model selection based on request parameters and model performance
- **Line 18:** Create load-based auto-scaling for model instances with capacity prediction
- **Line 19:** Implement dynamic model instance assignment based on hardware capabilities
- **Line 20:** Add A/B testing framework for comparing model performance across versions

### ContentProcessorFactory.ts

- **Line 91:** Add AudioProcessor implementation
- **Line 92:** Add TextProcessor implementation
- **Line 93:** Add DocumentProcessor implementation

### ModelDispatcher.ts

- **Line 7:** Implement dynamic model scaling based on incoming request patterns
- **Line 8:** Add federated learning capabilities for distributed model training
- **Line 9:** Implement edge deployment options for low-latency inference
- **Line 10:** Create advanced health monitoring with automatic failover
- **Line 11:** Develop intelligent caching strategy for common prompts

### OrchestrationManager.test.ts

- **Line 37:** Add tests for advanced workflow, provider selection, and metrics

### OrchestrationManager.ts

- **Line 2:** Create comprehensive test suite for OrchestrationManager

### OpenAIProvider.test.ts

- **Line 36:** Add tests for fallback, advanced error handling, and OpenAI API integration

### model-registry.test.ts

- **Line 54:** Add tests for error handling, artifact management, and MLflow integration

### inference.routes.ts

- **Line 37:** [llmcli] Add OpenAPI contract test for /generate endpoint.
- **Line 39:** [llmcli] Add integration test for LLM service error handling.
- **Line 107:** Implement actual chat completion using LLM service
- **Line 166:** Implement actual embedding generation
- **Line 217:** Implement actual model health checking

### models.routes.ts

- **Line 33:** [llmcli] Add OpenAPI contract test for /models endpoint.
- **Line 34:** [llmcli] Ensure Zod validation covers all query params.
- **Line 35:** [llmcli] Add integration test for model registry lookup.
- **Line 47:** Implement actual model registry lookup
- **Line 135:** Implement actual model lookup
- **Line 194:** Implement actual model registration
- **Line 212:** Store in model registry
- **Line 247:** Implement actual model update
- **Line 289:** Implement actual model deployment
- **Line 329:** Implement actual model undeployment

### training.routes.ts

- **Line 28:** [llmcli] Add OpenAPI contract test for /training/jobs endpoint.
- **Line 29:** [llmcli] Ensure Zod validation covers all request fields.
- **Line 30:** [llmcli] Add integration test for training pipeline error handling.
- **Line 31:** [llmcli] Log user context and request ID for audit.
- **Line 32:** [llmcli] Refactor to use typed response per OpenAPI.
- **Line 33:** [llmcli] Add contract test for error scenarios.
- **Line 46:** Implement actual training pipeline integration
- **Line 69:** Store job in database/registry
- **Line 102:** Implement actual job status lookup
- **Line 145:** Implement actual job listing with pagination
- **Line 185:** Implement actual job cancellation

### server.ts

- **Line 97:** Add connection checks to model inference engines when available
- **Line 129:** Implement actual text generation using LLM service
- **Line 158:** Implement actual model service integration
- **Line 203:** Implement actual fine-tuning logic
- **Line 230:** Implement actual fine-tuning status lookup

### ExtendedKVCacheManager.ts

- **Line 2:** Create comprehensive test suite for ExtendedKVCacheManager

### kvCacheManager.ts

- **Line 2:** Create comprehensive test suite for KVCacheManager

### VLLMAdapter.ts

- **Line 2:** Create comprehensive test suite for VLLMAdapter

### distributed.ts

- **Line 6:** Implement federated learning capabilities for privacy-preserving model training
- **Line 7:** Add cross-organization knowledge sharing with differential privacy
- **Line 8:** Create distributed model training across edge devices
- **Line 9:** Implement gradient compression for efficient distributed training
- **Line 10:** Add failure recovery for distributed training jobs

### errorHandler.ts

- **Line 4:** Create comprehensive test suite for LLM error handling

## XXX Items (76)

### index.js

- **Line 108:** non-documented `http` module API :(

### list.js

- **Line 3:** This shares a lot in common with extract.js

### pax.js

- **Line 43:** split the path
- **Line 129:** Values with \n in them will fail this.

### unpack.js

- **Line 718:** get the type ('symlink' or 'junction') for windows

### browser.js

- **Line 118:** (@Qix-) should we be logging these?

### node.js

- **Line 163:** It's lame that node doesn't expose this API out-of-the-box. It also

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### ast.js

- **Line 483:** abstract out this map method

### index.js

- **Line 137:** this is incorrect. we have multicharacter flags like `-iwr` that

### cache.js

- **Line 140:** this could leave other entries without content!

### ci.js

- **Line 109:** should we remove this finally??

### doctor.js

- **Line 164:** get the latest in the current major as well

### fund.js

- **Line 24:** maybe worth making this generic for all commands?

### help.js

- **Line 17:** these are used in the docs workspace and should be exported

### publish.js

- **Line 194:** can't pacote read the manifest from a directory?

### team.js

- **Line 44:** "description" option to libnpmteam is used as a description of the

### package-url-cmd.js

- **Line 26:** It is very odd that `where` is how pacote knows to look anywhere

### display.js

- **Line 328:** in a future (breaking?) change it might make sense for run-script to

### error-message.js

- **Line 386:** we should stop throwing strings
- **Line 395:** we should stop throwing other non-errors

### build-ideal-tree.js

- **Line 559:** this belongs in the audit report itself, not here.
- **Line 583:** how to handle top nodes that aren't the root?  Maybe the report
- **Line 649:** this could be faster by doing a series of inventory.query('name')
- **Line 652:** add any invalid edgesOut to the queue
- **Line 753:** also push anything that depends on a node with a name
- **Line 1006:** This is somehow load bearing.  This makes tests that print

### load-actual.js

- **Line 71:** deprecate separate method options objects.

### load-virtual.js

- **Line 37:** deprecate separate reify() options object.

### reify.js

- **Line 413:** if we have an existing diff already, there should be a way
- **Line 832:** use a magic string that isn't also a valid value, like

### edge.js

- **Line 55:** where is this used?
- **Line 66:** are all of these error states even possible?

### node.js

- **Line 1009:** need to check for two root nodes?

### place-dep.js

- **Line 42:** this only appears to be used by tests
- **Line 237:** if we are replacing SOME of a peer entry group, we will need to
- **Line 335:** handle replacing an entire peer group?
- **Line 510:** decorate more with this.canPlace and this.canPlaceSelf,

### shrinkwrap.js

- **Line 203:** this is duplicated in this.load(), but using loadFiles instead of resetFiles
- **Line 577:** is this even reachable?
- **Line 872:** why is this different from pathFixed in this.add??

### definitions.js

- **Line 127:** We should really deprecate all these `--save-blah` switches
- **Line 1665:** update arborist to just ignore it if resulting saveType is peer

### errors.js

- **Line 10:** context.code is undefined in all constructors used in cp/polyfill

### advisory.js

- **Line 267:** if bundled, then semver.intersects() means vulnerable

### normalize.js

- **Line 609:** should a future breaking change delete bin entries that cannot be accessed?

### set-path.js

- **Line 21:** we should specify a cwd that we don't go above
- **Line 33:** include the node-gyp-bin path somehow?  Probably better for

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 262:** DO NOT USE. This is a temporary stub function.
- **Line 263:** It WILL be removed in the next major release.

### helpers.js

- **Line 18:** Use #base-2 .value-0 instead?

### get-bin-from-manifest.js

- **Line 10:** probably a util to parse this better?
- **Line 16:** need better error message

### index.js

- **Line 18:** this should really be split up and unit-ized for easier testing

### install.js

- **Line 42:** use a different footer line if some aren't fixable easily.

### npa.js

- **Line 259:** backwards compatibility lack of compliance with RFC 8089
- **Line 275:** end RFC 8089 violation backwards compatibility section

### fetcher.js

- **Line 101:** fill more of this in based on what we know from this.opts

### git.js

- **Line 103:** make this a custom error class

### registry.js

- **Line 47:** pacote <=9 has some logic to ignore opts.resolved if
- **Line 136:** add ETARGET and E403 revalidation of cached packuments here

### index.js

- **Line 147:** remove v.length check to remove cb from functions
- **Line 149:** if cb is no longer an argument then this.#ctx should
- **Line 165:** remove this to require throwing an error instead of

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### tdigest.js

- **Line 775:** because mean and mean_cumn give rise to the same sort order

### bundle.min.js

- **Line 9475:** still nice to have that for argument lists
- **Line 11758:** HACK! Ensure the switch expression gets the correct scope (the parent scope) and the body gets the contained scope

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

### source-map-consumer.js

- **Line 305:** keep these error codes in sync with `fitzgen/source-map-mappings`.

### compress.js

- **Line 12099:** intentionally falling down to the next case

### output.js

- **Line 1947:** I'm not exactly sure if we need it for all of these nodes,

