# Roadmap

_Generated on 2025-05-30_

Found 1018 TODO items in the codebase.

## BUG Items (2)

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### _stream_readable.js

- **Line 996:** in node.  Should never happen.

## FIXME Items (15)

### validate.js

- **Line 15:** https://github.com/ajv-validator/ajv/issues/2132

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### node.js

- **Line 200:** Should probably have an option in net.Socket to create a
- **Line 208:** Hack to have stream not keep the event loop alive.

### haml.js

- **Line 20:** these comments should be allowed to span indented lines

### less.js

- **Line 490:** it does not include dot for numbers like .5em :(

### r.js

- **Line 50:** Support Unicode identifiers.

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### profile.js

- **Line 201:** Work around to not clear everything other than what we're setting

### query.js

- **Line 92:** Workspace support in query does not work as expected so this does not

## HACK Items (11)

### node.js

- **Line 178:** to have stream not keep the event loop alive.

### capnproto.js

- **Line 45:** eating everything after the first title

### htmlbars.js

- **Line 337:** This lets handlebars do the auto-detection if it's been loaded (by

### qml.js

- **Line 213:** prevents detection of keywords after dots

### stan.js

- **Line 507:** in range constraints, lower must follow "<"
- **Line 512:** in range constraints, upper must follow either , or <

### typescript.js

- **Line 556:** prevents detection of keywords in some circumstances

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### display.js

- **Line 319:** Check if the argument looks like a run-script banner. This can be

### index.js

- **Line 650:** this is an option set in tests to stop the local prefix from being set

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

## NOTE Items (481)

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### ajv.bundle.js

- **Line 6413:** We do not parse query strings for HTTP URIs

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### types.d.ts

- **Line 145:** that some options, like reasoning summaries, are only available when using the responses

### text_splitter.js

- **Line 534:** the alternative syntax for headings (below) is not handled here
- **Line 543:** that this splitter doesn't handle horizontal lines defined

### types.d.ts

- **Line 441:** With [pagination](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
- **Line 738:** that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
- **Line 778:** ** This endpoint is only available to organizations with access to the enhanced billing platform. For more information, see "[About the enhanced billing platform](https://docs.github.com/billing/using-the-new-billing-platform)."
- **Line 3091:** that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 3150:** ** To prevent leaking sensitive information, the `bypass_actors` property is only returned if the user
- **Line 5075:** ** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
- **Line 5645:** that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 8042:** If making a request on behalf of a GitHub App you must also have permissions to write the contents of the head repository.
- **Line 8480:** there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
- **Line 9057:** **
- **Line 9192:** ** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
- **Line 9981:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
- **Line 86398:** ** A parameter can override this parameter. See `members_allowed_repository_creation_type` in this table for details.
- **Line 86410:** ** This parameter is closing down and will be removed in the future. Its return value ignores internal repositories. Using this parameter overrides values set in `members_can_create_repositories`. See the parameter deprecation notice in the operation description for details.
- **Line 93781:** ** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
- **Line 100520:** ** Providing `conclusion` will automatically set the `status` parameter to `completed`. You cannot change a check run conclusion to `stale`, only GitHub can set this.
- **Line 105563:** ** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
- **Line 110565:** ** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a hypermedia resource. For more information, see "[Getting started with the REST API](https://docs.github.com/rest/using-the-rest-api/getting-started-with-the-rest-api#hypermedia)."
- **Line 112101:** ** Topic `names` will be saved as lowercase.
- **Line 114779:** ** Alternatively, you can pass a single email address or an `array` of emails addresses directly, but we recommend that you pass an object using the `emails` key.

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### octokit.js

- **Line 21:** replace with import ... assert { type: 'json' } once supported

### verify.js

- **Line 130:** we cannot check if the installation has all required permissions, it's

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 718:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### jtd-schema.ts

- **Line 33:** see the end of
- **Line 80:** relies on the fact that tuples don't have an index at 0.5, but arrays

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### semver.js

- **Line 18:** this is the semver.org version of the spec that it implements
- **Line 139:** that the only major, minor, patch, and pre-release sections of
- **Line 167:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 257:** that these all use the loose form, because they'll be

### es5.js

- **Line 244:** that simple async functions are implemented on top of

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### index.js

- **Line 177:** Change prototype *after* Buffer.from is defined to workaround Chrome bug:
- **Line 323:** cannot use `length < K_MAX_LENGTH` here because that fails when

### index.js

- **Line 245:** overwritten later (depends on usePolling)

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### index.js

- **Line 646:** for future: we could return early if we found an action handler in parseArgs, as none of following code needed?

### context.d.ts

- **Line 58:** groups.

### util.js

- **Line 22:** These type checking functions intentionally don't use `instanceof`

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### main.d.ts

- **Line 691:** These declarations exist to avoid type errors when you omit "dom" from

### referencer.js

- **Line 178:** Not referring variableScope. It is intended.
- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 660:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### events.js

- **Line 137:** The comments on the `throw` lines are intentional, they show

### request.js

- **Line 202:** remember that ranges are inclusive, so for example "Range: users=0-3"
- **Line 316:** X-Forwarded-Proto is normally only ever a
- **Line 434:** X-Forwarded-Host is normally only ever a

### node.js

- **Line 171:** stream._type is used for test-module-load-list.js

### isFileLike.d.ts

- **Line 5:** that this function will return `false` for Blob, because the FormDataEncoder expects FormData to return File when a value is binary data.

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### FormData.d.ts

- **Line 19:** that this object is not a part of Node.js, so you might need to check if an HTTP client of your choice support spec-compliant FormData.

### copy.js

- **Line 92:** that The initial srcStat.atime cannot be trusted

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### handlebars.amd.js

- **Line 451:** for 5.0: Change to "obj == null" in 5.0
- **Line 917:** Using env.VM references rather than local var references throughout this section to allow

### index.d.ts

- **Line 198:** for backward compatibility of this typing

### python.js

- **Line 297:** no leading \b because floats can start with a decimal point

### swift.js

- **Line 159:** Contextual keywords are reserved only in specific contexts.

### typescript.js

- **Line 421:** this might not work how you think.  We don't actually always

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that [@link OptionsBase.allowStale] is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### extend-node.js

- **Line 3:** not polyfilled with safer-buffer on a purpose, as overrides Buffer
- **Line 12:** this does use older Buffer API on a purpose

### errors.js

- **Line 322:** extra classes have been shaken out.
- **Line 361:** no need to implement `kIsNodeError` symbol, would be hard,

### get-format.js

- **Line 125:** we don’t implement WASM, so we don’t need

### package-json-reader.js

- **Line 132:** in Node, this is now a native module.

### resolve.js

- **Line 136:** from Node 15 onwards we can use `throwIfNoEntry: false` instead.
- **Line 140:** in Node code this returns `new Stats`,
- **Line 175:** fs check redundances will be handled by Descriptor cache here.
- **Line 1082:** The Node code supports `base` as a string (in this internal API) too,
- **Line 1106:** actual code uses `canBeRequiredWithoutScheme`.
- **Line 1175:** this is from:

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### index.js

- **Line 412:** Intentionally NOT pushing/indexing into the array of mock

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### types.d.ts

- **Line 8:** **It is recommended to use `await jiti.import` instead
- **Line 59:** ** It is recommended to keep this option enabled for better performance.

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### agent.d.ts

- **Line 112:** that the runnable should still only stream a single action or

### initialize.js

- **Line 50:** this tools cast is safe as the overload signatures prevent

### index.js

- **Line 6:** This functionality is currently in beta.

### time_weighted.d.ts

- **Line 93:** When adding documents to a vector store, use addDocuments

### serpapi.d.ts

- **Line 8:** you must provide location, gl and hl or your region and language will

### async_caller.js

- **Line 122:** this doesn't cancel the underlying request,

### generic.js

- **Line 30:** that this will wrap and trace ALL SDK methods, not just

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### _equalByTag.js

- **Line 34:** ** This function only supports comparing values with tags of

### _initCloneByTag.js

- **Line 32:** ** This function only supports cloning values with tags of

### _setData.js

- **Line 7:** ** If this function becomes hot, i.e. is invoked a lot in a short

### assignInWith.js

- **Line 11:** ** This method mutates `object`.

### bindAll.js

- **Line 11:** ** This method doesn't set the "length" property of bound functions.

### conforms.js

- **Line 12:** ** The created function is equivalent to `_.conformsTo` with

### core.js

- **Line 1705:** ** This method is used instead of
- **Line 1919:** ** Unlike `_.remove`, this method returns a new array.
- **Line 2002:** ** As with other "Collections" methods, objects with a "length"
- **Line 2271:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 2405:** ** This method is loosely based on the
- **Line 2723:** ** This method is loosely based on
- **Line 2868:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 3076:** ** This method mutates `object` and is loosely based on
- **Line 3413:** ** No other characters are escaped. To escape additional
- **Line 3515:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 3522:** ** Multiple values can be checked by combining several matchers
- **Line 3554:** ** Use `_.runInContext` to create a pristine `lodash` function to

### curryRight.js

- **Line 13:** ** This method doesn't set the "length" property of curried functions.

### debounce.js

- **Line 23:** ** If `leading` and `trailing` options are `true`, `func` is

### difference.js

- **Line 12:** ** Unlike `_.pullAll`, this method returns a new array.

### differenceBy.js

- **Line 15:** ** Unlike `_.pullAllBy`, this method returns a new array.

### every.js

- **Line 12:** ** This method returns `true` for

### fill.js

- **Line 8:** ** This method mutates `array`.

### isEqual.js

- **Line 7:** ** This method supports comparing arrays, array buffers, booleans,

### isInteger.js

- **Line 6:** ** This method is based on

### keys.js

- **Line 8:** ** Non-object values are coerced to objects. See the

### lodash.js

- **Line 7059:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 7824:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 11196:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 11867:** ** This method is equivalent to `_.matches` when `source` is
- **Line 11970:** ** This method can't reliably detect native functions in the presence
- **Line 14741:** ** In the development build `_.template` utilizes

### matchesProperty.js

- **Line 12:** ** Partial comparisons will match empty array and empty object

### memoize.js

- **Line 13:** ** The cache is exposed as the `cache` property on the memoized

### omit.js

- **Line 19:** ** This method is considerably slower than `_.pick`.

### parseInt.js

- **Line 15:** ** This method aligns with the

### partial.js

- **Line 17:** ** This method doesn't set the "length" property of partially

### pull.js

- **Line 9:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`

### pullAll.js

- **Line 6:** ** Unlike `_.difference`, this method mutates `array`.

### pullAllBy.js

- **Line 9:** ** Unlike `_.differenceBy`, this method mutates `array`.

### pullAt.js

- **Line 12:** ** Unlike `_.at`, this method mutates `array`.

### range.js

- **Line 9:** ** JavaScript follows the IEEE-754 standard for resolving

### remove.js

- **Line 9:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`

### rest.js

- **Line 12:** ** This method is based on the

### reverse.js

- **Line 11:** ** This method mutates `array` and is based on

### unescape.js

- **Line 13:** ** No other HTML entities are unescaped. To unescape additional

### valuesIn.js

- **Line 8:** ** Non-object values are coerced to objects.

### without.js

- **Line 10:** ** Unlike `_.pull`, this method returns a new array.

### wrapperReverse.js

- **Line 9:** ** This method mutates the wrapped array.

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### index.js

- **Line 543:** we can't clone the form-data object without having it as a dependency
- **Line 742:** per spec we have to first exhaust the lists then process them

### index.js

- **Line 147:** This could be implemented using a single negative lookbehind

### index.js

- **Line 27:** We cannot use the name property command file because in the case of

### update-notifier.js

- **Line 41:** that this isn't another http request over the network, because

### install.js

- **Line 93:** there used to be registry completion here,

### publish.js

- **Line 116:** that publishConfig might have changed as well!

### npm.js

- **Line 109:** that this might not be the actual name of the command
- **Line 154:** this MUST be shorter than the actual argv length, because it

### log-file.js

- **Line 16:** that each log event can write more than one line to the

### queryable.js

- **Line 141:** that occurrences of Symbol(append) will throw,

### reify-output.js

- **Line 23:** fails and crashes if we're running audit fix and there was an error

### build-ideal-tree.js

- **Line 37:** some of these symbols are shared so we can hit
- **Line 579:** any that can't be fixed at the root level without --force
- **Line 841:** this is the same "maximally naive" deduping tree-building
- **Line 1035:** that the virtual root will also have virtual copies of the
- **Line 1116:** that this WILL fetch bundled meta-deps which are also dependencies
- **Line 1269:** that the peers in the set can conflict either with each other,

### load-actual.js

- **Line 137:** hidden lockfile will be rejected if it's not the latest thing

### rebuild.js

- **Line 260:** that 'scripts' might be missing entirely, and the package may

### reify.js

- **Line 301:** that each rollback *also* calls the previous one when it's

### deepest-nesting-target.js

- **Line 7:** this will skip past the first target if edge is peer

### diff.js

- **Line 145:** that if ideal has integrity, and resolved doesn't, we treat
- **Line 189:** we DON'T diff fsChildren themselves, because they are either
- **Line 262:** that moving over a bundled dep will break the links to other

### edge.js

- **Line 110:** this condition means we explicitly do not support overriding

### node.js

- **Line 143:** this *only* works for non-file: deps, so we avoid even
- **Line 220:** this is _slightly_ less efficient for the initial tree
- **Line 853:** the subtle breaking change from v6: it is no longer possible
- **Line 994:** that there are cases where Arborist will opt to insert a node

### optional-set.js

- **Line 8:** that this is *only* going to work with trees where calcDepFlags

### place-dep.js

- **Line 90:** this sets the parent's canPlace as the parent of this
- **Line 301:** if the virtualRoot *doesn't* have the peer, then that means

### query-selector-all.js

- **Line 519:** this uses a Promise.all around a map without in-line concurrency handling
- **Line 861:** this runs over each node and should not throw

### shrinkwrap.js

- **Line 30:** that between this.add() and this.commit(), `this.data` will be out of
- **Line 86:** name is included if necessary, for alias packages

### definition.js

- **Line 178:** these are not quite the same as the description printed

### index.js

- **Line 393:** we pull registry without restricting to the current 'where' because we want to
- **Line 804:** not encrypted, no idea why we bothered to do this, but oh well

### set-envs.js

- **Line 99:** this doesn't afect the *current* node process, of course, since

### index.js

- **Line 89:** the first or second parameter must be a static version or range

### field_behavior.js

- **Line 11:** This enum **may** receive new values in the future.

### entry-index.js

- **Line 126:** - Cleverness ahoy!

### index.js

- **Line 59:** `iterator.next()` can be called many times in parallel.
- **Line 145:** We *must* do this for async iterators otherwise we'll spin up

### read-entry.js

- **Line 65:** gnutar and bsdtar treat unrecognized types as 'File'

### strip-absolute-path.js

- **Line 5:** that windows will think that //x/y/z/a has a "root" of //x/y, and in

### unpack.js

- **Line 97:** that on windows, we always drop the entire cache whenever a

### dbcs-codec.js

- **Line 284:** '>>> 0' keeps 32-bit num positive.

### utf32.js

- **Line 123:** codepoint is a signed int32 and can be negative.
- **Line 124:** We copied this block from below to help V8 optimize it (it works with array, not buffer).
- **Line 156:** codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.

### index.js

- **Line 135:** Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add

### streams.js

- **Line 5:** Due to 'stream' module being pretty large (~100Kb, significant in browser environments),

### entry.js

- **Line 15:** we will also store any request headers
- **Line 26:** we must not store the real response's age header, or when we load
- **Line 311:** we do not set the x-local-cache-hash header because we do not know
- **Line 394:** be sure to remove the headers property from the

### policy.js

- **Line 123:** this is a hack to avoid parsing the cache-control

### fetcher.js

- **Line 172:** that they should *not* calculate or check integrity or cache,
- **Line 189:** cacache will raise a EINTEGRITY error if the integrity doesn't match

### git.js

- **Line 169:** that this does mean that a dependency MAY in theory end up

### registry.js

- **Line 79:** this might be either an in-flight promise for a request,

### is-package-bin.js

- **Line 5:** this is not possible in remote or file fetchers, since

### tar-create-options.js

- **Line 16:** that npm-packlist is already filtering out

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### container.js

- **Line 121:** that this location is relative to the location of the first character

### socksclient.js

- **Line 34:** Supports callbacks and promises. Only supports the connect command.
- **Line 84:** Supports callbacks and promises. Only supports the connect method.
- **Line 85:** Implemented via createConnection() factory function.
- **Line 274:** If the Socks client is not BoundWaitingForConnection or Established, the connection will be closed.
- **Line 482:** As of Tor v0.3.5.7+, if user/pass auth is an option from the client, by default it will always take priority.
- **Line 537:** No auth and user/pass are currently supported.

### store.js

- **Line 169:** that an expired initial root is still considered valid.

### updater.js

- **Line 311:** This may be a slow operation if there are many delegated roles.

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### core.js

- **Line 31:** there is an invariant here that isn't represented in the type system
- **Line 403:** this is not a standard header.
- **Line 426:** the `retry-after-ms` header may not be standard, but is a good idea and we'd like proactive support for it.
- **Line 639:** modified from https://github.com/JS-DevTools/host-environment/blob/b1ab79ecde37db5d6e163c050e54fe7d287d7c92/src/isomorphic.browser.ts
- **Line 644:** The order matters here!
- **Line 689:** this iOS check is untested and may not work

### index.d.ts

- **Line 49:** that request timeouts are retried by default, so in a worst-case scenario you may wait
- **Line 207:** this means you won't be able to use non-deployment endpoints. Not supported with Assistants APIs.

### ChatCompletionStream.js

- **Line 38:** that messages sent to the model do not appear in `.on('message')`

### EventStream.js

- **Line 161:** _emit('error', error) should only be called from #handleError().

### Util.js

- **Line 16:** TS was complaining about using `.filter().map()` here for some reason

### net.d.ts

- **Line 48:** this will cause the streaming functionality to not provide any data, however events like 'error', 'end', and 'close' will

### transcriptions.d.ts

- **Line 288:** Streaming is not supported for the `whisper-1` model and will be ignored.

### assistants.d.ts

- **Line 552:** that the file search tool may output fewer than `max_num_results` results.

### realtime.d.ts

- **Line 1386:** that the server sets default instructions which will be used if this field
- **Line 1702:** that once a session has been initialized with a particular `model`, it

### threads.d.ts

- **Line 358:** that the overlap must not exceed half of `max_chunk_size_tokens`.

### completions.d.ts

- **Line 367:** ** If the stream is interrupted or cancelled, you may not receive the
- **Line 836:** ** If the stream is interrupted, you may not receive the final usage

### completions.d.ts

- **Line 159:** that <|endoftext|> is the document separator that the model sees during
- **Line 171:** ** Because this parameter generates many completions, it can quickly

### permissions.d.ts

- **Line 6:** ** Calling this endpoint requires an [admin API key](../admin-api-keys).
- **Line 24:** ** This endpoint requires an [admin API key](../admin-api-keys).

### models.d.ts

- **Line 22:** no pagination actually occurs yet, this is for forwards-compatibility.

### file-batches.d.ts

- **Line 36:** this will return even if one of the files failed to process, you need to

### files.js

- **Line 72:** this will return even if the file failed to process, you need to check
- **Line 112:** the file will be asynchronously processed (you can use the alternative

### ChatCompletionStream.ts

- **Line 736:** we do not include an "object" type on the snapshot,

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### unicode.js

- **Line 99:** excluding NULL and ASCII whitespace

### preprocessor-mixin.js

- **Line 16:** avoid reporting error twice on advance/retreat

### parser-mixin.js

- **Line 43:** For cases like <p> <p> </p> - First 'p' closes without a closing
- **Line 86:** generate location info for elements
- **Line 103:** <body> and <html> are never popped from the stack, so we need to updated
- **Line 140:** _attachElementToTree is called from _appendElement, _insertElement and _insertTemplate methods.
- **Line 183:** store last foster parenting location, so we will be able to find inserted text
- **Line 209:** if we have location assigned by another token, then just update end position

### tokenizer-mixin.js

- **Line 93:** if we have pending character token make it's end location equal to the
- **Line 117:** if we have character token and it's location wasn't set in the _emitCurrentToken(),
- **Line 132:** patch initial states for each mode to obtain token start position

### preprocessor-mixin.js

- **Line 25:** LF should be in the last column of the line

### formatting-element-list.js

- **Line 59:** build attrs map for the new element so we can perform fast lookups
- **Line 81:** remove bottommost candidates until Noah's Ark condition will not be met

### index.js

- **Line 350:** use <template> element as a fragment context if context element was not provided,
- **Line 356:** create fake element which will be used as 'document' for fragment parsing.
- **Line 939:** store next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 1042:** do nothing =)
- **Line 1389:** If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
- **Line 1583:** here we assume that we always act as an user agent with enabled plugins, so we parse

### open-element-stack.js

- **Line 257:** here we assume that root <html> element is always first in the open element stack, so

### index.js

- **Line 163:** used in tests and by rewriting stream

### index.js

- **Line 176:** String.fromCharCode() function can handle only characters from BMP subset.
- **Line 434:** store emited start tag's tagName to determine is the following end tag token is appropriate.
- **Line 502:** used then we emit character explicitly. This is always a non-whitespace and a non-null character.
- **Line 522:** we use greedy search, so we continue lookup at this point
- **Line 1402:** sequence lookup can be abrupted by hibernation. In that case lookup
- **Line 2026:** matching can be abrupted by hibernation. In that case match

### named-entity-data.js

- **Line 3:** this file contains auto-generated array mapped radix tree that is used for the named entity references consumption

### preprocessor.js

- **Line 13:** HTML input preprocessing
- **Line 33:** err reporting is noop by default. Enabled by mixin.
- **Line 42:** try to peek a surrogate pair
- **Line 47:** we have a surrogate pair. Peek pair character and recalculate code point.
- **Line 50:** add gap that should be avoided during retreat
- **Line 57:** we are at the end of a chunk, therefore we can't infer surrogate pair yet.
- **Line 63:** isolated surrogate
- **Line 108:** any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character
- **Line 116:** all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### index.js

- **Line 85:** this function must be synchronous.

### readable.js

- **Line 163:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 439:** that this may be asynchronous, or synchronous.  Yes, it is

### writable.js

- **Line 83:** 0 is a valid value, means that we always return false if

### redact.bench.js

- **Line 33:** that "redact me." is the same amount of bytes as the censor: "[Redacted]"

### proto.js

- **Line 52:** use of class is satirical

### redaction.js

- **Line 52:** "b.z" is in both "a" and * arrays because "a" matches the wildcard.

### pino.d.ts

- **Line 92:** When browserified, this functionality will only be available if the `events` module has been required elsewhere
- **Line 117:** Does not overwrite bindings. Can potentially result in duplicate keys in log lines.

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### index.js

- **Line 160:** we intentionally leave the stream paused,

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### rollup.d.ts

- **Line 128:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 389:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 6637:** this doesn't skip properties with defined getters/setters which we use to pack wrap booleans
- **Line 9618:** that class fields do not end up on the prototype
- **Line 12853:** that we use posix.join because:
- **Line 14336:** that unknown test values are always included

### index.js

- **Line 24:** 'error' and 'ready' events emitted below only relevant when sonic.sync===false

### HelperManager.js

- **Line 36:** that TypeScript and Babel do this differently; TypeScript does a simple existence

### flow.js

- **Line 351:** bracketL has already been consumed
- **Line 363:** both bracketL have already been consumed

### types.js

- **Line 26:** These "type casts" are *not* valid TS expressions.

### typescript.js

- **Line 75:** TypeScript's implementation is much more complicated because
- **Line 241:** In TypeScript implementation we must provide `yieldContext` and `awaitContext`,
- **Line 824:** TS uses parseLeftHandSideExpressionOrHigher,
- **Line 993:** this won't be called unless the keyword is allowed in `shouldParseExportDeclaration`.
- **Line 1466:** The reason we do this in `parseIdentifierStatement` and not `parseStatement`
- **Line 1544:** When the JSX plugin is on, type assertions (`<T> x`) aren't valid syntax.

### statement.js

- **Line 175:** falls through to _var
- **Line 265:** that this can happen either in place of a regular variable declaration

### RootTransformer.js

- **Line 80:** that we always want to enable the imports transformer, even when the import transform

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 747:** ending in / means that we'll get a final ""

### get.d.ts

- **Line 125:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 5:** The return value has to be `any` and not `unknown` so it can match `void`.
- **Line 67:** The use of tuples in this first condition side-steps distributive conditional types

### mapping-list.js

- **Line 41:** The order of the mappings is NOT guaranteed.

### read-wasm.js

- **Line 3:** This file is replaced with "read-wasm-browser.js" when this module is

### url.js

- **Line 9:** This file is overridden in the 'package.json#browser' field to

### index.js

- **Line 64:** that http://stackoverflow.com/a/4467559/3191 does NOT work for large modulos

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### output.js

- **Line 101:** includes "all" option

### propmangle.js

- **Line 190:** debug is either false (disabled), or a string of the debug suffix to use (enabled).
- **Line 191:** debug may be enabled as an empty string, which is falsy. Also treat passing 'true'

### stringify.js

- **Line 19:** Be careful editing this code!  It's been tuned for performance
- **Line 22:** to future-self: No, you can't remove the `toLowerCase()` call.

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### ponyfill.d.ts

- **Line 202:** that the chunks seen in each branch will be the same object. If the chunks are not immutable,
- **Line 757:** that the lock can still be released even if some ongoing writes have not yet finished (i.e. even if the
- **Line 769:** that what "success" means is up to the underlying sink; it might indicate simply that the chunk has been

### parser.js

- **Line 53:** May modify input array

### types.d.ts

- **Line 88:** this is required if nodeClass is not provided.

### base.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

### schemas.js

- **Line 811:** `Missing required key: "Key"`,

## OPTIMIZE Items (3)

### events.js

- **Line 190:** the case of one listener. Don't need the extra array object.

### index.js

- **Line 91:** for Arrays. Big arrays could kill the performance otherwise!

### index.js

- **Line 249:** for compressibility

## REVIEW Items (11)

### types.d.ts

- **Line 2861:** requests to access organization resources with fine-grained personal access tokens
- **Line 2870:** a request to access organization resources with a fine-grained personal access token
- **Line 4410:** custom deployment protection rules for a workflow run
- **Line 4472:** pending deployments for a workflow run
- **Line 7690:** comments are in ascending order by ID.
- **Line 24253:** Requested Issue Event
- **Line 24271:** Request Removed Issue Event
- **Line 24289:** Dismissed Issue Event

### sequential_chain.d.ts

- **Line 39:** from a New York Times play critic of the above play:`,
- **Line 127:** from a New York Times play critic of the above play:`

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

## TODO Items (418)

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### ajv.bundle.js

- **Line 6248:** normalize IPv6 address as per RFC 5952

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### formatter.js

- **Line 10:** add [additonal formatters][1]

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### chat_models.js

- **Line 177:** Function messages do not support array content, fix cast
- **Line 426:** add support for `addLangChainErrorFields`

### embeddings.js

- **Line 46:** Update to `false` on next minor release (see: https://github.com/langchain-ai/langchainjs/pull/3612)

### index.js

- **Line 129:** type `octokit.auth` based on passed options.authStrategy

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### glob-assets.js

- **Line 18:** Temporary workaround for https://github.com/mrmlnc/fast-glob/issues/47

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 759:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### agent.js

- **Line 196:** need to fix on node itself

### code.js

- **Line 124:** do not allow arrays here

### index.js

- **Line 34:** refactor - remove compilations
- **Line 38:** if getFullPath removed 1 tests fails
- **Line 58:** can its length be used as dataLevel if nil is removed?
- **Line 135:** maybe localRefs should hold SchemaEnv
- **Line 162:** returns AnySchemaObject (if the schema can be inlined) or validation function
- **Line 178:** `Object.keys(root.schema).length > 0` should not be needed - but removing breaks 2 tests
- **Line 223:** PREVENT_SCOPE_CHANGE could be defined in keyword def?

### parse.js

- **Line 270:** loopEnum

### resolve.js

- **Line 7:** refactor to use keyword definitions

### util.js

- **Line 6:** refactor to use Set
- **Line 164:** maybe use global escapePointer

### boolSchema.js

- **Line 37:** maybe some other interface should be used for non-keyword validation errors...

### dataType.js

- **Line 126:** use gen.property

### index.js

- **Line 76:** maybe some hook to execute it in the end to check whether props/items are Name, as in assignEvaluated
- **Line 165:** assign unevaluated
- **Line 185:** typecast
- **Line 210:** make it "ok" call?
- **Line 427:** value.code for standalone

### keyword.js

- **Line 93:** add tests

### subschema.js

- **Line 56:** something is possibly wrong here with not changing parentDataProperty and not appending dataPathArr

### core.js

- **Line 374:** return type should be Ajv
- **Line 455:** atm it is allowed to overwrite schemas without id (instead of not adding them)
- **Line 501:** tests fail without this line

### additionalItems.js

- **Line 35:** var

### dependencies.js

- **Line 15:** change to reference

### oneOf.js

- **Line 26:** possibly fail straight away (with warning or exception) if there are two empty always valid schemas

### ref.js

- **Line 71:** will not work with async, it has to be returned with the result
- **Line 87:** tagged

### dynamicRef.js

- **Line 26:** the assumption here is that `recursiveRef: #` always points to the root

### format.js

- **Line 31:** simplify

### properties.js

- **Line 130:** maybe an option instead of hard-coded 8?

### pattern.js

- **Line 17:** regexp should be wrapped in try/catchs

### index.ts

- **Line 78:** possibly, it should be readonly

### subschema.ts

- **Line 8:** use Optional? align with SchemCxt property types

### core.ts

- **Line 394:** allow passing schema URI

### jtd-schema.ts

- **Line 138:** we can't actually check that everything in the union was specified
- **Line 187:** currently allows descriminator to be present in schema
- **Line 205:** these should only be allowed at the top level

### dependencies.ts

- **Line 19:** change to string[]

### constants.js

- **Line 3:** increment this version if there are schema changes

### json.js

- **Line 77:** maybe make this configurable or part of "strict" option

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### handler.js

- **Line 70:** emit errors properly. Example: EMFILE on Macos.

### index.js

- **Line 107:** this is not equal to path-normalize module - investigate why
- **Line 203:** what if stats is undefined? remove !
- **Line 309:** (43081j): make this more efficient.

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### cell.js

- **Line 169:** cells should always exist - some tests don't fill it in though

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### writerOpts.js

- **Line 130:** investigate why this code exists.

### basic.d.ts

- **Line 24:** Make it this when targeting TypeScript 4.1:

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### request.js

- **Line 452:** change req.host to return host in next major

### browser.js

- **Line 36:** add a `localStorage` variable to explicitly enable/disable colors

### test-stable.js

- **Line 260:** This is a known limitation of the current implementation.

### uri-js.test.ts

- **Line 734:** Verify this

### index.js

- **Line 10:** Remove the `...` when https://github.com/tc39/proposal-iterator-helpers is available.

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### index.js

- **Line 5:** Document the `context` option and add to types when I know it's something I want to keep.

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### index.js

- **Line 15:** Remove the `.reduce` call.

### index.js

- **Line 246:** Make it return a web stream at some point.

### index.d.ts

- **Line 66:** replace Function with actual signature

### core.js

- **Line 653:** We need negative look-behind support to do this properly
- **Line 2221:** remove with version 11.0
- **Line 2253:** remove v12, deprecated
- **Line 2404:** remove with v12
- **Line 2474:** Remove with v12 API

### ada.js

- **Line 49:** These spaces are not required by the Ada syntax

### elm.js

- **Line 25:** other constructors (built-in, infix).

### haml.js

- **Line 9:** support filter tags like :javascript, support inline HTML

### haskell.js

- **Line 37:** other constructors (build-in, infix).
- **Line 158:** characters.

### java.js

- **Line 101:** can this be removed somehow?

### julia.js

- **Line 366:** neatly escape normal code in string literal

### less.js

- **Line 129:** find a better solution?

### llvm.js

- **Line 90:** split into different categories of keywords

### markdown.js

- **Line 48:** fix to allow these to work with sublanguage also

### powershell.js

- **Line 66:** 'validate[A-Z]+' can't work in keywords

### python.js

- **Line 159:** Could these be supplemented by a CamelCase matcher in certain

### r.js

- **Line 194:** replace with negative look-behind when available

### swift.js

- **Line 273:** The following characters are also allowed, but the regex isn't supported yet.
- **Line 475:** Update for leading `-` after lookbehind is supported everywhere
- **Line 809:** Interpolation can contain any expression, so there's room for improvement here.

### vbnet.js

- **Line 151:** Use `beforeMatch:` for leading spaces
- **Line 159:** Use `beforeMatch:` for indentation once available

### yaml.js

- **Line 141:** remove |$ hack when we have proper look-ahead support

### index.d.ts

- **Line 107:** Old API, remove with v12

### dbcs-codec.js

- **Line 348:** What if we have no default? (resCode == undefined)
- **Line 472:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### extend-node.js

- **Line 169:** Set _charsWritten.

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 365:** check & read HasteFS instead of reading the filesystem:

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### agent.js

- **Line 82:** Remove in the future. Only for backwards compatibility.
- **Line 213:** Rename input to "intermediate_steps"

### executor.js

- **Line 299:** Update BaseChain implementation on breaking change
- **Line 339:** Update BaseChain implementation on breaking change to include this
- **Line 662:** Deprecate these other parameters

### index.js

- **Line 234:** Add .bind to core runnable interface.

### conversational_retrieval_chain.js

- **Line 160:** Deprecate on a breaking release

### retrieval.js

- **Line 41:** Fix typing by adding withConfig to core RunnableInterface

### generative_agent_memory.js

- **Line 228:** Mock "now" to simulate different times
- **Line 512:** clear memory contents

### generative_agent.js

- **Line 43:** Add support for daily summaries

### node.js

- **Line 3:** Make this the default, add web entrypoint in next breaking release

### runner_utils.js

- **Line 405:** Parallelize and/or put in callbacks to speed up evals.
- **Line 537:** Collect the runs as well.
- **Line 542:** Insert evaluation inline for immediate feedback.

### sql_db.js

- **Line 131:** Potential security issue here

### axios-fetch-adapter.js

- **Line 155:** this needs to be fixed to run in newer browser-like environments

### client.js

- **Line 1013:** Untangle types
- **Line 1090:** make dotted order required when the migration finishes
- **Line 1571:** Add a head request

### _runner.js

- **Line 714:** Deprecate this and rely on interop on 0.2 minor bump.
- **Line 824:** fix this by porting LangChainStringEvaluator to langsmith sdk
- **Line 836:** Remove this, handle outside the manager
- **Line 851:** this is `any`. does it work properly?

### evaluate_comparative.js

- **Line 90:** add URL to the comparative experiment

### langchain.js

- **Line 23:** CallbackManager.configure() is only async due to LangChainTracer

### run_trees.js

- **Line 261:** Deprecate

### traceable.js

- **Line 281:** deal with possible nested promises and async iterables

### index.js

- **Line 456:** Create or update the example in the background

### vercel.js

- **Line 513:** add first_token_time
- **Line 649:** Figure out why this happens.

### magic-string.cjs.js

- **Line 131:** is this block necessary?...
- **Line 830:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 1310:** there's a bunch of this sort of thing, needs cleaning up

### index.d.ts

- **Line 1300:** Remove this in meow 14.

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### mime_cli.ts

- **Line 13:** Use json imports to access package.json once "import attributes" are

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### async.js

- **Line 2903:** size could be changed

### index.js

- **Line 151:** Replace everything below with `urlObject.pathname = urlObject.pathname.replace(/(?<!\b[a-z][a-z\d+\-.]{1,50}:)\/{2,}/g, '/');` when Safari supports negative lookbehind.

### npx-cli.js

- **Line 9:** remove the affordances for removed items in npm v9

### cache.js

- **Line 82:** - eventually...

### completion.js

- **Line 178:** this was dead code, leaving it in case we find some command we
- **Line 214:** Ignoring coverage, see 'non EPIPE errors cause failures' test.

### config.js

- **Line 128:** complete with valid values, if possible.

### doctor.js

- **Line 118:** when we have an in progress indicator that could go here
- **Line 328:** display layer should do this

### fund.js

- **Line 80:** add !workspacesEnabled option handling to libnpmfund

### link.js

- **Line 165:** write tests for unmatching version specs, this is hard to test

### ls.js

- **Line 300:** there is a LOT of overlap with lib/utils/explain-dep.js here

### outdated.js

- **Line 121:** normalize usage of edges and avoid looping through nodes here

### pkg.js

- **Line 77:** https://github.com/npm/cli/issues/5508 a raw mode has been requested similar

### rebuild.js

- **Line 34:** when extending ReifyCmd
- **Line 78:** add tests for a package with missing version

### npm.js

- **Line 89:** should we throw here?

### display.js

- **Line 390:** this could probably be moved to arborist now that display is refactored

### get-workspaces.js

- **Line 12:** we need a better error to be bubbled up here if this call fails

### reify-output.js

- **Line 19:** output JSON if flatOptions.json is true

### build-ideal-tree.js

- **Line 364:** make buildIdealTree() and loadActual handle a missing root path,
- **Line 533:** create synthetic test case to simulate realpath failure
- **Line 550:** provide a way to fix bundled deps by exposing metadata about
- **Line 1217:** post arborist refactor, will need to check for installStrategy=linked

### index.js

- **Line 94:** we only ever look at this.options.replaceRegistryHost, not
- **Line 110:** We should change these to static functions instead
- **Line 145:** why is includeWorkspaceRoot a param?
- **Line 146:** why is workspaces a param?

### isolated-reifier.js

- **Line 112:** this approach feels wrong
- **Line 166:** make sure that idealTree object exists
- **Line 168:** test workspaces having bundled deps
- **Line 264:** we should probably not reference this.idealTree
- **Line 277:** We should mock better the inventory object because it is used by audit-report.js ... maybe
- **Line 388:** we should no-op is an edge has already been created with the same fromKey and toKey

### load-actual.js

- **Line 58:** remove options param in next semver major

### rebuild.js

- **Line 371:** these run before they're awaited

### reify.js

- **Line 57:** tests should not be this deep into internals
- **Line 330:** rollbacks shouldn't be relied on to throw err
- **Line 1525:** this ignores options.save

### can-place-dep.js

- **Line 366:** represent peerPath in ERESOLVE error somehow?

### node.js

- **Line 122:** if this came from pacote.manifest we don't have to do this,

### query-selector-all.js

- **Line 724:** Need a test with an infinite loop
- **Line 805:** (future) loop over ancestry property

### shrinkwrap.js

- **Line 153:** limit concurrency here, this is recursive
- **Line 212:** what uses this?
- **Line 436:** emit a warning here or something if both are present.

### vuln.js

- **Line 62:** duped entries may require different fixes but the current

### definition.js

- **Line 5:** some kind of categorization system, so we can

### definitions.js

- **Line 87:** refactor these type definitions so that they are less
- **Line 89:** use better type definition/validation API, nopt's is so weird.
- **Line 2253:** this is a derived value, and should be reworked when we have a

### index.js

- **Line 6:** make these getters so that we only have to make dirty
- **Line 10:** move nerfdart auth stuff into a nested object that
- **Line 37:** when we switch off of nopt, use an arg parser that supports

### index.js

- **Line 1:** set the scope config from package.json or explicit cli config
- **Line 821:** evaluate removing 'email' from the credentials object returned here

### type-defs.js

- **Line 60:** make nopt less of a global beast so this kludge isn't necessary

### normalize.js

- **Line 446:** exports is much more complicated than this in verbose format

### diff.js

- **Line 113:** Remove the `+ 1` here to make behavior match Myers algorithm

### index.js

- **Line 81:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### init-package-json.js

- **Line 48:** test for non-default definitions

### ipv6.js

- **Line 301:** probably useful to have a numeric version of this too
- **Line 530:** Improve the semantics of this helper function
- **Line 549:** Make private?
- **Line 949:** revisit why this is necessary

### index.js

- **Line 1289:** allow reseeding after first request

### index.js

- **Line 7:** we test this condition in the diff command

### entry.js

- **Line 298:** if the cache write fails, log a warning but return the response anyway

### index.js

- **Line 36:** remove when Node v8 support drops

### fetcher.js

- **Line 251:** check error class, once those are rolled out to our deps

### git.js

- **Line 225:** after cloning, create a tarball of the folder, and add to the cache

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### read.js

- **Line 16:** add tests for edit
- **Line 32:** add tests for timeout
- **Line 41:** add tests for edit + default
- **Line 57:** add tests for rejecting
- **Line 66:** add tests for silent
- **Line 73:** add tests for default
- **Line 79:** add tests for sigint

### cert.js

- **Line 142:** test coverage for this case

### entry.js

- **Line 23:** Remove this parameter once have completely switched to 'dsse' entries
- **Line 27:** Remove this conditional once have completely ditched "intoto" entries

### certificate.js

- **Line 113:** Add support for authorityCertIssuer/authorityCertSerialNumber

### index.js

- **Line 9:** this should really be a hardcoded list of algorithms we support,
- **Line 568:** - it's unclear _which_ of these Node will actually use as its name

### mkdir.js

- **Line 4:** This should probably be a class, not functionally

### updater.js

- **Line 251:** use length for fetching

### core.js

- **Line 55:** handle blob, arraybuffer, other content types, etc.
- **Line 629:** add support for Cloudflare workers, etc.

### AbstractChatCompletionRunner.js

- **Line 310:** support audio here

### EventEmitter.js

- **Line 65:** handle errors

### events.d.ts

- **Line 425:** These should be described using static getter/setter pairs:

### streaming.js

- **Line 58:** Is this where the error should be thrown?

### uploads.js

- **Line 153:** make nested formats configurable

### index.js

- **Line 56:** Node.js 18.

### index.js

- **Line 82:** remove this in the next major version

### index.js

- **Line 43:** Use native `finally` keyword when targeting Node.js 10

### compose.js

- **Line 75:** (ronag): highWaterMark?

### destroy.js

- **Line 262:** Remove isRequest branches.
- **Line 273:** Don't lose err?

### end-of-stream.js

- **Line 73:** (ronag): Improve soft detection to include core modules and

### readable.js

- **Line 940:** (ronag): Should this.destroy(err) emit

### transform.js

- **Line 77:** (ronag): This should preferably always be
- **Line 89:** (ronag): 0 is not optimal since we have

### basic.test.ts

- **Line 432:** 2019-03-30 -- We don't really want the indentation in this case? Or at least some better formatting.

### redaction.js

- **Line 13:** should this be configurable?

### transport-stream.js

- **Line 19:** add support for the TSM modules loader ( https://github.com/lukeed/tsm ).
- **Line 25:** Support ES imports once tsc, tap & ts-node provide better compatibility guarantees.

### worker.js

- **Line 42:** manage backpressure
- **Line 50:** handle backpressure

### pino.d.ts

- **Line 27:** https://github.com/pinojs/thread-stream/issues/24
- **Line 316:** why is this different from `obj: object` or `obj: any`?

### core.test.ts

- **Line 86:** add case for non-pipelined single target (needs changes in thread-stream)

### module-link.test.ts

- **Line 41:** make this test pass on Windows

### pino-top-export.test-d.ts

- **Line 30:** currently returns (aliased) `any`, waiting for strong typed `thread-stream`

### doc.js

- **Line 1246:** Remove this in v4

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### test.js

- **Line 105:** Should we be stricter and perform validation?

### index.js

- **Line 86:** isn't this wrong?

### _stream_writable.js

- **Line 289:** defer error events consistently everywhere, not just the cb

### index.js

- **Line 7504:** real check
- **Line 7992:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-

### rollup.js

- **Line 19065:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 139:** throws or warn? Currently just ignore, uses new event

### index.js

- **Line 85:** look into also checking the `bugs`/`homepage` URLs

### range.js

- **Line 489:** build?

### test.js

- **Line 46:** Uncomment once #157 is resolved

### write.test.ts

- **Line 142:** refactor

### parse.js

- **Line 46:** Actually, everything is concatenated into one string

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### cli.js

- **Line 248:** read exclude

### typescript.js

- **Line 58:** actually a bit more complex in TypeScript, but shouldn't matter.
- **Line 78:** Would be nice to avoid lookahead. Want a hasLineBreakUpNext() method...

### TokenProcessor.js

- **Line 78:** We need to process escapes since technically you can have unicode escapes in variable

### JestHoistTransformer.js

- **Line 37:** This only works if imports transform is active, which it will be for jest.

### CJSImportTransformer.d.ts

- **Line 50:** This function has some awkward overlap with

### getImportExportSpecifierInfo.d.ts

- **Line 31:** There's some redundancy with the type detection here and the isType

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### index.js

- **Line 10:** Use `node:stream/promises` when targeting Node.js 16.

### bench.js

- **Line 81:** figure out why it does not shut down

### index.js

- **Line 229:** (fix): Make private?
- **Line 230:** (fix): make private
- **Line 295:** write all .buf
- **Line 305:** handle deadlock
- **Line 524:** stream timeouts for some reason.

### index.js

- **Line 3:** use call-bind, is-date, is-regex, is-string, is-boolean-object, is-number-object
- **Line 12:** use isarray
- **Line 17:** use for-each?
- **Line 26:** use object-keys
- **Line 36:** use reflect.ownkeys and filter out non-enumerables
- **Line 52:** use object.hasown
- **Line 321:** replace with object.assign?

### super_deep.js

- **Line 52:** this one

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### rollup.js

- **Line 4335:** deprecate this? not really very useful

### index.js

- **Line 109:** make this more efficient

### url-state-machine.js

- **Line 1074:** If c is not a URL code point and not "%", parse error.
- **Line 1096:** Add: not a URL code point
- **Line 1121:** Use encoding override instead

### urlencoded.js

- **Line 107:** handle encoding override

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### URL-impl.js

- **Line 24:** query stuff

### addPairToJSMap.js

- **Line 12:** Should drop this special case for bare << handling

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### base.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### schemas.d.ts

- **Line 60:** unions?

### index.ts

- **Line 5:** Implement multi-modal content generation capabilities (text, images, diagrams)
- **Line 6:** Add personalization engine for content tailoring based on client profile
- **Line 7:** Implement brand consistency enforcement for generated content
- **Line 8:** Create AI-powered document analysis with improved accuracy
- **Line 9:** Add automated compliance checking for generated RFP responses

### CompanyKnowledgeBase.ts

- **Line 2:** Create comprehensive test suite for CompanyKnowledgeBase

### CompetitiveAnalysisEngine.ts

- **Line 2:** Create comprehensive test suite for CompetitiveAnalysisEngine

### RFPContentGenerator.ts

- **Line 8:** Implement multi-modal content generation (text, images, charts, diagrams)
- **Line 9:** Create personalization engine for client-specific content adaptation
- **Line 10:** Add brand consistency enforcement across all generated content
- **Line 11:** Implement regulatory compliance checking with automated validation
- **Line 12:** Create accessibility standards compliance for all generated content

### ml-integration.ts

- **Line 10:** Create comprehensive test suite for ML Integration Module

### free-model-service.js

- **Line 58:** Implement actual free model integration

### model-dispatcher.ts

- **Line 5:** Implement multimodal content generation capabilities (text, images, diagrams)
- **Line 6:** Create personalization engine for tailoring content based on client profiles
- **Line 7:** Add brand consistency enforcement through prompt augmentation
- **Line 8:** Implement detailed content analysis with semantic understanding
- **Line 9:** Add automated compliance checking for content generation

## XXX Items (77)

### node.js

- **Line 163:** It's lame that node doesn't expose this API out-of-the-box. It also

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### index.js

- **Line 137:** this is incorrect. we have multicharacter flags like `-iwr` that

### cache.js

- **Line 140:** this could leave other entries without content!

### ci.js

- **Line 109:** should we remove this finally??

### doctor.js

- **Line 164:** get the latest in the current major as well

### fund.js

- **Line 24:** maybe worth making this generic for all commands?

### help.js

- **Line 17:** these are used in the docs workspace and should be exported

### publish.js

- **Line 194:** can't pacote read the manifest from a directory?

### team.js

- **Line 44:** "description" option to libnpmteam is used as a description of the

### package-url-cmd.js

- **Line 26:** It is very odd that `where` is how pacote knows to look anywhere

### display.js

- **Line 328:** in a future (breaking?) change it might make sense for run-script to

### error-message.js

- **Line 386:** we should stop throwing strings
- **Line 395:** we should stop throwing other non-errors

### build-ideal-tree.js

- **Line 559:** this belongs in the audit report itself, not here.
- **Line 583:** how to handle top nodes that aren't the root?  Maybe the report
- **Line 649:** this could be faster by doing a series of inventory.query('name')
- **Line 652:** add any invalid edgesOut to the queue
- **Line 753:** also push anything that depends on a node with a name
- **Line 1006:** This is somehow load bearing.  This makes tests that print

### load-actual.js

- **Line 71:** deprecate separate method options objects.

### load-virtual.js

- **Line 37:** deprecate separate reify() options object.

### reify.js

- **Line 413:** if we have an existing diff already, there should be a way
- **Line 832:** use a magic string that isn't also a valid value, like

### edge.js

- **Line 55:** where is this used?
- **Line 66:** are all of these error states even possible?

### node.js

- **Line 1009:** need to check for two root nodes?

### place-dep.js

- **Line 42:** this only appears to be used by tests
- **Line 237:** if we are replacing SOME of a peer entry group, we will need to
- **Line 335:** handle replacing an entire peer group?
- **Line 510:** decorate more with this.canPlace and this.canPlaceSelf,

### shrinkwrap.js

- **Line 203:** this is duplicated in this.load(), but using loadFiles instead of resetFiles
- **Line 577:** is this even reachable?
- **Line 872:** why is this different from pathFixed in this.add??

### definitions.js

- **Line 127:** We should really deprecate all these `--save-blah` switches
- **Line 1665:** update arborist to just ignore it if resulting saveType is peer

### errors.js

- **Line 10:** context.code is undefined in all constructors used in cp/polyfill

### advisory.js

- **Line 267:** if bundled, then semver.intersects() means vulnerable

### normalize.js

- **Line 609:** should a future breaking change delete bin entries that cannot be accessed?

### set-path.js

- **Line 21:** we should specify a cwd that we don't go above
- **Line 33:** include the node-gyp-bin path somehow?  Probably better for

### pax.js

- **Line 54:** split the path
- **Line 134:** Values with \n in them will fail this.

### unpack.js

- **Line 678:** get the type ('symlink' or 'junction') for windows

### browser.js

- **Line 208:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 262:** DO NOT USE. This is a temporary stub function.
- **Line 263:** It WILL be removed in the next major release.

### helpers.js

- **Line 18:** Use #base-2 .value-0 instead?

### get-bin-from-manifest.js

- **Line 10:** probably a util to parse this better?
- **Line 16:** need better error message

### index.js

- **Line 18:** this should really be split up and unit-ized for easier testing

### install.js

- **Line 42:** use a different footer line if some aren't fixable easily.

### npa.js

- **Line 259:** backwards compatibility lack of compliance with RFC 8089
- **Line 275:** end RFC 8089 violation backwards compatibility section

### fetcher.js

- **Line 101:** fill more of this in based on what we know from this.opts

### git.js

- **Line 103:** make this a custom error class

### registry.js

- **Line 47:** pacote <=9 has some logic to ignore opts.resolved if
- **Line 136:** add ETARGET and E403 revalidation of cached packuments here

### index.js

- **Line 147:** remove v.length check to remove cb from functions
- **Line 149:** if cb is no longer an argument then this.#ctx should
- **Line 165:** remove this to require throwing an error instead of

### list.js

- **Line 3:** This shares a lot in common with extract.js

### test.js

- **Line 354:** 80');
- **Line 355:** 1337');
- **Line 362:** 443');
- **Line 370:** 70');
- **Line 374:** 21');

### preload.js

- **Line 3:** remove in v8 or beyond

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### ast.js

- **Line 483:** abstract out this map method

### index.js

- **Line 699:** remove this slice.  Just pass the start index.

### source-map-consumer.js

- **Line 305:** keep these error codes in sync with `fitzgen/source-map-mappings`.

### compress.js

- **Line 12099:** intentionally falling down to the next case

### output.js

- **Line 1947:** I'm not exactly sure if we need it for all of these nodes,

