# Roadmap

_Generated on 2025-05-30_

Found 1351 TODO items in the codebase.

## BUG Items (4)

### index.js

- **Line 12:** 1: Safari 10/11 doesn't reliably return the same Strings value.
- **Line 18:** 2: Safari 10/11 use the same cached strings value when the string parts are the same.

### dns.d.ts

- **Line 114:** in the name resolution service used by the operating system.

### _stream_readable.js

- **Line 996:** in node.  Should never happen.

## FIXME Items (19)

### validate.js

- **Line 15:** https://github.com/ajv-validator/ajv/issues/2132

### dom.umd.js

- **Line 2698:** Including aria-owns is not defined in the spec

### built-in-definitions.js

- **Line 206:** Pure disabled to work around zloirock/core-js#262.

### ejs.js

- **Line 387:** Remove this in a future version
- **Line 746:** May end up with some false positives here

### componentUtil.js

- **Line 70:** Remove try/catch when https://github.com/eslint/eslint-scope/issues/27 is implemented.

### referencer.js

- **Line 62:** Now, we don't create module environment, because the context is

### no-unmodified-loop-condition.js

- **Line 142:** This should probably be extracted to a function.

### return-focus.js

- **Line 9:** remove in 2025

### haml.js

- **Line 20:** these comments should be allowed to span indented lines

### less.js

- **Line 490:** it does not include dot for numbers like .5em :(

### r.js

- **Line 50:** Support Unicode identifiers.

### jake.js

- **Line 237:** Should only need to add a new entry for the current

### rule.js

- **Line 79:** Right now this just throws away any passed-in args
- **Line 154:** Should allow optional ns passed in instead of this hack

### default-stylesheet.js

- **Line 413:** Remove when tabs work with optimizeLegibility.

### profile.js

- **Line 201:** Work around to not clear everything other than what we're setting

### query.js

- **Line 92:** Workspace support in query does not work as expected so this does not

### parse.js

- **Line 320:** what if this '{' is in the url text of the match function?

## HACK Items (16)

### TimeZoneString.js

- **Line 35:** until LocalTZA, and "implementation-defined string" are available

### TimeZoneString.js

- **Line 38:** until DefaultTimeZone, IsTimeZoneOffsetString, ParseTimeZoneOffsetString, GetNamedTimeZoneOffsetNanoseconds, and "implementation-defined string" are available

### capnproto.js

- **Line 45:** eating everything after the first title

### htmlbars.js

- **Line 337:** This lets handlebars do the auto-detection if it's been loaded (by

### qml.js

- **Line 213:** prevents detection of keywords after dots

### stan.js

- **Line 507:** in range constraints, lower must follow "<"
- **Line 512:** in range constraints, upper must follow either , or <

### typescript.js

- **Line 556:** prevents detection of keywords in some circumstances

### minimatch.js

- **Line 590:** to work around lack of negative lookbehind in JS

### Document-impl.js

- **Line 390:** for script execution

### display.js

- **Line 319:** Check if the argument looks like a run-script banner. This can be

### index.js

- **Line 650:** this is an option set in tests to stop the local prefix from being set

### keys-of-union.d.ts

- **Line 41:** to fix https://github.com/sindresorhus/type-fest/issues/1008

### runmain-hack.js

- **Line 3:** to avoid Module.runMain on node 18.6.0

### bin.js

- **Line 59:** technically, this function is not marked @internal so it's possible
- **Line 462:** workaround node regression

## NOTE Items (638)

### util.d.ts

- **Line 4:** comments are stripped, it can be preserved if, in the options param,

### inline-callSuper-helpers.js

- **Line 43:** This doesn't work if this.__proto__.constructor has been modified.

### index.js

- **Line 11:** contrary to various Github issues, Edge 16+ *does* correctly infer the name of Arrow Functions.

### index-legacy.d.ts

- **Line 1:** This file is autogenerated. Do not modify.

### accordion-button.d.ts

- **Line 8:** 🚨: Each accordion button must be wrapped in a heading tag,

### image.d.ts

- **Line 10:** 🚨: We recommend you use a local image

### use-popover.d.ts

- **Line 118:** 🚨: We don't recommend using this in a popover/menu intensive UI or page

### others.d.ts

- **Line 14:** Styles must be located in `theme.layerStyles`
- **Line 19:** Styles must be located in `theme.textStyles`

### pseudos.d.ts

- **Line 44:** When using this, ensure the `content` is wrapped in a backtick.
- **Line 129:** This selector is only applied for block-level elements and not preceded by an image or table.

### jtd-schema.ts

- **Line 33:** see the end of
- **Line 80:** relies on the fact that tuples don't have an index at 0.5, but arrays

### index.js

- **Line 49:** this will only work on the server since it attempts to read the map file

### emotion-cache.browser.development.esm.js

- **Line 474:** this very very intentionally targets all style elements regardless of the key to ensure

### action.js

- **Line 69:** that the difference between the default and nargs=1 is that with the

### append.js

- **Line 23:** options.nargs should be optional for constants

### compiler.js

- **Line 437:** This types are assured to be hoisted prior to this call. Just yield the function.
- **Line 487:** In the case of cyclic types, we need to create a 'functions' record

### extends-check.js

- **Line 450:** RegExp types evaluate as strings, not RegExp objects.

### intrinsic.js

- **Line 32:** template literals require special runtime handling as they are encoded in string patterns.

### convert.js

- **Line 88:** this function may return an invalid dates for the regex

### create.js

- **Line 152:** The best we can do here is attempt to instance each

### default.js

- **Line 75:** we need to traverse into the object and test if the return value

### decode.js

- **Line 170:** ensure interior is decoded first

### index.js

- **Line 320:** Intentionally NOT pushing/indexing into the array of mock

### CoverageReporter.js

- **Line 370:** glob.sync is slow. By memoizing the files matching each glob

### index.js

- **Line 229:** that a possible improvement would be to analyse other information

### types.d.ts

- **Line 441:** With [pagination](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api), you can fetch up to 3000 gists. For example, you can fetch 100 pages with 30 gists per page or 30 pages with 100 gists per page.
- **Line 738:** that subscriptions are only generated if a user is participating in a conversation--for example, they've replied to the thread, were **@mentioned**, or manually subscribe to a thread.
- **Line 778:** ** This endpoint is only available to organizations with access to the enhanced billing platform. For more information, see "[About the enhanced billing platform](https://docs.github.com/billing/using-the-new-billing-platform)."
- **Line 3091:** that you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 3150:** ** To prevent leaking sensitive information, the `bypass_actors` property is only returned if the user
- **Line 5075:** ** The Checks API only looks for pushes in the repository where the check suite or check run were created. Pushes to a branch in a forked repository are not detected and return an empty `pull_requests` array.
- **Line 5645:** that, if you choose not to pass any parameters, you'll need to set `Content-Length` to zero when calling out to this endpoint. For more information, see "[HTTP method](https://docs.github.com/rest/guides/getting-started-with-the-rest-api#http-method)."
- **Line 8042:** If making a request on behalf of a GitHub App you must also have permissions to write the contents of the head repository.
- **Line 8480:** there is a limit of 1000 statuses per `sha` and `context` within a repository. Attempts to create more than 1000 statuses will result in a validation error.
- **Line 9057:** **
- **Line 9192:** ** If your email is set to private and you send an `email` parameter as part of this request to update your profile, your privacy settings are still enforced: the email address will not be displayed on your public profile or via the API.
- **Line 9981:** Pagination is powered exclusively by the `since` parameter. Use the [Link header](https://docs.github.com/rest/guides/using-pagination-in-the-rest-api#using-link-headers) to get the URL for the next page of users.
- **Line 86398:** ** A parameter can override this parameter. See `members_allowed_repository_creation_type` in this table for details.
- **Line 86410:** ** This parameter is closing down and will be removed in the future. Its return value ignores internal repositories. Using this parameter overrides values set in `members_can_create_repositories`. See the parameter deprecation notice in the operation description for details.
- **Line 93781:** ** If you're creating a repository in an organization that has disabled repository projects, the default is `false`, and if you pass `true`, the API returns an error.
- **Line 100520:** ** Providing `conclusion` will automatically set the `status` parameter to `completed`. You cannot change a check run conclusion to `stale`, only GitHub can set this.
- **Line 105563:** ** Use either `tree.sha` or `content` to specify the contents of the entry. Using both `tree.sha` and `content` will return an error.
- **Line 110565:** ** This returns an `upload_url` key corresponding to the endpoint for uploading release assets. This key is a hypermedia resource. For more information, see "[Getting started with the REST API](https://docs.github.com/rest/using-the-rest-api/getting-started-with-the-rest-api#hypermedia)."
- **Line 112101:** ** Topic `names` will be saved as lowercase.
- **Line 114779:** ** Alternatively, you can pass a single email address or an `array` of emails addresses directly, but we recommend that you pass an object using the `emails` key.

### limit-long-syntax.js

- **Line 9:** this is not a common behaviour, most CLIs allow both forms.

### index.js

- **Line 10:** DO NOT REMOVE the null character `\0` as it may be used by other plugins

### index.d.ts

- **Line 214:** In extreme cases, this feature may result in some paths being

### index.js

- **Line 177:** that we use posix.join because:

### octokit.js

- **Line 21:** replace with import ... assert { type: 'json' } once supported

### verify.js

- **Line 130:** we cannot check if the installation has all required permissions, it's

### iterate.js

- **Line 82:** this option does not exist on Node 18, but this is ok since the logic works without it. It just consumes more memory.

### convert.js

- **Line 158:** this function may return an invalid dates for the regex tests

### create.js

- **Line 182:** The best we can do here is attempt to instance each sub type and apply through object assign. For non-object

### mdx-loader.d.ts

- **Line 1764:** if `Value` from `VFile` is changed, this should too.
- **Line 3938:** this file is authored manually, not generated from `index.js`.
- **Line 4755:** when changing the next interface, you likely also have to change
- **Line 4761:** these are compiled away.

### matchers-7fb38cd4.js

- **Line 1060:** Not even sure this is a valid use case, but just in case...

### matchers.d.ts

- **Line 597:** roles are matched literally by string equality, without inheriting
- **Line 715:** the expected selection is a string, it does not allow to check for

### index.d.ts

- **Line 706:** the documentation says the ConfigAPI also exposes @babel/core's exports, but it actually doesn't
- **Line 756:** this is an undocumented reexport from "@babel/parser" but it's missing from its types

### index.d.ts

- **Line 445:** The current node path is included in this.
- **Line 488:** This is typically not a good idea to use. Building source strings when

### index.d.ts

- **Line 7:** This should only ever be done at the top-level application layer, in order to delay on

### index.d.ts

- **Line 365:** The default timeout interval is 5 seconds if this method is not called.
- **Line 371:** By default, jest.spyOn also calls the spied method. This is different behavior from most
- **Line 806:** that the type must be either an array or a tuple.
- **Line 1363:** `jest.fn(implementation)` is a shorthand for `jest.fn().mockImplementation(implementation)`.

### unicode.js

- **Line 55:** excluding NULL and ASCII whitespace

### formatting-element-list.js

- **Line 47:** build attrs map for the new element, so we can perform fast lookups
- **Line 50:** remove bottommost candidates, until Noah's Ark condition will not be met

### index.js

- **Line 124:** use a <template> element as the fragment context if no context element was provided,
- **Line 127:** create a fake element which will be used as the `document` for fragment parsing.
- **Line 361:** if we have a location assigned by another token, then just update the end position
- **Line 384:** For cases like <p> <p> </p> - First 'p' closes without a closing
- **Line 1221:** store the next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 1312:** Set end locations for elements that remain on the open element stack.
- **Line 1314:** If we are not in a fragment, `html` and `body` will stay on the stack.
- **Line 1707:** If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
- **Line 1859:** here we assume that we always act as a user agent with enabled plugins/frames, so we parse
- **Line 2145:** <body> is never popped from the stack, so we need to updated
- **Line 3080:** <html> is never popped from the stack, so we need to updated
- **Line 3239:** update the token tag name for `_setEndLocation`.

### open-element-stack.js

- **Line 134:** here we assume that the root <html> element is always first in the open element stack, so

### index.js

- **Line 166:** Set `pos` _before_ flushing, as flushing might drop
- **Line 191:** `offset` may never run across line boundaries.
- **Line 398:** if we have a pending character token, make it's end location equal to the
- **Line 464:** used when we emit characters explicitly.
- **Line 1772:** Doctypes tokens are created without fixed offsets. We keep track of the moment a doctype *might* start here.
- **Line 1787:** Sequence lookups can be abrupted by hibernation. In that case, lookup
- **Line 2151:** sequence lookup can be abrupted by hibernation. In that case lookup

### preprocessor.js

- **Line 6:** HTML input preprocessing
- **Line 13:** Initial `lastGapPos` is -2, to ensure `col` on initialisation is 0
- **Line 24:** avoid reporting errors twice on advance/retreat
- **Line 59:** try to peek a surrogate pair
- **Line 63:** we have a surrogate pair. Peek pair character and recalculate code point.
- **Line 65:** add a gap that should be avoided during retreat
- **Line 70:** we are at the end of a chunk, therefore we can't infer the surrogate pair yet.
- **Line 75:** isolated surrogate
- **Line 134:** LF should be in the last column of the line
- **Line 145:** all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters
- **Line 151:** any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character

### interface.d.ts

- **Line 17:** that `TreeAdapter` is not designed to be a general purpose AST manipulation library. You can build such library

### array.d.ts

- **Line 333:** This method mutates array.
- **Line 925:** Unlike _.without, this method mutates array.
- **Line 953:** ** Unlike `_.difference`, this method mutates `array`.
- **Line 991:** ** Unlike `_.differenceBy`, this method mutates `array`.
- **Line 1038:** ** Unlike `_.differenceWith`, this method mutates `array`.
- **Line 1084:** Unlike _.at, this method mutates array.
- **Line 1113:** Unlike _.filter, this method mutates array.
- **Line 1138:** ** This method mutates `array` and is based on

### collection.d.ts

- **Line 778:** As with other "Collections" methods, objects with a "length" property are iterated like arrays. To

### common.d.ts

- **Line 221:** key should be string, not keyof T, because the actual object may contain extra properties that were not specified in the type.
- **Line 279:** keys of objects at run time are always strings, even when a NumericDictionary is being iterated.

### function.d.ts

- **Line 86:** Unlike native Function#bind this method does not set the "length" property of bound functions.
- **Line 412:** If leading and trailing options are true, func is invoked on the trailing edge of the timeout only
- **Line 1303:** This method is based on the rest parameter.
- **Line 1328:** This method is based on the spread operator.
- **Line 1365:** If leading and trailing options are true, func is invoked on the trailing edge of the timeout only if

### lang.d.ts

- **Line 86:** This method is loosely based on the structured clone algorithm and supports cloning arrays,
- **Line 207:** This method is equivalent to _.conforms when source is partially applied.
- **Line 599:** ** This method supports comparing arrays, array buffers, booleans,
- **Line 708:** This method is based on Number.isFinite.
- **Line 754:** ** This method is based on [`Number.isInteger`](https://mdn.io/Number/isInteger).
- **Line 792:** ** This function is loosely based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
- **Line 853:** ** This method supports comparing the same values as `_.isEqual`.
- **Line 934:** This method is not the same as isNaN which returns true for undefined and other non-numeric values.
- **Line 1035:** To exclude Infinity, -Infinity, and NaN, which are classified as numbers, use the _.isFinite method.
- **Line 1120:** This method assumes objects created by the Object constructor have no inherited enumerable properties.
- **Line 1167:** ** This method is based on [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).
- **Line 1510:** ** This function is loosely based on [`ToInteger`](http://www.ecma-international.org/ecma-262/6.0/#sec-tointeger).
- **Line 1549:** ** This method is based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).

### object.d.ts

- **Line 10:** ** This method mutates `object` and is loosely based on
- **Line 112:** ** This method mutates `object`.
- **Line 477:** This method mutates object.
- **Line 1547:** Non-object values are coerced to objects. See the ES spec for more details.
- **Line 1570:** Non-object values are coerced to objects.

### string.d.ts

- **Line 98:** No other characters are escaped. To escape additional characters use a third-party library like he.
- **Line 296:** This method aligns with the ES5 implementation of parseInt.
- **Line 345:** This method is based on String#replace.
- **Line 402:** This method is based on String#split.
- **Line 494:** In the development build _.template utilizes
- **Line 697:** No other HTML entities are unescaped. To unescape additional HTML entities use a third-party library

### util.d.ts

- **Line 32:** This method does not set the "length" property of bound functions.
- **Line 490:** This method supports comparing arrays, booleans, Date objects, numbers, Object objects, regexes, and
- **Line 613:** Use _.runInContext to create a pristine lodash function to avoid conflicts caused by modifying

### index.d.ts

- **Line 47:** that this overwrites the `declare module '*.mdx' […]` types from earlier, which is why you

### events.d.ts

- **Line 39:** This class is in the docs but is **not actually exported** by Node.

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 5.7+.

### module.d.ts

- **Line 18:** the list doesn't contain prefix-only modules like `node:test`.

### readline.d.ts

- **Line 98:** According to the documentation:
- **Line 497:** we use the crlfDelay option to recognize all instances of CR LF

### web.d.ts

- **Line 347:** that the provided high water mark will not be validated ahead of

### test.d.ts

- **Line 84:** ** `shard` is used to horizontally parallelize test running across
- **Line 569:** ** Some of the functions from `node:assert` contain type assertions. If these are called via the
- **Line 706:** If a `wait` timeout is specified, it begins counting down only after the test function finishes executing.
- **Line 1499:** ** When you enable mocking for a specific timer, its associated
- **Line 1502:** ** Mocking `Date` will affect the behavior of the mocked timers
- **Line 1547:** This method will execute any mocked timers that are in the past from the new time.
- **Line 1569:** ** After each test completes, this function is called on
- **Line 1582:** ** This diverges from how `setTimeout` in Node.js behaves and accepts
- **Line 1686:** ** The `runAll()` function is specifically designed for

### tls.d.ts

- **Line 351:** `getSession()` works only for TLSv1.2 and below. For TLSv1.3, applications

### index.d.ts

- **Line 25:** These definitions support Node.js and TypeScript 4.9 through 5.6.

### util.d.ts

- **Line 1900:** that an effort will be made to coerce the given values into strings.

### v8.d.ts

- **Line 296:** that, when there are child classes inheriting from a constructor,

### vm.d.ts

- **Line 718:** This is a contrived example in that the linker function creates a new

### index.d.ts

- **Line 1:** Users of the `experimental` builds of React should add a reference

### experimental.d.ts

- **Line 59:** that SuspenseList require more than one child;

### index.d.ts

- **Line 1411:** its presence prevents any of the deprecated lifecycle methods from being invoked
- **Line 1431:** the presence of this method prevents any of the deprecated
- **Line 1448:** the presence of [@link NewLifecycle.getSnapshotBeforeUpdate getSnapshotBeforeUpdate]
- **Line 1509:** You cannot call [@link Component.setState] here.
- **Line 1629:** String refs can be forwarded. We can't fix this bug without breaking a bunch of libraries now though.
- **Line 1861:** callbacks are _only_ allowed to return either void, or a destructor.
- **Line 1972:** without the ReducerState indirection, TypeScript would reduce S to be the most common
- **Line 1987:** that `useRef()` is useful for more than the `ref` attribute. It’s handy for keeping any mutable
- **Line 2046:** this does not accept strings, but this will have to be fixed by removing strings from type Ref<T>
- **Line 2081:** We don’t recommend adding debug values to every custom hook.

### index.d.ts

- **Line 123:** this property is currently true by default but it will be changed to false in the next major version because Node's resolution

### index.d.ts

- **Line 159:** that when `void` is returned, the handler `argv` object type will not include command-specific arguments.
- **Line 405:** that any multi-char aliases (e.g. `help`) used for the help option will also be used for the implicit command.
- **Line 435:** that the OS locale can be modified by setting/exporting the `LC_ALL` environment variable.
- **Line 470:** that decimals, hexadecimals, and scientific notation are all accepted.
- **Line 514:** Providing a callback to parse() disables the `exitProcess` setting until after the callback is invoked.

### eslint-recommended-raw.js

- **Line 2:** this file is isolated to be shared across legacy and flat configs.

### await-thenable.js

- **Line 97:** that this suggestion causes broken code for sync iterables

### consistent-type-exports.js

- **Line 172:** it is valid to export values as types. We will avoid reporting errors

### consistent-type-imports.js

- **Line 238:** - in TS 5.0 `experimentalDecorators` became the legacy option,

### member-ordering.js

- **Line 665:** Not all members have names

### naming-convention.js

- **Line 10:** that that rule ignores leading and trailing underscores and only checks those in the middle of a variable name

### no-inferrable-types.js

- **Line 72:** that bigint cannot have + prefixed to it

### no-unnecessary-condition.js

- **Line 50:** that this differs from [@link isNullableType] in that it doesn't consider
- **Line 331:** It's also unnecessary if the types that don't overlap at all

### prefer-find.js

- **Line 219:** we're always looking for array member access to be "computed",

### prefer-nullish-coalescing.js

- **Line 528:** This does not imply that the nodes are runtime-equivalent.

### compareNodes.js

- **Line 192:** - we purposely ignore optional flag because for our purposes

### collectUnusedVariables.js

- **Line 33:** - This is a simple visitor - meaning it does not support selectors

### getOperatorPrecedence.d.ts

- **Line 10:** This is wrong

### getOperatorPrecedence.js

- **Line 15:** `Spread` is higher than `Comma` due to how it is parsed in |ElementList|
- **Line 27:** AssignmentExpression is broken down into several precedences due to the requirements
- **Line 40:** `Conditional` is considered higher than `Assignment` here, but in reality they have

### Referencer.js

- **Line 313:** In ES6, ForStatement dynamically generates per iteration environment. However, this is

### GlobalScope.js

- **Line 11:** this is accessed in used in the legacy eslint-scope tests, so it can't be true private

### ESLintScopeVariable.js

- **Line 16:** that this isn't a typo - ESlint uses this spelling here

### isUnsafeAssignment.js

- **Line 44:** in the case of generic positions, it makes the assumption that the two types are the same.

### typeFlagUtils.d.ts

- **Line 11:** that if the type is a union, this function will decompose it into the

### ast-spec.d.ts

- **Line 470:** that this is neither up to date nor fully correct.

### convert.js

- **Line 1767:** - NewExpression cannot have an optional chain in it

### createProjectService.js

- **Line 120:** The inferred projects API is not intended for source files when a tsconfig

### getScriptKind.js

- **Line 45:** - we only respect the user's jsx setting for unknown extensions

### node-utils.js

- **Line 591:** getWidth() does not take trivia into account.

### parser-options.d.ts

- **Line 55:** this setting does not effect known file types (.js, .cjs, .mjs, .jsx, .ts, .mts, .cts, .tsx, .json) because the
- **Line 128:** When used with [@link projectService], full project reloads may occur.
- **Line 143:** If `preserveNodeMaps` is explicitly set by the user, it will be respected,
- **Line 154:** that [@link projectService] is now preferred.

### createParseSettings.js

- **Line 56:** - we intentionally use "unnecessary" `?.` here because in TS<5.3 this enum doesn't exist

### resolveProjectList.js

- **Line 45:** - we initialize the global cache based on the first config we encounter.

### useProgramFromProjectService.js

- **Line 166:** triggers a full project reload when changes are detected

### version.js

- **Line 4:** - cannot migrate this to an import statement because it will make TSC copy the package.json to the dist folder

### LegacyESLint.d.ts

- **Line 23:** This option only applies when you pass directory paths to the eslint.lintFiles() method.

### RuleTester.d.ts

- **Line 64:** Suggestions will be applied as a stand-alone change, without triggering multi-pass fixes.

### acorn.d.ts

- **Line 696:** that you are not allowed to call the

### acorn.js

- **Line 4459:** this updates `state.lastStringValue` property with the eaten name.

### argparse.js

- **Line 1201:** that the difference between the default and nargs=1 is that
- **Line 2259:** if add_mutually_exclusive_group ever gains title= and

### textwrap.js

- **Line 395:** that tabs and spaces are both treated as whitespace, but they

### async.js

- **Line 3214:** Since this function applies the `iteratee` to each item in parallel,
- **Line 3561:** if the async function errs, the result will not be cached and
- **Line 3692:** ** `parallel` is about kicking-off I/O tasks in parallel, not about

### helpers.js

- **Line 29:** If this is found to have issues, please also revist the logic in

### es5.js

- **Line 244:** that simple async functions are implemented on top of

### index.js

- **Line 497:** op_mob is not included as its chromium versions are not in sync with Opera desktop

### helpers.dataset.js

- **Line 1264:** the rounded rect implementation changed to use `arc` instead of

### controller.bar.d.ts

- **Line 53:** pixel values are not clamped to the scale area.

### core.animator.d.ts

- **Line 7:** class is export for typedoc

### index.d.ts

- **Line 1139:** class is exported for typedoc

### lexer.js

- **Line 1296:** non-asii BR and whitespace checks omitted for perf / footprint

### conversions.js

- **Line 5:** conversions should only return primitive values (i.e. arrays, or

### index.main.cjs.js

- **Line 299:** padStart could be used here but it breaks Node 6 compat

### context.d.ts

- **Line 58:** groups.

### util.js

- **Line 22:** These type checking functions intentionally don't use `instanceof`

### parse.js

- **Line 39:** that `forceShell` is an hidden option used only in tests

### resolveCommand.js

- **Line 40:** that when a custom `cwd` was used, we need to resolve to an absolute path based on it

### css.escape.js

- **Line 33:** there’s no need to special-case astral symbols, surrogate

### ejs.js

- **Line 378:** that the return type of the function also depends on the value of `opts.async`.

### escape.d.ts

- **Line 24:** that the output will be character-set dependent.

### index.js

- **Line 1:** since nyc uses this module to output coverage, any lines

### index.js

- **Line 23:** I'm intentionally not DRYing up the other variables to keep them "lazy".

### IsWordChar.js

- **Line 21:** prior to ES2023, this AO erroneously omitted the latter of its arguments.

### InternalizeJSONProperty.js

- **Line 18:** `reviver` was implicitly closed-over until ES2020, where it becomes a third argument

### main.d.ts

- **Line 691:** These declarations exist to avoid type errors when you omit "dom" from

### eslint-plugin-react-hooks.development.js

- **Line 503:** We could report here that the hook is not reachable, but
- **Line 688:** We could also support `ClassProperty` and `MethodDefinition`
- **Line 1156:** no need to handle OptionalMemberExpression because it can't be LHS.
- **Line 2218:** we don't check OptionalMemberExpression because it can't be LHS.
- **Line 2227:** If the node argument is an OptionalMemberExpression, it doesn't necessarily mean it is optional.

### jsx-child-element-spacing.js

- **Line 8:** 'br' is not included because whitespace around br tags is inconsequential to the rendered output

### no-adjacent-inline-elements.js

- **Line 52:** raw &nbsp; will be transformed into \u00a0.

### no-unescaped-entities.js

- **Line 18:** '<' and '{' are also problematic characters, but they do not need

### no-unknown-property.js

- **Line 402:** does not check if a tag's parent against a list of standard HTML/DOM tags. For example,
- **Line 431:** - these exclusions are not made by React core team, but `eslint-plugin-react` community.

### referencer.js

- **Line 178:** Not referring variableScope. It is intended.
- **Line 496:** In ES6, ForStatement dynamically generates
- **Line 521:** This should be `variableScope`. Since direct eval call always creates Lexical environment and

### scope.js

- **Line 660:** Arrow functions never have an arguments objects.

### eslint.js

- **Line 24:** See

### api.js

- **Line 32:** The v9.x version of this function doesn't have a cwd option

### cli-engine.js

- **Line 850:** The LintResultCache will remove the file source and any

### cli.js

- **Line 9:** The CLI object should *not* call process.exit() directly. It should only return

### flat-config-schema.js

- **Line 13:** This can be removed in ESLint v9 because structuredClone is available globally

### rule-validator.js

- **Line 117:** ruleOptions is always an array at this point because

### flat-eslint.js

- **Line 12:** Node.js 12 does not support fs/promises.
- **Line 284:** that we should not overuse queries (e.g., by appending the current time

### fork-context.js

- **Line 90:** `create` is just a wrapper that augments `new CodePathSegment`.

### flat-rule-tester.js

- **Line 150:** This ignores `parent` property.

### capitalized-comments.js

- **Line 157:** that the comment itself need not be single-line!

### indent.js

- **Line 312:** that since collapsing only occurs when two tokens are on the same line, there are a few cases where non-intuitive

### no-setter-return.js

- **Line 198:** A previously declared function can be referenced and actually used as a setter in a property descriptor,

### no-useless-return.js

- **Line 275:** This event is notified for only reachable segments.

### prefer-object-spread.js

- **Line 111:** don't include the parens of the argument list.

### quotes.js

- **Line 44:** escaping of newlines when switching from backtick to other quotes is not handled.

### letters.js

- **Line 3:** This file was generated using this script in JSCS based on the Unicode 7.0.0 standard: https://github.com/jscs-dev/node-jscs/blob/f5ed14427deb7e7aac84f3056a5aab2d9f3e563e/publish/helpers/generate-patterns.js

### esprima.js

- **Line 6083:** replacing with '\uFFFF' enables false positives in unlikely

### diff.js

- **Line 878:** that diff_commonPrefix and diff_commonSuffix are unicode-aware
- **Line 1040:** this runs after equality check has ruled out exact equality

### schemes.js

- **Line 31:** We do not parse query strings for HTTP URIs

### form_data.js

- **Line 359:** getLengthSync DOESN'T calculate streams length

### framer-motion.dev.js

- **Line 6234:** Currently only running on root node
- **Line 6360:** Disabled to fix relative animations always triggering new
- **Line 6463:** This is a DOM write. Worst case scenario is this is sandwiched

### m.d.ts

- **Line 405:** `duration` and `bounce` will be overridden if `stiffness`, `damping` or `mass` are set.
- **Line 443:** `bounce` and `duration` will be overridden if `stiffness`, `damping` or `mass` are set.
- **Line 1359:** This is not supported publically.
- **Line 1370:** ** For pan gestures to work correctly with touch input, the element needs

### index.d.ts

- **Line 1046:** Still used by components generated by old versions of Framer

### copy.js

- **Line 92:** that The initial srcStat.atime cannot be trusted

### handlebars.amd.js

- **Line 451:** for 5.0: Change to "obj == null" in 5.0
- **Line 917:** Using env.VM references rather than local var references throughout this section to allow

### index.d.ts

- **Line 198:** for backward compatibility of this typing

### python.js

- **Line 297:** no leading \b because floats can start with a decimal point

### swift.js

- **Line 159:** Contextual keywords are reserved only in specific contexts.

### typescript.js

- **Line 421:** this might not work how you think.  We don't actually always

### index.d.ts

- **Line 160:** that this can change as the underlying fetch() moves through
- **Line 367:** that it must be a valid value for whichever time-tracking
- **Line 413:** that significantly fewer items may be stored, if
- **Line 474:** that this may *significantly* degrade performance, especially if
- **Line 479:** that this means that {@link OptionsBase.allowStale} is a bit
- **Line 518:** that when a stale entry is fetched, _even if it is returned due to
- **Line 592:** that this may result in fewer than `max` items being stored.
- **Line 609:** also that size tracking can negatively impact performance,
- **Line 685:** that the `get` return value will still be `undefined`
- **Line 779:** do NOT pass the signal to fetch()!
- **Line 1167:** that this means that handling options such as
- **Line 1206:** `fetch()` calls are inflight-unique**

### index.js

- **Line 808:** this returns an actual array, not a generator, so it can be more
- **Line 864:** if `undefined` is specified as a value, this is an alias for

### dbcs-codec.js

- **Line 284:** '>>> 0' keeps 32-bit num positive.

### utf16.js

- **Line 4:** UTF16-LE (or UCS2) codec is Node.js native. See encodings/internal.js

### utf32.js

- **Line 123:** codepoint is a signed int32 and can be negative.
- **Line 124:** We copied this block from below to help V8 optimize it (it works with array, not buffer).
- **Line 156:** codepoint is signed int32 and can be negative. We keep it that way to help V8 with optimizations.

### index.js

- **Line 135:** Streaming API naturally depends on 'stream' module from Node.js. Unfortunately in browser environments this module can add

### streams.js

- **Line 5:** Due to 'stream' module being pretty large (~100Kb, significant in browser environments),

### errors.js

- **Line 322:** extra classes have been shaken out.
- **Line 361:** no need to implement `kIsNodeError` symbol, would be hard,

### get-format.js

- **Line 125:** we don’t implement WASM, so we don’t need

### package-json-reader.js

- **Line 132:** in Node, this is now a native module.

### resolve.js

- **Line 136:** from Node 15 onwards we can use `throwIfNoEntry: false` instead.
- **Line 140:** in Node code this returns `new Stats`,
- **Line 1082:** The Node code supports `base` as a string (in this internal API) too,
- **Line 1106:** actual code uses `canBeRequiredWithoutScheme`.
- **Line 1175:** this is from:

### file-coverage.js

- **Line 293:** that the other object should have the same structure as this one (same file).

### annotator.js

- **Line 267:** order is important, since statements typically result in spanning the whole line and doing branches late

### rule.js

- **Line 60:** that, it is assumed a is a suffix of s.

### rule.jake.js

- **Line 49:** that tmp_dep2.o depends on tmp_dep2.c, which is a

### index.js

- **Line 371:** we might need to resolve this dir to an absolute path in the future

### index.js

- **Line 211:** that the data structures described above are conceptual only. The actual

### resolver.js

- **Line 652:** once a moduleNameMapper matches the name, it must result

### index.js

- **Line 186:** that this only applies when they are required in an internal context;

### common.js

- **Line 110:** that they are not supported in Glob itself anyway.

### minimatch.js

- **Line 906:** ending in / means that we'll get a final ""

### State.js

- **Line 207:** that this is only relevant when a snapshot is added and the dirty

### index.d.ts

- **Line 298:** this is different from ResourceLimits in that it checks at idle, after

### ChildProcessWorker.js

- **Line 121:** Detecting an out of memory crash is independent of idle memory usage monitoring. We want to

### types.d.ts

- **Line 8:** **It is recommended to use `await jiti.import` instead
- **Line 59:** ** It is recommended to keep this option enabled for better performance.

### js-yaml.js

- **Line 3216:** line breaking/folding is implemented for only the folded style.
- **Line 3236:** that this implies
- **Line 3277:** the special case: the string '\n' counts as a "trailing" empty line.
- **Line 3290:** a long line without a suitable break point will exceed the width limit.
- **Line 3333:** the match index will always be <= length-2.

### core.js

- **Line 4:** JS-YAML does not support schema-specific tag resolution restrictions.

### index.js

- **Line 17:** HTML and XML fragment parsing algorithm already return a document fragments; no need to do steps 3 and 4

### xpath.js

- **Line 1292:** parseFloat(' ') -> NaN, unlike +' ' -> 0.
- **Line 1425:** that xpath string positions user 1-based index

### header-list.js

- **Line 7:** that this class only operates on ByteStrings (which is also why we use

### create-event-accessor.js

- **Line 105:** this won't execute body; that would require `Function(body)()`.
- **Line 114:** the with (window) [] is not necessary in Node, but is necessary in a browserified environment.

### interfaces.js

- **Line 7:** The mapping needs to stay as-is in order due to interface evaluation.

### node.js

- **Line 240:** I'd prefer to check instanceof Node rather than string

### HTMLInputElement-impl.js

- **Line 930:** As of today, the value IDL attribute always applies.

### Node-impl.js

- **Line 871:** This section differs from the pre-insert validation algorithm.

### RadioNodeList-impl.js

- **Line 7:** in general the spec says to manipulate/consult checkedness, but we use `checked` instead

### SVGListBase.js

- **Line 186:** this will always throw a IndexSizeError.

### named-properties-tracker.js

- **Line 154:** delete puts the object in dictionary mode.

### index.js

- **Line 25:** `~-` is the bitwise way to perform a `- 1` operation

### _equalByTag.js

- **Line 34:** ** This function only supports comparing values with tags of

### _initCloneByTag.js

- **Line 32:** ** This function only supports cloning values with tags of

### _setData.js

- **Line 7:** ** If this function becomes hot, i.e. is invoked a lot in a short

### bindAll.js

- **Line 11:** ** This method doesn't set the "length" property of bound functions.

### conforms.js

- **Line 12:** ** The created function is equivalent to `_.conformsTo` with

### core.js

- **Line 1705:** ** This method is used instead of
- **Line 1919:** ** Unlike `_.remove`, this method returns a new array.
- **Line 2002:** ** As with other "Collections" methods, objects with a "length"
- **Line 2271:** ** Unlike native `Function#bind`, this method doesn't set the "length"
- **Line 2405:** ** This method is loosely based on the
- **Line 2723:** ** This method is loosely based on
- **Line 2868:** ** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
- **Line 3413:** ** No other characters are escaped. To escape additional
- **Line 3515:** ** The created function is equivalent to `_.isMatch` with `source`
- **Line 3522:** ** Multiple values can be checked by combining several matchers
- **Line 3554:** ** Use `_.runInContext` to create a pristine `lodash` function to

### curryRight.js

- **Line 13:** ** This method doesn't set the "length" property of curried functions.

### debounce.js

- **Line 23:** ** If `leading` and `trailing` options are `true`, `func` is

### difference.js

- **Line 12:** ** Unlike `_.pullAll`, this method returns a new array.

### differenceBy.js

- **Line 15:** ** Unlike `_.pullAllBy`, this method returns a new array.

### every.js

- **Line 12:** ** This method returns `true` for

### fill.js

- **Line 8:** ** This method mutates `array`.

### isInteger.js

- **Line 6:** ** This method is based on

### keys.js

- **Line 8:** ** Non-object values are coerced to objects. See the

### lodash.js

- **Line 7059:** ** Unlike `_.pullAllWith`, this method returns a new array.
- **Line 11196:** ** This method is equivalent to `_.conforms` when `source` is
- **Line 11867:** ** This method is equivalent to `_.matches` when `source` is
- **Line 11970:** ** This method can't reliably detect native functions in the presence
- **Line 14741:** ** In the development build `_.template` utilizes

### matchesProperty.js

- **Line 12:** ** Partial comparisons will match empty array and empty object

### memoize.js

- **Line 13:** ** The cache is exposed as the `cache` property on the memoized

### omit.js

- **Line 19:** ** This method is considerably slower than `_.pick`.

### parseInt.js

- **Line 15:** ** This method aligns with the

### partial.js

- **Line 17:** ** This method doesn't set the "length" property of partially

### pull.js

- **Line 9:** ** Unlike `_.without`, this method mutates `array`. Use `_.remove`

### pullAt.js

- **Line 12:** ** Unlike `_.at`, this method mutates `array`.

### range.js

- **Line 9:** ** JavaScript follows the IEEE-754 standard for resolving

### remove.js

- **Line 9:** ** Unlike `_.filter`, this method mutates `array`. Use `_.pull`

### rest.js

- **Line 12:** ** This method is based on the

### unescape.js

- **Line 13:** ** No other HTML entities are unescaped. To unescape additional

### valuesIn.js

- **Line 8:** ** Non-object values are coerced to objects.

### without.js

- **Line 10:** ** Unlike `_.pull`, this method returns a new array.

### wrapperReverse.js

- **Line 9:** ** This method mutates the wrapped array.

### jasmine.js

- **Line 236:** Do <b>not</b> call new jasmine.Spy() directly - a spy must be created using spyOn, jasmine.createSpy or jasmine.createSpyObj.

### ast.js

- **Line 68:** will be undefined until we generate the regexp src and find out

### index.js

- **Line 363:** flushing CAN potentially switch us into not-flowing mode

### constants.js

- **Line 3:** this is the semver.org version of the spec that it implements

### re.js

- **Line 116:** that the only major, minor, patch, and pre-release sections of
- **Line 139:** that "x.x" is a valid xRange identifer, meaning "any version"
- **Line 206:** that these all use the loose form, because they'll be

### index.js

- **Line 147:** This could be implemented using a single negative lookbehind

### index.js

- **Line 27:** We cannot use the name property command file because in the case of

### update-notifier.js

- **Line 41:** that this isn't another http request over the network, because

### install.js

- **Line 93:** there used to be registry completion here,

### publish.js

- **Line 116:** that publishConfig might have changed as well!

### npm.js

- **Line 109:** that this might not be the actual name of the command
- **Line 154:** this MUST be shorter than the actual argv length, because it

### log-file.js

- **Line 16:** that each log event can write more than one line to the

### queryable.js

- **Line 141:** that occurrences of Symbol(append) will throw,

### reify-output.js

- **Line 23:** fails and crashes if we're running audit fix and there was an error

### build-ideal-tree.js

- **Line 37:** some of these symbols are shared so we can hit
- **Line 579:** any that can't be fixed at the root level without --force
- **Line 841:** this is the same "maximally naive" deduping tree-building
- **Line 1035:** that the virtual root will also have virtual copies of the
- **Line 1116:** that this WILL fetch bundled meta-deps which are also dependencies
- **Line 1269:** that the peers in the set can conflict either with each other,

### load-actual.js

- **Line 137:** hidden lockfile will be rejected if it's not the latest thing

### rebuild.js

- **Line 260:** that 'scripts' might be missing entirely, and the package may

### reify.js

- **Line 301:** that each rollback *also* calls the previous one when it's

### deepest-nesting-target.js

- **Line 7:** this will skip past the first target if edge is peer

### diff.js

- **Line 145:** that if ideal has integrity, and resolved doesn't, we treat
- **Line 189:** we DON'T diff fsChildren themselves, because they are either
- **Line 262:** that moving over a bundled dep will break the links to other

### edge.js

- **Line 110:** this condition means we explicitly do not support overriding

### node.js

- **Line 143:** this *only* works for non-file: deps, so we avoid even
- **Line 220:** this is _slightly_ less efficient for the initial tree
- **Line 853:** the subtle breaking change from v6: it is no longer possible
- **Line 994:** that there are cases where Arborist will opt to insert a node

### optional-set.js

- **Line 8:** that this is *only* going to work with trees where calcDepFlags

### place-dep.js

- **Line 90:** this sets the parent's canPlace as the parent of this
- **Line 301:** if the virtualRoot *doesn't* have the peer, then that means

### query-selector-all.js

- **Line 519:** this uses a Promise.all around a map without in-line concurrency handling
- **Line 861:** this runs over each node and should not throw

### shrinkwrap.js

- **Line 30:** that between this.add() and this.commit(), `this.data` will be out of
- **Line 86:** name is included if necessary, for alias packages

### definition.js

- **Line 178:** these are not quite the same as the description printed

### index.js

- **Line 393:** we pull registry without restricting to the current 'where' because we want to
- **Line 804:** not encrypted, no idea why we bothered to do this, but oh well

### set-envs.js

- **Line 99:** this doesn't afect the *current* node process, of course, since

### index.js

- **Line 89:** the first or second parameter must be a static version or range

### field_behavior.js

- **Line 11:** This enum **may** receive new values in the future.

### entry-index.js

- **Line 126:** - Cleverness ahoy!

### index.js

- **Line 59:** `iterator.next()` can be called many times in parallel.
- **Line 145:** We *must* do this for async iterators otherwise we'll spin up

### read-entry.js

- **Line 65:** gnutar and bsdtar treat unrecognized types as 'File'

### strip-absolute-path.js

- **Line 5:** that windows will think that //x/y/z/a has a "root" of //x/y, and in

### unpack.js

- **Line 97:** that on windows, we always drop the entire cache whenever a

### entry.js

- **Line 15:** we will also store any request headers
- **Line 26:** we must not store the real response's age header, or when we load
- **Line 311:** we do not set the x-local-cache-hash header because we do not know
- **Line 394:** be sure to remove the headers property from the

### policy.js

- **Line 123:** this is a hack to avoid parsing the cache-control

### headers.js

- **Line 57:** per spec we have to first exhaust the lists then process them

### fetcher.js

- **Line 172:** that they should *not* calculate or check integrity or cache,
- **Line 189:** cacache will raise a EINTEGRITY error if the integrity doesn't match

### git.js

- **Line 169:** that this does mean that a dependency MAY in theory end up

### registry.js

- **Line 79:** this might be either an in-flight promise for a request,

### is-package-bin.js

- **Line 5:** this is not possible in remote or file fetchers, since

### tar-create-options.js

- **Line 16:** that npm-packlist is already filtering out

### index.js

- **Line 137:** that fs operations that would normally throw will instead return an
- **Line 493:** that we might know *something* about it if there has been a previous
- **Line 638:** even on case-sensitive systems, it is **not** safe to test the
- **Line 854:** that unlike `fs.lstat()`, the returned value does not contain some
- **Line 1676:** As of Node 19, this is very slow, compared to other methods of

### container.js

- **Line 121:** that this location is relative to the location of the first character

### socksclient.js

- **Line 34:** Supports callbacks and promises. Only supports the connect command.
- **Line 84:** Supports callbacks and promises. Only supports the connect method.
- **Line 85:** Implemented via createConnection() factory function.
- **Line 274:** If the Socks client is not BoundWaitingForConnection or Established, the connection will be closed.
- **Line 482:** As of Tor v0.3.5.7+, if user/pass auth is an option from the client, by default it will always take priority.
- **Line 537:** No auth and user/pass are currently supported.

### store.js

- **Line 169:** that an expired initial root is still considered valid.

### updater.js

- **Line 311:** This may be a slow operation if there are many delegated roles.

### nwsapi.js

- **Line 690:** SPECIAL CASES IN CSS SYNTAX PARSING RULES

### index.js

- **Line 253:** in IE 8, sometimes `global !== window` but both are the prototypes of each other

### browser.js

- **Line 1242:** this does not detect the bug unless there's 20 characters

### index.js

- **Line 12:** this *only* works if you build your code into `'./dist'`, and that the

### preprocessor-mixin.js

- **Line 16:** avoid reporting error twice on advance/retreat

### parser-mixin.js

- **Line 86:** generate location info for elements
- **Line 103:** <body> and <html> are never popped from the stack, so we need to updated
- **Line 140:** _attachElementToTree is called from _appendElement, _insertElement and _insertTemplate methods.
- **Line 183:** store last foster parenting location, so we will be able to find inserted text
- **Line 209:** if we have location assigned by another token, then just update end position

### tokenizer-mixin.js

- **Line 93:** if we have pending character token make it's end location equal to the
- **Line 117:** if we have character token and it's location wasn't set in the _emitCurrentToken(),
- **Line 132:** patch initial states for each mode to obtain token start position

### formatting-element-list.js

- **Line 59:** build attrs map for the new element so we can perform fast lookups
- **Line 81:** remove bottommost candidates until Noah's Ark condition will not be met

### index.js

- **Line 350:** use <template> element as a fragment context if context element was not provided,
- **Line 356:** create fake element which will be used as 'document' for fragment parsing.
- **Line 939:** store next element for the next loop iteration (it may be deleted from the stack by step 9.5)
- **Line 1042:** do nothing =)
- **Line 1583:** here we assume that we always act as an user agent with enabled plugins, so we parse

### open-element-stack.js

- **Line 257:** here we assume that root <html> element is always first in the open element stack, so

### index.js

- **Line 163:** used in tests and by rewriting stream

### index.js

- **Line 176:** String.fromCharCode() function can handle only characters from BMP subset.
- **Line 434:** store emited start tag's tagName to determine is the following end tag token is appropriate.
- **Line 502:** used then we emit character explicitly. This is always a non-whitespace and a non-null character.
- **Line 522:** we use greedy search, so we continue lookup at this point
- **Line 2026:** matching can be abrupted by hibernation. In that case match

### named-entity-data.js

- **Line 3:** this file contains auto-generated array mapped radix tree that is used for the named entity references consumption

### preprocessor.js

- **Line 33:** err reporting is noop by default. Enabled by mixin.
- **Line 50:** add gap that should be avoided during retreat
- **Line 57:** we are at the end of a chunk, therefore we can't infer surrogate pair yet.

### index.d.ts

- **Line 879:** that this will be extremely memory-hungry on large filesystems.

### polished.cjs.js

- **Line 2327:** At a later stage we can optimize this function as right now a hsl

### index.js

- **Line 60:** INSERT never advances the offset.

### doc.d.ts

- **Line 204:** that, like cursorNodeStart, this is a misnomer and may actually be the text between two

### index.d.ts

- **Line 131:** that resolving these types is somewhat complicated, and it wasn't

### react-is.development.js

- **Line 43:** its typeof might be other than 'symbol' or 'number' if it's a polyfill.

### punycode.es6.js

- **Line 18:** U+007F DEL is excluded too.

### index.js

- **Line 8:** We **don't** need `envHasBigInt64Array` in fde es6/index.js

### react-is.development.js

- **Line 56:** typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).

### component.d.ts

- **Line 9:** this is not expected behavior from a "singleton"

### _stream_readable.js

- **Line 120:** 0 is a valid value, means "don't call _read preemptively ever"
- **Line 411:** that this may be asynchronous, or synchronous.  Yes, it is

### _stream_writable.js

- **Line 119:** 0 is a valid value, means that we always return false if

### regenerate.js

- **Line 166:** the `- 1` makes `end` inclusive.
- **Line 203:** we cannot `return` just yet, in case any following pairs still
- **Line 365:** we cannot `return` just yet, as there may still be other
- **Line 376:** we cannot return yet.
- **Line 409:** we cannot `return` just yet.
- **Line 517:** the `\b` escape sequence for U+0008 BACKSPACE in strings has a
- **Line 523:** IE < 9 treats `'\v'` as `'v'`, so avoid using it.
- **Line 538:** `-` (U+002D HYPHEN-MINUS) is escaped in this way rather
- **Line 864:** the loop starts at the next index.
- **Line 1182:** `valueOf` is aliased as `toArray`.

### rewrite-pattern.js

- **Line 85:** `unicodeMatchPropertyValue` throws on invalid values.
- **Line 97:** `unicodeMatchProperty` throws on invalid properties.
- **Line 981:** `processTerm` mutates `tree` and `groups`.

### parser.js

- **Line 7:** The ECMA-262 standard uses the term "Assertion" for /^/. Here the
- **Line 148:** The following productions refer to the "set notation and
- **Line 213:** The following productions refer to the

### core.js

- **Line 29:** this must be require, not require.resolve, due to https://github.com/nodejs/node/issues/43274

### filter_sync.js

- **Line 10:** in v2.x, this will be `pkg, pkgfile, dir`, but must remain "broken" here in v1.x for compatibility

### retry-busy.js

- **Line 1:** max backoff is the maximum that any *single* backoff will do

### rimraf-posix.js

- **Line 2:** that this approach does NOT work on Windows!

### rimraf-windows.js

- **Line 9:** "move then remove" is 2-10 times slower, and just as unreliable.

### glob.d.ts

- **Line 113:** that this does NOT prevent traversal to sibling folders,
- **Line 168:** that this _doesn't_ necessarily limit the walk to the
- **Line 211:** that this makes it **impossible** to match against paths
- **Line 351:** that a previous `Glob` object can be passed as the

### rollup-plugin-peer-deps-external.js

- **Line 366:** `R.bind` does not provide the additional argument-binding capabilities of
- **Line 502:** that the order of the output array is not guaranteed to be consistent

### rollup.d.ts

- **Line 111:** if plugins use new this.cache to opt-out auto transform cache

### loadConfigFile.js

- **Line 387:** that we do not have coverage for Windows-only code paths

### rollup.js

- **Line 11727:** that class fields do not end up on the prototype
- **Line 12382:** that unknown test values are always included

### saxes.js

- **Line 688:** ``char`` MAY NOT
- **Line 1903:** do not apply default ns to attributes:

### source-map.debug.js

- **Line 1381:** The order of the mappings is NOT guaranteed.

### SymbolTree.js

- **Line 606:** unlike DOM, preceding / following is not set here

### index.js

- **Line 89:** here `domain` and `suffix` cannot have the same length because in

### cookie.d.ts

- **Line 250:** when parsing a `Cookie` header it must be split by ';' before each Cookie string can be parsed.

### cookie.js

- **Line 64:** that it excludes \x3B ";"
- **Line 67:** ';' is \x3B

### cookieCompare.d.ts

- **Line 25:** Not all user agents sort the cookie-list in this order, but

### memstore.js

- **Line 65:** we should use path-match algorithm from S5.1.4 here

### index.d.ts

- **Line 2716:** It is intentional that this is not a type guard.
- **Line 2887:** that this is a shallow collection: it only returns `type.types` or `[type]`.

### node-internal-modules-esm-resolve.js

- **Line 258:** fs check redundances will be handled by Descriptor cache here.

### runmain-hack.js

- **Line 6:** that I attempted a try-catch around `Module._load`, but it poisons some sort of cache such that subsequent `import()` is impossible.

### bin.js

- **Line 41:** When transitioning into the child-process after `phase2`,
- **Line 147:** argv and restArgs may be overwritten by child process
- **Line 247:** When we transition to a child process for ESM, the entry-point script determined
- **Line 294:** that we need to explicitly re-resolve the entry-point information in the final
- **Line 316:** resolution relative to cwd option (not `process.cwd()`) is legacy backwards-compat; should be changed in next major: https://github.com/TypeStrong/ts-node/issues/1834
- **Line 470:** eval and repl may both run, but never with stdin.

### file-extensions.js

- **Line 108:** TS's resolver is only used by, and only required for, typechecking.

### index.js

- **Line 285:** fileURLToPath does not exist on early node v10

### repl.d.ts

- **Line 13:** typically, you will want to call `start()` instead of using this method.

### repl.js

- **Line 196:** `code` argument is deprecated
- **Line 205:** deprecated
- **Line 212:** should not be killing the process here, but this codepath is deprecated anyway
- **Line 388:** REPL does not respect sourcemaps!

### resolver-functions.js

- **Line 100:** seems to be called with empty typeDirectiveNames array for all files.

### ts-internals.js

- **Line 13:** This factory returns *only* functions which need a reference to the TS

### index.d.ts

- **Line 1:** named reexports are used instead of `export *` because

### type-detect.js

- **Line 125:** Most browsers currently adher to the W3C DOM Level 2 spec

### get.d.ts

- **Line 125:** This is needed to avoid being too lax with records types using number keys like `{0: string; 1: boolean}`.

### jsonify.d.ts

- **Line 5:** The return value has to be `any` and not `unknown` so it can match `void`.
- **Line 67:** The use of tuples in this first condition side-steps distributive conditional types

### lib.dom.d.ts

- **Line 1509:** that the provided high water mark will not be validated ahead of time. Instead, if it is negative, NaN, or not a number, the resulting ByteLengthQueuingStrategy will cause the corresponding stream constructor to throw.
- **Line 6806:** that script elements are not evaluated during parsing, and the resulting document's encoding will always be UTF-8.

### lib.es2015.generator.d.ts

- **Line 22:** 'next' is defined using a tuple to ensure we report the correct assignability errors in all places.

### lib.esnext.iterator.d.ts

- **Line 21:** This is specified as what is essentially an unreachable module. All actual global declarations can be found

### typescript.d.ts

- **Line 608:** Paths may also be directories.
- **Line 1425:** this us query-only operation and does not generate any output on disk.
- **Line 4502:** Consider calling `getEffectiveConstraintOfTypeParameter`
- **Line 5748:** that `@extends` is a synonym of `@augments`.
- **Line 5926:** that this field is only set by the module resolution process when
- **Line 6193:** that the resulting nodes cannot be checked.
- **Line 7964:** Transformation hooks should only be modified during `Transformer` initialization,
- **Line 8253:** Do not use this mode if you require accurate type errors; use [@link ParseForTypeErrors] instead.
- **Line 9267:** that the case of the config path has not yet been normalized, as no files have been imported into the project yet
- **Line 9586:** The file might not exist.
- **Line 9682:** that it is assumed that when asked about semantic diagnostics through this API,
- **Line 11327:** It is not allowed to call release on a SourceFile that was not acquired from

### typescript.js

- **Line 34692:** that theoretically the following condition would hold true literals like 009,
- **Line 60556:** cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
- **Line 149640:** that no attempt is made to take advantage of type argument inference
- **Line 166960:** there might be:
- **Line 178488:** that separators are part of the node in statements and class elements.
- **Line 178584:** after calling this, the TextChanges object must be discarded!
- **Line 190500:** that this does not return projects in info.containingProjects

### output.js

- **Line 101:** includes "all" option

### propmangle.js

- **Line 190:** debug is either false (disabled), or a string of the debug suffix to use (enabled).
- **Line 191:** debug may be enabled as an empty string, which is falsy. Also treat passing 'true'

### stringify.js

- **Line 24:** Be careful editing this code!  It's been tuned for performance

### v8-compile-cache.js

- **Line 228:** that this actually includes the newline character(s) in the

### line.js

- **Line 4:** that startCol and endCol are absolute positions

### index.js

- **Line 50:** that http://stackoverflow.com/a/4467559/3191 does NOT work for large modulos

### whatwg-encoding.js

- **Line 26:** that we won't end up in the x-user-defined case when there's a bomEncoding.

### infra.js

- **Line 3:** that we take code points as JS numbers, not JS strings.

### base.js

- **Line 21:** Intentionally not using string interpolation for performance reasons.

## OPTIMIZE Items (2)

### index.js

- **Line 249:** for compressibility

### nwsapi.js

- **Line 1644:** selectors avoiding duplicated checks

## REVIEW Items (9)

### types.d.ts

- **Line 2861:** requests to access organization resources with fine-grained personal access tokens
- **Line 2870:** a request to access organization resources with a fine-grained personal access token
- **Line 4410:** custom deployment protection rules for a workflow run
- **Line 4472:** pending deployments for a workflow run
- **Line 7690:** comments are in ascending order by ID.
- **Line 24253:** Requested Issue Event
- **Line 24271:** Request Removed Issue Event
- **Line 24289:** Dismissed Issue Event

### typescript.js

- **Line 196089:** can optimize by coalescing simple edits

## TODO Items (588)

### convert-chakra-to-tailwind.js

- **Line 24:** map Chakra props (bg, p, borderRadius, boxShadow) to Tailwind classes

### BFUIProvider.d.ts

- **Line 2:** Create comprehensive test suite for BFUIProvider

### AgentHealthMonitor.d.ts

- **Line 2:** Create comprehensive test suite for AgentHealthMonitor component

### remapping.umd.js

- **Line 40:** Eventually support sourceRoot, which has to be removed because the sources are already
- **Line 138:** We should eventually support async loading of sourcemap files.

### index.ts

- **Line 24:** remove later

### corejs2-built-ins.js

- **Line 1:** (Babel 8): remove this file as Babel 8 drop support of core-js 2

### corejs3-shipped-proposals.js

- **Line 1:** (Babel 8): remove this file now that it is included in babel-plugin-polyfill-corejs3

### plugin-bugfixes.js

- **Line 1:** (Babel 8): remove this file, in Babel 8 users import the .json directly

### core-js-compat.js

- **Line 1:** Remove in Babel 8

### normalize.js

- **Line 68:** Tree-based normalization of the ranges.

### code.js

- **Line 124:** do not allow arrays here

### index.js

- **Line 34:** refactor - remove compilations
- **Line 38:** if getFullPath removed 1 tests fails
- **Line 58:** can its length be used as dataLevel if nil is removed?
- **Line 135:** maybe localRefs should hold SchemaEnv
- **Line 162:** returns AnySchemaObject (if the schema can be inlined) or validation function
- **Line 178:** `Object.keys(root.schema).length > 0` should not be needed - but removing breaks 2 tests
- **Line 223:** PREVENT_SCOPE_CHANGE could be defined in keyword def?

### parse.js

- **Line 270:** loopEnum

### resolve.js

- **Line 7:** refactor to use keyword definitions

### util.js

- **Line 6:** refactor to use Set
- **Line 164:** maybe use global escapePointer

### boolSchema.js

- **Line 37:** maybe some other interface should be used for non-keyword validation errors...

### dataType.js

- **Line 126:** use gen.property

### index.js

- **Line 76:** maybe some hook to execute it in the end to check whether props/items are Name, as in assignEvaluated
- **Line 165:** assign unevaluated
- **Line 185:** typecast
- **Line 210:** make it "ok" call?
- **Line 427:** value.code for standalone

### keyword.js

- **Line 93:** add tests

### subschema.js

- **Line 56:** something is possibly wrong here with not changing parentDataProperty and not appending dataPathArr

### core.js

- **Line 374:** return type should be Ajv
- **Line 455:** atm it is allowed to overwrite schemas without id (instead of not adding them)
- **Line 501:** tests fail without this line

### additionalItems.js

- **Line 35:** var

### dependencies.js

- **Line 15:** change to reference

### oneOf.js

- **Line 26:** possibly fail straight away (with warning or exception) if there are two empty always valid schemas

### ref.js

- **Line 71:** will not work with async, it has to be returned with the result
- **Line 87:** tagged
- **Line 95:** refactor

### dynamicRef.js

- **Line 26:** the assumption here is that `recursiveRef: #` always points to the root

### format.js

- **Line 31:** simplify

### properties.js

- **Line 130:** maybe an option instead of hard-coded 8?

### pattern.js

- **Line 17:** regexp should be wrapped in try/catchs

### index.ts

- **Line 78:** possibly, it should be readonly

### subschema.ts

- **Line 8:** use Optional? align with SchemCxt property types

### core.ts

- **Line 394:** allow passing schema URI

### jtd-schema.ts

- **Line 138:** we can't actually check that everything in the union was specified
- **Line 187:** currently allows descriminator to be present in schema
- **Line 205:** these should only be allowed at the top level

### dependencies.ts

- **Line 19:** change to string[]

### index.js

- **Line 56:** Node.js 18.

### source-map-support.js

- **Line 138:** un-copy these from resolve-uri; see if they can be exported from that lib
- **Line 392:** Remove now that windows path support was added to resolve-uri and thus trace-mapping?
- **Line 629:** is there a better way to reliably get an instance of NodeError?

### emotion-cache.browser.development.esm.js

- **Line 181:** consider changing this comment placement in the next major version

### basic.d.ts

- **Line 3:** This can just be `export type Primitive = not object` when the `not` keyword is out.
- **Line 16:** Remove the `= unknown` sometime  in the future when most users are on TS 3.5 as it's now the default

### require-exactly-one.d.ts

- **Line 1:** Remove this when we target TypeScript >=3.5.

### api.js

- **Line 540:** Throw more verbose error
- **Line 850:** Maybe move elsewhere? Maybe combine with getConfig() logic?
- **Line 908:** Maybe move elsewhere?

### formatter.js

- **Line 10:** add [additonal formatters][1]

### index.js

- **Line 95:** remove at some point - for "universal" code (code should use `globalThis`)
- **Line 103:** remove this ASAP, but it currently causes tests to run really slow

### index.js

- **Line 90:** add type test that these are all the colors available in chalk.ForegroundColor
- **Line 97:** verify these are the names of istanbulReport.ReportOptions
- **Line 224:** Make sure to type these correctly

### index.js

- **Line 268:** check & read HasteFS instead of reading the filesystem:

### legacyFakeTimers.js

- **Line 452:** Use performance.now() once it's mocked

### generateEmptyCoverage.js

- **Line 138:** consider passing AST

### ScriptTransformer.js

- **Line 824:** do we need to define the generics twice?

### index.js

- **Line 129:** type `octokit.auth` based on passed options.authStrategy

### index.js

- **Line 47:** cover with tests that configs from workspace .npmrc have bigger priority

### index.js

- **Line 206:** remove version checks for 1.20 - 1.25 when we bump peer deps
- **Line 254:** remove options hook and hoist declarations when version checks are removed

### index.js

- **Line 405:** Drop if we do not support Node <= 16 anymore
- **Line 484:** We do not check if the key is a number here...
- **Line 1054:** set to false in next major release or remove

### index.js

- **Line 353:** remove this in next major

### glob-assets.js

- **Line 18:** Temporary workaround for https://github.com/mrmlnc/fast-glob/issues/47

### index.js

- **Line 246:** Make it return a web stream at some point.

### index.js

- **Line 265:** Use `not ''` when the `not` operator is available.
- **Line 270:** Use `not` operator here to remove `Map` and `Set` from type guard:

### dom.umd.js

- **Line 2450:** why does this not narrow?
- **Line 2561:** https://github.com/eps1lon/dom-accessibility-api/issues/100
- **Line 2585:** form-associated custom elements
- **Line 2707:** Unclear why display affects delimiter
- **Line 2806:** l10n
- **Line 2830:** wpt test consider label elements but html-aam does not mention them
- **Line 2870:** Do we generally need to block query IdRefs of attributes we have already consulted?
- **Line 2876:** Chrome will consider repeated values i.e. use a node multiple times while we'll bail out in computeTextAlternative.
- **Line 2980:** should this be reachable?
- **Line 3064:** Technically we need to make sure that node wasn't used for the accessible name

### event-map.js

- **Line 524:** load events can be UIEvent or Event depending on what generated them

### text.js

- **Line 30:** `matches` according lib.dom.d.ts can get only `string` but according our code it can handle also boolean :)

### query-helpers.js

- **Line 128:** This deviates from the published declarations

### role-helpers.js

- **Line 172:** This violates html-aria which does not allow any role on every element

### screen.js

- **Line 16:** Statically verify we don't rely on NodeJS implicit named imports.

### matchers-7fb38cd4.js

- **Line 662:** If we are truly just copying over stuff, would it make sense to move
- **Line 665:** This technique relies on CSS selectors; are those consistently
- **Line 1098:** Change condition to use instanceof against the appropriate element classes instead

### focus.js

- **Line 9:** simulate FocusEvent in browsers

### modifySelectionPerMouse.js

- **Line 15:** extend selection according to pointer position

### moveSelection.js

- **Line 10:** implement shift

### setSelectionPerMouse.js

- **Line 15:** Check what might be considered part of the same line of text.
- **Line 18:** support expanding initial range on multiple clicks if node is given
- **Line 23:** implement modifying selection per shift/ctrl+mouse

### updateSelectionOnFocus.js

- **Line 8:** update implementation to match that of current browsers

### index.js

- **Line 28:** deprecate the following implicit setting of position

### mouse.js

- **Line 133:** support extending range (shift)

### type.js

- **Line 6:** properly type guard

### object.d.ts

- **Line 1901:** Probably should just put all these methods on Object and forget about it.

### disposable.d.ts

- **Line 2:** remove once this package no longer supports TS 5.1, and replace with a

### indexable.d.ts

- **Line 2:** these methods are not used within @types/node, and should be removed at the next

### iterators.d.ts

- **Line 6:** remove once this package no longer supports TS 5.5, and replace NodeJS.BuiltinIteratorReturn with BuiltinIteratorReturn.

### promises.d.ts

- **Line 90:** Add `EventEmitter` close

### globals.d.ts

- **Line 254:** In next major @types/node version, change default TReturn to undefined.

### module.d.ts

- **Line 759:** consider removing in a future major version update

### net.d.ts

- **Line 46:** remove empty ConnectOpts placeholder at next major @types/node version.

### perf_hooks.d.ts

- **Line 99:** Narrow this based on entry type.

### test.d.ts

- **Line 2275:** change the export to a wrapper function once node@0db38f0 is merged (breaking change)

### timers.d.ts

- **Line 69:** remove in a future major version bump

### util.d.ts

- **Line 107:** , inspect: inspect

### wasi.d.ts

- **Line 159:** avoid DOM dependency until WASM moved to own lib.
- **Line 176:** Narrow to DOM types

### canary.d.ts

- **Line 43:** Upstream to microsoft/TypeScript-DOM-lib-generator -> w3c/webref
- **Line 66:** These should only be allowed with `as: 'image'` but it's not trivial to write tests against the full TS support matrix.

### index.d.ts

- **Line 4337:** Check impact of making React.ElementType<P = any> = React.JSXElementConstructor<P>

### index.d.ts

- **Line 201:** Remove the string ref special case from `PropsWithRef` once we remove LegacyRef
- **Line 528:** generalize this to everything in `keyof ReactHTML`, not just "input"
- **Line 1976:** double-check if this weird overload logic is necessary. It is possible it's either a bug
- **Line 2184:** change any to unknown when moving to TS v3
- **Line 4474:** It is SVGAnimateElement but is not in TypeScript's lib.dom.d.ts for now.
- **Line 4476:** It is SVGAnimateTransformElement but is not in TypeScript's lib.dom.d.ts for now.

### eslint-recommended-raw.js

- **Line 24:** - remove this once we no longer support ESLint v8

### no-floating-promises.js

- **Line 110:** #5439

### no-inferrable-types.js

- **Line 128:** - if we add more references

### no-misused-promises.js

- **Line 481:** - Once we're able to use `checker.isTypeAssignableTo` (v8), we can check an index

### no-mixed-enums.js

- **Line 154:** We don't need to dip into the TypeScript type checker here!

### no-unnecessary-type-arguments.js

- **Line 79:** would like checker.areTypesEquivalent. https://github.com/Microsoft/TypeScript/issues/13502

### no-unnecessary-type-assertion.js

- **Line 237:** - add contextually unnecessary check for this

### no-unsafe-argument.js

- **Line 199:** - we could break down the spread and compare the array type against each argument
- **Line 238:** - handle generic iterable case

### no-unused-vars.js

- **Line 585:** ######

### prefer-nullish-coalescing.js

- **Line 364:** also account for = in the ternary clause

### analyzeChain.js

- **Line 208:** - we could further reduce the false-positive rate of this check by
- **Line 428:** - #7170

### compareNodes.js

- **Line 145:** - handle this once TS supports it (https://github.com/microsoft/TypeScript/issues/42734)

### strict-boolean-expressions.js

- **Line 650:** we have to compare to 0n if the type is bigint
- **Line 655:** don't suggest this for bigint because it can't be NaN

### getOperatorPrecedence.js

- **Line 123:** Do we need to investigate the precedence here?
- **Line 156:** JSXElement?

### getContextualType.js

- **Line 74:** - support return statement checking

### isUnsafeAssignment.js

- **Line 74:** - figure out how to handle cases like this,

### clear-caches.js

- **Line 24:** - delete this in next major

### convert.js

- **Line 1788:** do we really want to convert it to Token?

### createIsolatedProgram.js

- **Line 66:** Support Windows CRLF

### createProjectService.js

- **Line 28:** Once we drop support for TS<5.3 we can import from "typescript" directly
- **Line 31:** see getWatchProgramsForProjects

### getWatchProgramsForProjects.js

- **Line 208:** file issue on TypeScript to suggest making optional?

### RuleCreator.js

- **Line 13:** - when the above PR lands; add type checking for the context.report `data` property

### SourceCode.d.ts

- **Line 272:** rename to 'tokens'

### implementation.js

- **Line 14:** use callBind.apply without breaking IE 8

### constants.js

- **Line 3:** increment this version if there are schema changes

### built-in-definitions.js

- **Line 337:** We should introduce overloaded instance methods definition
- **Line 360:** add async iterator dependencies when we support sub-dependencies

### index.d.ts

- **Line 90:** Remove this for the next major release, refactor the whole definition to:

### index.js

- **Line 12:** Remove this for the next major release

### index.d.ts

- **Line 1:** Make it this when TS suports that.

### index.js

- **Line 213:** Remove these aliases in the next major version

### utilities.js

- **Line 1:** When targeting Node.js 16, use `String.prototype.replaceAll`.

### lexer.js

- **Line 196:** <!-- XML comment support

### string-utils.js

- **Line 3:** look at porting https://www.npmjs.com/package/wrap-ansi to ESM.

### cell.js

- **Line 169:** cells should always exist - some tests don't fill it in though

### index.js

- **Line 154:** maybe save() to a url target could be a PUT or something?

### writerOpts.js

- **Line 130:** investigate why this code exists.

### index.d.ts

- **Line 1300:** Remove this in meow 14.

### compat.js

- **Line 28:** use `.flatMap` in core-js@4
- **Line 53:** Obsolete, remove from `core-js@4`

### targets-parser.js

- **Line 13:** Remove from `core-js@4`

### basic.d.ts

- **Line 24:** Make it this when targeting TypeScript 4.1:

### typed.js

- **Line 128:** review removal octal = false
- **Line 183:** Review Removal octal = true;

### index.js

- **Line 249:** Use https://github.com/sindresorhus/safe-stringify when the package is more mature. Just copy-paste the code.

### array-buffer.js

- **Line 64:** remove after dropping support for Node 20.
- **Line 66:** use `ArrayBuffer.transferToFixedLength()` instead once it is available

### ArraySpeciesCreate.js

- **Line 29:** figure out how to make a cross-realm normal Array, a same-realm Array

### DetachArrayBuffer.js

- **Line 37:** see if this might trigger listeners

### GetIterator.js

- **Line 57:** This should return an IteratorRecord

### LengthOfArrayLike.js

- **Line 19:** use this all over

### ArrayBufferByteLength.js

- **Line 13:** support this
- **Line 25:** see if IsFixedLengthArrayBuffer can be used here in the spec instead

### IsTypedArrayOutOfBounds.js

- **Line 37:** probably use package for array length

### GetIntrinsic.js

- **Line 3:** remove, semver-major

### isStringOrHole.js

- **Line 3:** semver-major: remove

### async-generator-request-record.js

- **Line 10:** confirm is a completion record

### shim.js

- **Line 17:** install Symbol.toStringTag if needed, once https://bugs.chromium.org/p/chromium/issues/detail?id=1477372 is fixed?

### eslint-plugin-prettier.js

- **Line 73:** Only use property when our eslint peerDependency is >=8.40.0.

### eslint-plugin-react-hooks.development.js

- **Line 1245:** we could potentially ignore early returns.
- **Line 1405:** also add an import?
- **Line 1406:** ideally we'd gather deps here but it would require
- **Line 1413:** What if the function needs to change on every render anyway?
- **Line 1418:** Why not report this at the dependency site?
- **Line 1709:** consider preserving the comments or formatting?
- **Line 1746:** Can this have a suggestion?

### index.js

- **Line 3:** this doesn't make sense for an ESLint rule.

### index.js

- **Line 34:** with TS 4.5+, inline this

### jsx-fragments.js

- **Line 71:** FIXME: can we fake these two descriptors?

### types.d.ts

- **Line 6:** fixme

### ast.js

- **Line 94:** properly warn on React.forwardRefs having typo properties

### linkComponents.js

- **Line 10:** type {(string | { name: string, linkAttribute: string })[]}
- **Line 15:** type {(string | { name: string, formAttribute: string })[]}

### referencer.js

- **Line 621:** ExportDeclaration doesn't exist. for bc?
- **Line 640:** `node.id` doesn't exist. for bc?

### flat-eslint.js

- **Line 1021:** This is pretty dirty...would be nice to clean up at some point.

### linter.js

- **Line 694:** espree validate parserOptions.globalReturn when sourceType is setting to module.(@aladdin-add)
- **Line 1228:** Remove after flat config conversion

### capitalized-comments.js

- **Line 20:** Combine w/ max-len pattern?

### indent-legacy.js

- **Line 721:** - come up with a better strategy in future
- **Line 1028:** Add appropriate configuration options for variable

### no-warning-comments.js

- **Line 85:** something`
- **Line 97:** something ... `

### index.js

- **Line 362:** We have a plan to remove this in a future major version.

### token-translator.js

- **Line 108:** See if this is an Acorn bug

### index.d.ts

- **Line 97:** should be: extends Array<unknown> = [] */,

### uri-js.test.ts

- **Line 734:** Verify this

### index.js

- **Line 10:** Remove the `...` when https://github.com/tc39/proposal-iterator-helpers is available.

### parenting.js

- **Line 53:** add assert here?

### form_data.js

- **Line 122:** Looks like there is bug in Node fs.createReadStream

### framer-motion.dev.js

- **Line 5751:** Prefer to remove this, but currently we have motion components with
- **Line 6153:** This could be faster to iterate as a flat array stored on the root node.
- **Line 6226:** Lazy-init
- **Line 6279:** Only running on root node
- **Line 6348:** Check here if an animation exists
- **Line 6587:** Incorporate into a forwarded scroll offset
- **Line 6876:** This is creating a new object every frame
- **Line 7052:** Schedule render
- **Line 7467:** Maybe we want to also resize the layout snapshot so we don't trigger
- **Line 7546:** Investigate why this transition is being passed in as {type: false } from Framer
- **Line 7747:** Doesn't support multiple shadows
- **Line 8024:** This is currently set on every individual VisualElement but feels
- **Line 8099:** This is impure and we should look at changing this to run on mount.
- **Line 8984:** maybe throw if v.length - 1 is placeholder token?
- **Line 9300:** Can probably change this to a !isControllingVariants check
- **Line 10494:** We use this data in relegate to determine whether to
- **Line 10977:** Update options in an effect. This could be tricky as it'll be too late
- **Line 12624:** More reusable data structures for targetSize/containerSize would also be good.
- **Line 13156:** See if people miss automatically updating shouldReduceMotion setting

### types.d-CtuPurYT.d.ts

- **Line 1442:** This might be better replaced with a method isParentMounted

### index.d.ts

- **Line 753:** Remove and move to library

### index.js

- **Line 5:** Document the `context` option and add to types when I know it's something I want to keep.

### functionsHaveNames.js

- **Line 5:** semver-major, remove

### index.js

- **Line 15:** Remove the `.reduce` call.

### index.d.ts

- **Line 66:** replace Function with actual signature

### core.js

- **Line 653:** We need negative look-behind support to do this properly
- **Line 2221:** remove with version 11.0
- **Line 2253:** remove v12, deprecated
- **Line 2404:** remove with v12
- **Line 2474:** Remove with v12 API

### ada.js

- **Line 49:** These spaces are not required by the Ada syntax

### elm.js

- **Line 25:** other constructors (built-in, infix).

### haml.js

- **Line 9:** support filter tags like :javascript, support inline HTML

### haskell.js

- **Line 37:** other constructors (build-in, infix).
- **Line 158:** characters.

### java.js

- **Line 101:** can this be removed somehow?

### julia.js

- **Line 366:** neatly escape normal code in string literal

### less.js

- **Line 129:** find a better solution?

### llvm.js

- **Line 90:** split into different categories of keywords

### markdown.js

- **Line 48:** fix to allow these to work with sublanguage also

### powershell.js

- **Line 66:** 'validate[A-Z]+' can't work in keywords

### python.js

- **Line 159:** Could these be supplemented by a CamelCase matcher in certain

### r.js

- **Line 194:** replace with negative look-behind when available

### swift.js

- **Line 273:** The following characters are also allowed, but the regex isn't supported yet.
- **Line 475:** Update for leading `-` after lookbehind is supported everywhere
- **Line 809:** Interpolation can contain any expression, so there's room for improvement here.

### vbnet.js

- **Line 151:** Use `beforeMatch:` for leading spaces
- **Line 159:** Use `beforeMatch:` for indentation once available

### yaml.js

- **Line 141:** remove |$ hack when we have proper look-ahead support

### index.d.ts

- **Line 107:** Old API, remove with v12

### dbcs-codec.js

- **Line 379:** What if we have no default? (resCode == undefined)
- **Line 505:** Callback with seq.

### dbcs-data.js

- **Line 64:** KDDI extension to Shift_JIS
- **Line 65:** IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
- **Line 66:** IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.

### index.d.ts

- **Line 2:** restrict this to require the brackets

### report-base.js

- **Line 3:** switch to class private field when targetting node.js 12

### rule.js

- **Line 107:** Write a utility function that appends a

### sl.js

- **Line 111:** Should we keep the original `message`?

### normalize.js

- **Line 592:** Type this properly

### index.js

- **Line 28:** remove re-export in Jest 30
- **Line 32:** in Jest 30 remove `SpyInstance` in favour of `Spied`

### index.js

- **Line 171:** Get appropriate type for `onCustomMessage`

### index.js

- **Line 278:** make mandatory in Jest 30
- **Line 1187:** will this work on windows? It might be better if `shouldInstrument` deals with it anyways
- **Line 1861:** consider warning somehow that this does nothing. We should support deletions, anyways
- **Line 2031:** remove this check in Jest 30

### common.js

- **Line 102:** is an absolute `cwd` supposed to be resolved against `root`?

### minimatch.js

- **Line 491:** It would probably be faster to determine this

### ChildProcessWorker.js

- **Line 246:** Add appropriate type check
- **Line 296:** At some point it would make sense to make use of

### js-yaml.js

- **Line 267:** Add tag format check.
- **Line 1755:** rework to inline fn with no type cast?

### api.js

- **Line 58:** NEWAPI move _cookieJar to window probably

### default-stylesheet.js

- **Line 425:** Add " i" to attribute matchers to support case-insensitive matching

### html.js

- **Line 131:** the rest of jsdom ignores this

### resource-loader.js

- **Line 105:** This deviates from the spec when it comes to

### Window.js

- **Line 106:** don't expose _globalObject and _globalProxy as public properties. While you're there, audit usage sites to
- **Line 148:** do an actual WindowProperties object. See https://github.com/jsdom/jsdom/pull/3765 for an attempt.
- **Line 567:** implement timer nesting level behavior.
- **Line 791:** targetOrigin === "/" requires getting incumbent settings object.
- **Line 811:** event.source - requires reference to incumbent window
- **Line 812:** event.origin - requires reference to incumbent window
- **Line 813:** event.ports
- **Line 814:** event.data - requires structured cloning
- **Line 889:** Parse pseudoElt

### xpath.js

- **Line 54:** not really needed, but supposedly tokenizer also disambiguates
- **Line 866:** use optimization. Also try element.getElementsByTagName
- **Line 1157:** figure out whether positions should be undefined here.
- **Line 1161:** with namespace
- **Line 1180:** I think this check is unnecessary
- **Line 1372:** namespaced version
- **Line 1648:** don't generate '/' nodes, just Axis nodes.
- **Line 1660:** give option
- **Line 1664:** is copy needed?
- **Line 1753:** we removed mutation events but didn't take care of this. No tests fail, so that's nice, but eventually we

### MouseEvent-impl.js

- **Line 17:** consider dispatch flag and return page-relative event coordinate once layout is supported
- **Line 18:** add horizontal scroll offset once jsdom implements scrolling support
- **Line 22:** add vertical scroll offset once jsdom implements scrolling support
- **Line 25:** consider dispatch flag and return target-relative event coordinate once layout is supported

### create-event-accessor.js

- **Line 39:** we don't implement BeforeUnloadEvent so we can't brand-check here
- **Line 176:** Consider replacing this with `[ReflectEvent]`

### form-controls.js

- **Line 230:** using parseFloatingPointNumber in addition to isValidFloatingPointNumber to pass number.html WPT.
- **Line 277:** The spec describes an imperative process for assigning/resetting an element's form

### http-request.js

- **Line 64:** investigate this further and ideally remove

### internal-constants.js

- **Line 6:** the many underscore-prefixed hooks should move here

### stylesheets.js

- **Line 7:** this should really implement https://html.spec.whatwg.org/multipage/links.html#link-type-stylesheet
- **Line 24:** "Set the CSS style sheet’s parent CSS style sheet, owner node and owner CSS rule to null."
- **Line 60:** title and disabled stuff
- **Line 80:** MIME type checking?
- **Line 93:** this is actually really messed up and overwrites the sheet on elementImpl

### MutationObserver-impl.js

- **Line 85:** revisit if https://github.com/jsdom/webidl2js/pull/108 gets fixed.

### Document-impl.js

- **Line 238:** account for encoding (once whatwg-url supports that)
- **Line 253:** implement, with tests for all code paths, the spec's behavior.
- **Line 939:** each style and link element should register its sheet on creation

### HTMLFrameElement-impl.js

- **Line 235:** this is not really correct behavior, because jsdom's window.close() is very aggressive and is meant for

### HTMLHyperlinkElementUtils-impl.js

- **Line 13:** Correctly check if the document is fully active
- **Line 46:** Create new browsing context, handle noopener
- **Line 78:** Handle hyperlink suffix and referrerpolicy

### HTMLImageElement-impl.js

- **Line 14:** handle crossorigin

### HTMLInputElement-impl.js

- **Line 206:** if/when layout is implemented, record the selected coordinate at the start of dispatch and use it here,

### HTMLLinkElement-impl.js

- **Line 44:** crossorigin="" or type=""
- **Line 77:** refactor into general link-fetching like the spec.
- **Line 90:** handle crossorigin="", nonce, integrity="", referrerpolicy=""

### HTMLOrSVGElement-impl.js

- **Line 27:** this should be [Reflect]able if we added default value support to webidl2js's [Reflect]

### HTMLScriptElement-impl.js

- **Line 139:** this text check doesn't seem completely the same as the spec, which e.g. will try to execute scripts with
- **Line 153:** implement modules, and then change the check to `type === null`.
- **Line 159:** implement nomodule here, **but only after we support modules**.

### SVGSVGElement-impl.js

- **Line 26:** optimize with _ids caching trick; see Document class.

### SVGListBase.js

- **Line 39:** support non-DOMString lists.
- **Line 98:** clone non-DOMString list elements.

### History-impl.js

- **Line 69:** structured clone data
- **Line 112:** If the current entry in the session history represents a non-GET request
- **Line 121:** clone again!! O_o

### SessionHistory.js

- **Line 72:** unload the active document with the recycle parameter set to false
- **Line 125:** structured clone

### FormData-impl.js

- **Line 109:** handle encoding
- **Line 110:** handling "constructing entry list"
- **Line 144:** handle form-associated custom elements.
- **Line 179:** formdata event

### xhr-utils.js

- **Line 63:** this should become "resource loading" when XHR goes through resource loader

### XMLHttpRequest-impl.js

- **Line 508:** Add support for URLSearchParams and ReadableStream

### XMLHttpRequestEventTarget-impl.js

- **Line 9:** remove this when we fix EventTargetImpl to use this._globalObject directly instead of using _ownerDocument.

### index.js

- **Line 1:** handle reviver/dehydrate function like normal

### helper.js

- **Line 18:** update to babel 7

### getPropLiteralValue-flowparser-test.js

- **Line 350:** We should fix this to check to see if we can evaluate it.

### jasmine-html.js

- **Line 604:** change this to check results.skipped

### jasmine.js

- **Line 90:** test better
- **Line 488:** pending tests
- **Line 595:** a simple suite
- **Line 597:** a simple suite with a nested describe block
- **Line 1187:** @deprecated as of Jasmine 0.11, remove soon [xw]
- **Line 1192:** @deprecated Deprecated as of Jasmine 0.10. Rewrite your custom matchers to return true or false. [xw]

### magic-string.cjs.js

- **Line 131:** is this block necessary?...
- **Line 830:** last chunk in the array may not be the last chunk, if it's moved...
- **Line 1029:** deprecate this? not really very useful
- **Line 1310:** there's a bunch of this sort of thing, needs cleaning up

### index.js

- **Line 54:** use media-typer
- **Line 78:** should this even be in this module?
- **Line 91:** use content-type or other module

### mime_cli.ts

- **Line 13:** Use json imports to access package.json once "import attributes" are

### ast.js

- **Line 344:** instead of injecting the start/end at this point, just return

### motion-dom.dev.js

- **Line 561:** Remove this cast - needed since Motion's stricter typing
- **Line 1067:** This should be passing * 1000
- **Line 1133:** Revisit this approach once we've moved to data models for values,
- **Line 1217:** Maybe we should warn here if there's a length mismatch
- **Line 1479:** The exception for inertia could be cleaner here
- **Line 1861:** This doesn't work if the final keyframe is a wildcard
- **Line 2203:** Does this have a better home? It could be shared with
- **Line 2319:** Could be re-enabled now we have support for linear() easing
- **Line 2517:** Filter out cancelled or stopped animations before returning
- **Line 2890:** We can throw if there are multiple keyframes and the value type changes.
- **Line 3047:** Can be accelerated but currently disabled until https://issues.chromium.org/issues/41491098 is resolved
- **Line 4262:** Go over existing targets and ensure they all have ids
- **Line 4283:** Go over new targets and ensure they all have ids
- **Line 4296:** If target is not "root", resolve elements

### async.js

- **Line 2903:** size could be changed

### range.js

- **Line 489:** build?

### index.js

- **Line 151:** Replace everything below with `urlObject.pathname = urlObject.pathname.replace(/(?<!\b[a-z][a-z\d+\-.]{1,50}:)\/{2,}/g, '/');` when Safari supports negative lookbehind.

### npx-cli.js

- **Line 9:** remove the affordances for removed items in npm v9

### cache.js

- **Line 82:** - eventually...

### completion.js

- **Line 178:** this was dead code, leaving it in case we find some command we
- **Line 214:** Ignoring coverage, see 'non EPIPE errors cause failures' test.

### config.js

- **Line 128:** complete with valid values, if possible.

### doctor.js

- **Line 118:** when we have an in progress indicator that could go here
- **Line 328:** display layer should do this

### fund.js

- **Line 80:** add !workspacesEnabled option handling to libnpmfund

### link.js

- **Line 165:** write tests for unmatching version specs, this is hard to test

### ls.js

- **Line 300:** there is a LOT of overlap with lib/utils/explain-dep.js here

### outdated.js

- **Line 121:** normalize usage of edges and avoid looping through nodes here

### pkg.js

- **Line 77:** https://github.com/npm/cli/issues/5508 a raw mode has been requested similar

### rebuild.js

- **Line 34:** when extending ReifyCmd
- **Line 78:** add tests for a package with missing version

### npm.js

- **Line 89:** should we throw here?

### display.js

- **Line 390:** this could probably be moved to arborist now that display is refactored

### get-workspaces.js

- **Line 12:** we need a better error to be bubbled up here if this call fails

### reify-output.js

- **Line 19:** output JSON if flatOptions.json is true

### build-ideal-tree.js

- **Line 364:** make buildIdealTree() and loadActual handle a missing root path,
- **Line 533:** create synthetic test case to simulate realpath failure
- **Line 550:** provide a way to fix bundled deps by exposing metadata about
- **Line 1217:** post arborist refactor, will need to check for installStrategy=linked

### index.js

- **Line 94:** we only ever look at this.options.replaceRegistryHost, not
- **Line 110:** We should change these to static functions instead
- **Line 145:** why is includeWorkspaceRoot a param?
- **Line 146:** why is workspaces a param?

### isolated-reifier.js

- **Line 112:** this approach feels wrong
- **Line 166:** make sure that idealTree object exists
- **Line 168:** test workspaces having bundled deps
- **Line 264:** we should probably not reference this.idealTree
- **Line 277:** We should mock better the inventory object because it is used by audit-report.js ... maybe
- **Line 388:** we should no-op is an edge has already been created with the same fromKey and toKey

### load-actual.js

- **Line 58:** remove options param in next semver major

### rebuild.js

- **Line 371:** these run before they're awaited

### reify.js

- **Line 57:** tests should not be this deep into internals
- **Line 330:** rollbacks shouldn't be relied on to throw err
- **Line 1525:** this ignores options.save

### can-place-dep.js

- **Line 366:** represent peerPath in ERESOLVE error somehow?

### node.js

- **Line 122:** if this came from pacote.manifest we don't have to do this,

### query-selector-all.js

- **Line 724:** Need a test with an infinite loop
- **Line 805:** (future) loop over ancestry property

### shrinkwrap.js

- **Line 153:** limit concurrency here, this is recursive
- **Line 212:** what uses this?
- **Line 436:** emit a warning here or something if both are present.

### vuln.js

- **Line 62:** duped entries may require different fixes but the current

### definition.js

- **Line 5:** some kind of categorization system, so we can

### definitions.js

- **Line 87:** refactor these type definitions so that they are less
- **Line 89:** use better type definition/validation API, nopt's is so weird.
- **Line 2253:** this is a derived value, and should be reworked when we have a

### index.js

- **Line 6:** make these getters so that we only have to make dirty
- **Line 10:** move nerfdart auth stuff into a nested object that
- **Line 37:** when we switch off of nopt, use an arg parser that supports

### index.js

- **Line 1:** set the scope config from package.json or explicit cli config
- **Line 821:** evaluate removing 'email' from the credentials object returned here

### type-defs.js

- **Line 60:** make nopt less of a global beast so this kludge isn't necessary

### normalize.js

- **Line 446:** exports is much more complicated than this in verbose format

### browser.js

- **Line 111:** add a `localStorage` variable to explicitly enable/disable colors

### diff.js

- **Line 113:** Remove the `+ 1` here to make behavior match Myers algorithm

### index.js

- **Line 81:** When there is more than one value present for a given directive (e.g., two Expires header fields, multiple Cache-Control: max-age directives),

### init-package-json.js

- **Line 48:** test for non-default definitions

### ipv6.js

- **Line 301:** probably useful to have a numeric version of this too
- **Line 530:** Improve the semantics of this helper function
- **Line 549:** Make private?
- **Line 949:** revisit why this is necessary

### index.js

- **Line 1289:** allow reseeding after first request

### index.js

- **Line 7:** we test this condition in the diff command

### entry.js

- **Line 298:** if the cache write fails, log a warning but return the response anyway

### index.js

- **Line 36:** remove when Node v8 support drops

### fetcher.js

- **Line 251:** check error class, once those are rolled out to our deps

### git.js

- **Line 225:** after cloning, create a tarball of the folder, and add to the cache

### index.js

- **Line 7:** test perf of fs/promises realpath vs realpathCB,

### read.js

- **Line 16:** add tests for edit
- **Line 32:** add tests for timeout
- **Line 41:** add tests for edit + default
- **Line 57:** add tests for rejecting
- **Line 66:** add tests for silent
- **Line 73:** add tests for default
- **Line 79:** add tests for sigint

### cert.js

- **Line 142:** test coverage for this case

### entry.js

- **Line 23:** Remove this parameter once have completely switched to 'dsse' entries
- **Line 27:** Remove this conditional once have completely ditched "intoto" entries

### certificate.js

- **Line 113:** Add support for authorityCertIssuer/authorityCertSerialNumber

### index.js

- **Line 9:** this should really be a hardcoded list of algorithms we support,
- **Line 568:** - it's unclear _which_ of these Node will actually use as its name

### mkdir.js

- **Line 4:** This should probably be a class, not functionally

### updater.js

- **Line 251:** use length for fetching

### nwsapi-traversal.js

- **Line 8:** all of this needs tests

### doc.js

- **Line 1246:** Remove this in v4

### date.js

- **Line 43:** (special)

### action.js

- **Line 28:** create home() in prompt types (e.g. TextPrompt)
- **Line 30:** create end() in prompt types (e.g. TextPrompt)

### react-is.development.js

- **Line 27:** We don't use AsyncMode or ConcurrentMode anymore. They were temporary

### test.js

- **Line 105:** Should we be stricter and perform validation?

### _stream_writable.js

- **Line 289:** defer error events consistently everywhere, not just the cb

### regenerate.js

- **Line 1141:** Optimize this by writing and using `dataIntersectionData()`.

### rewrite-pattern.js

- **Line 670:** consider changing this at the regenerate level.
- **Line 877:** remove modifiers: 'parse' in regexpu-core v7

### rollup-plugin-typescript2.cjs.js

- **Line 895:** remove this in the next major version

### index.js

- **Line 2459:** emit errors properly. Example: EMFILE on Macos.
- **Line 3085:** real check
- **Line 3571:** Strange thing: "should not choke on an ignored watch path" will be failed without 2 ready calls -__-
- **Line 3714:** this is not equal to path-normalize module - investigate why

### rollup.js

- **Line 7357:** this should be removed once ImportExpression follows official ESTree
- **Line 12796:** once ImportExpression follows official ESTree specs with "null" as
- **Line 15877:** we are pretending it was not found while it should behave like "undefined"

### watch.js

- **Line 138:** throws or warn? Currently just ignore, uses new event

### CSSValue.js

- **Line 10:** add if needed

### index.js

- **Line 85:** look into also checking the `bugs`/`homepage` URLs

### parse.js

- **Line 46:** Actually, everything is concatenated into one string

### index.d.ts

- **Line 23:** remove this in the next major version, refactor the whole definition to:

### index.js

- **Line 10:** Use `node:stream/promises` when targeting Node.js 16.

### cookieJar.js

- **Line 347:** It feels weird to be manipulating the store as a side effect of a method.
- **Line 403:** Refactor to avoid using a callback
- **Line 555:** persist lastAccessed
- **Line 847:** Refactor to avoid using callback

### memstore.js

- **Line 39:** It's weird that `allowSpecialUseDomain` defaults to false with no callback,

### index.js

- **Line 152:** make this more efficient

### index.js

- **Line 3:** use call-bind, is-date, is-regex, is-string, is-boolean-object, is-number-object
- **Line 12:** use isarray
- **Line 17:** use for-each?
- **Line 26:** use object-keys
- **Line 36:** use reflect.ownkeys and filter out non-enumerables
- **Line 52:** use object.hasown
- **Line 321:** replace with object.assign?

### super_deep.js

- **Line 52:** this one

### index.js

- **Line 1195:** handle type-only imports

### init.js

- **Line 5:** see what's the best path for this

### arrayable.d.ts

- **Line 28:** Use `readonly T[]` when this issue is resolved: https://github.com/microsoft/TypeScript/issues/17002

### array.d.ts

- **Line 15:** should unknown-array be updated?

### subtract.d.ts

- **Line 36:** Support big integer.

### node-internal-modules-cjs-helpers.js

- **Line 20:** Use this set when resolving pkg#exports conditions in loader.js.

### node-internal-modules-esm-resolve.js

- **Line 92:** receive cached fs implementations here

### node-options.js

- **Line 50:** handle errors somehow

### bin.js

- **Line 454:** this comes from BootstrapState

### configuration.js

- **Line 303:** technically, outDir is absolute path, but exclude should be relative glob pattern?
- **Line 304:** compute baseUrl

### esm.js

- **Line 103:** file://./foo sets `hostname` to `'.'`.  Perhaps we should special-case this.

### index.js

- **Line 227:** switch to getCanonicalFileName we already create later in scope
- **Line 390:** ordering of this with getScriptVersion?  Should they sync up?

### repl.js

- **Line 126:** Figure out how to handle completion here.
- **Line 156:** should evalCode API get the same error-handling benefits?
- **Line 203:** assert that `service` is set; remove all `service!` non-null assertions

### resolver-functions.js

- **Line 101:** consider using `ts.loadWithTypeDirectiveCache`

### swc.js

- **Line 107:** cache the results of this; slightly faster

### util.js

- **Line 135:** technically breaks if projectOption is path to a file, not a directory,

### typescript.js

- **Line 13781:** don't use slice
- **Line 19811:** Should prefix `++` and `--` be moved to the `Update` precedence?
- **Line 31393:** GH#18217
- **Line 32782:** should we separate these branches out?
- **Line 58754:** could probably serialize as function + ns + class, now that that's OK
- **Line 58844:** https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
- **Line 134671:** syntax errors????
- **Line 156361:** Maybe we should handle this? See fourslash test `refactorConvertToEs6Module_export_object_shorthand.ts`.
- **Line 164589:** Handle auto quote preference.
- **Line 170969:** GH#23879
- **Line 174930:** should have its own kind?

### uri.all.js

- **Line 1013:** normalize IPv6 address as per RFC 5952

### v8-to-istanbul.js

- **Line 72:** investigate whether there's ever a case where we hit this logic with 1:many sources.
- **Line 252:** could we move the resolving logic for 1:1 source maps to the final

### attributes.js

- **Line 28:** Check well-formedness

### url-state-machine.js

- **Line 1042:** If c is not a URL code point and not "%", parse error.
- **Line 1071:** Add: not a URL code point

### urlencoded.js

- **Line 47:** accept and use encoding argument

### Document-9b4560a1.js

- **Line 18:** Set true in v2

### Schema-88e323a7.js

- **Line 393:** deprecate/remove class check
- **Line 484:** remove in v2

### browser.js

- **Line 4:** figure out reasonable web equivalents for "resolve", "normalize", etc.

### index.js

- **Line 37:** figure  out a  way to combine ESM and CJS coverage, such  that

### index.js

- **Line 8:** Remove this when targeting Node.js 12.
- **Line 14:** Use private class fields when targeting Node.js 12.

### base.js

- **Line 4:** Use a better method when it's added to Node.js (https://github.com/nodejs/node/pull/40240)

### theme.ts

- **Line 43:** Extend semanticTokens.colors with brand and status colors:
- **Line 45:** Define additional semantic tokens for borderWidths, zIndices, letterSpacings, lineHeights, and fontFamily
- **Line 46:** Add textStyles (h1–h6, body1, body2, caption, small) for richer typography control
- **Line 47:** Integrate Chakra's CSSReset or GlobalStyle under styles.global for comprehensive element normalization
- **Line 75:** Expand button styleConfig to use semanticTokens for primary, secondary, error, etc.
- **Line 133:** Add Modal, Toast, Form, Data, Layout components here
- **Line 139:** Scaffold styleConfigs for additional component categories:

## XXX Items (75)

### inflight.js

- **Line 23:** It's somewhat ambiguous whether a new callback added in this

### sync.js

- **Line 388:** review this.  Shouldn't it be doing the mounting etc

### minimatch.js

- **Line 859:** remove this slice.  Just pass the start index.

### ast.js

- **Line 483:** abstract out this map method

### preload.js

- **Line 3:** remove in v8 or beyond

### index.js

- **Line 137:** this is incorrect. we have multicharacter flags like `-iwr` that

### cache.js

- **Line 140:** this could leave other entries without content!

### ci.js

- **Line 109:** should we remove this finally??

### doctor.js

- **Line 164:** get the latest in the current major as well

### fund.js

- **Line 24:** maybe worth making this generic for all commands?

### help.js

- **Line 17:** these are used in the docs workspace and should be exported

### publish.js

- **Line 194:** can't pacote read the manifest from a directory?

### team.js

- **Line 44:** "description" option to libnpmteam is used as a description of the

### package-url-cmd.js

- **Line 26:** It is very odd that `where` is how pacote knows to look anywhere

### display.js

- **Line 328:** in a future (breaking?) change it might make sense for run-script to

### error-message.js

- **Line 386:** we should stop throwing strings
- **Line 395:** we should stop throwing other non-errors

### build-ideal-tree.js

- **Line 559:** this belongs in the audit report itself, not here.
- **Line 583:** how to handle top nodes that aren't the root?  Maybe the report
- **Line 649:** this could be faster by doing a series of inventory.query('name')
- **Line 652:** add any invalid edgesOut to the queue
- **Line 753:** also push anything that depends on a node with a name
- **Line 1006:** This is somehow load bearing.  This makes tests that print

### load-actual.js

- **Line 71:** deprecate separate method options objects.

### load-virtual.js

- **Line 37:** deprecate separate reify() options object.

### reify.js

- **Line 413:** if we have an existing diff already, there should be a way
- **Line 832:** use a magic string that isn't also a valid value, like

### edge.js

- **Line 55:** where is this used?
- **Line 66:** are all of these error states even possible?

### node.js

- **Line 1009:** need to check for two root nodes?

### place-dep.js

- **Line 42:** this only appears to be used by tests
- **Line 237:** if we are replacing SOME of a peer entry group, we will need to
- **Line 335:** handle replacing an entire peer group?
- **Line 510:** decorate more with this.canPlace and this.canPlaceSelf,

### shrinkwrap.js

- **Line 203:** this is duplicated in this.load(), but using loadFiles instead of resetFiles
- **Line 577:** is this even reachable?
- **Line 872:** why is this different from pathFixed in this.add??

### definitions.js

- **Line 127:** We should really deprecate all these `--save-blah` switches
- **Line 1665:** update arborist to just ignore it if resulting saveType is peer

### errors.js

- **Line 10:** context.code is undefined in all constructors used in cp/polyfill

### advisory.js

- **Line 267:** if bundled, then semver.intersects() means vulnerable

### normalize.js

- **Line 609:** should a future breaking change delete bin entries that cannot be accessed?

### set-path.js

- **Line 21:** we should specify a cwd that we don't go above
- **Line 33:** include the node-gyp-bin path somehow?  Probably better for

### pax.js

- **Line 54:** split the path
- **Line 134:** Values with \n in them will fail this.

### unpack.js

- **Line 678:** get the type ('symlink' or 'junction') for windows

### browser.js

- **Line 208:** (@Qix-) should we be logging these?

### common.js

- **Line 120:** Temporary. Will be removed in the next major release.
- **Line 262:** DO NOT USE. This is a temporary stub function.
- **Line 263:** It WILL be removed in the next major release.

### helpers.js

- **Line 18:** Use #base-2 .value-0 instead?

### get-bin-from-manifest.js

- **Line 10:** probably a util to parse this better?
- **Line 16:** need better error message

### index.js

- **Line 18:** this should really be split up and unit-ized for easier testing

### install.js

- **Line 42:** use a different footer line if some aren't fixable easily.

### npa.js

- **Line 259:** backwards compatibility lack of compliance with RFC 8089
- **Line 275:** end RFC 8089 violation backwards compatibility section

### fetcher.js

- **Line 101:** fill more of this in based on what we know from this.opts

### git.js

- **Line 103:** make this a custom error class

### registry.js

- **Line 47:** pacote <=9 has some logic to ignore opts.resolved if
- **Line 136:** add ETARGET and E403 revalidation of cached packuments here

### index.js

- **Line 147:** remove v.length check to remove cb from functions
- **Line 149:** if cb is no longer an argument then this.#ctx should
- **Line 165:** remove this to require throwing an error instead of

### list.js

- **Line 3:** This shares a lot in common with extract.js

### test.js

- **Line 354:** 80');
- **Line 355:** 1337');
- **Line 362:** 443');
- **Line 370:** 70');
- **Line 374:** 21');

### pattern.js

- **Line 155:** would be nice to handle patterns like `c:*` to test the cwd

### source-map.debug.js

- **Line 2155:** file:// URIs and absolute paths lead to unexpected behavior for

### compress.js

- **Line 12099:** intentionally falling down to the next case

### output.js

- **Line 1947:** I'm not exactly sure if we need it for all of these nodes,

