# Security Component

This component provides standardized security scanning and vulnerability checks for Bluefly CI / CD pipelines.

## Inputs

| Name | Type | Required | Default | Description |
|------|------|----------|---------|-------------|
| stage | string | false | validate | The stage in which to run this component |
| image | string | false | node:16 | Docker image to use for security scanning |
| use_custom_image | boolean | false | false | Whether to use a custom image |
| custom_image_path | string | false | "" | Path to custom Docker image if use_custom_image is true |
| security_scan_enabled | boolean | false | true | Whether to enable security scanning |
| dependency_check_enabled | boolean | false | true | Whether to enable dependency checking |
| security_level | string | false | "high" | Security level for scanning (low, medium, high) |
| scanner_version | string | false | "latest" | Version of security scanner to use |
| variables | object | false | {} | Additional variables to pass to the job |
| allow_failure | boolean | false | true | Whether to allow this job to fail without failing the pipeline |

## Usage Example

```yaml
include:
  - project: 'bluefly / internal - projects / llm / bfcicomponents'
    file: 'templates / security / template.yml'

security_check:
  extends: .security_template
  variables:
    SECURITY_LEVEL: "high"
    DEPENDENCY_CHECK_ENABLED: "true"
  allow_failure: false
