# Test Component

A reusable GitLab CI/CD component for testing Node.js applications.

## Features

- Automated test execution
- Coverage reporting
- JUnit test results
- Configurable test scripts
- Coverage thresholds

## Usage

```yaml
include:
  - component: gitlab.com/bluefly/ci-components/test@1.0.0
    inputs:
      stage: test
      image: node:16
      test_script: npm test
      coverage_script: npm run test:coverage
```

## Configuration

### Inputs

| Input | Description | Default |
|-------|-------------|---------|
| stage | Stage name | test |
| image | Docker image | node:16 |
| test_script | Test script | npm test |
| coverage_script | Coverage script | npm run test:coverage |
| artifacts | Artifacts path | coverage/ |
| reports | Test reports | junit: test-results.xml, coverage: coverage/lcov.info |

## Development

### Testing

```bash
npm test
```

### Contributing

1. Fork the repository
2. Create a feature branch
3. Submit a merge request 
