# Test Component

This component provides standardized testing configurations for Bluefly CI / CD pipelines.

## Inputs

| Name | Type | Required | Default | Description |
|------|------|----------|---------|-------------|
| stage | string | false | test | The stage in which to run this component |
| image | string | false | node:16 | Docker image to use for testing |
| use_custom_image | boolean | false | false | Whether to use a custom image |
| custom_image_path | string | false | "" | Path to custom Docker image if use_custom_image is true |
| test_framework | string | false | "jest" | Testing framework to use |
| test_coverage_threshold | string | false | "80" | Minimum coverage percentage required |
| test_environment | string | false | "node" | Environment to run tests in |
| test_reporters | string | false | "default, junit" | Test reporters to use |
| variables | object | false | {} | Additional variables to pass to the job |
| allow_failure | boolean | false | false | Whether to allow this job to fail without failing the pipeline |

## Usage Example

```yaml
include:
  - project: 'bluefly / internal - projects / llm / bfcicomponents'
    file: 'templates / test / template.yml'

run_unit_tests:
  extends: .test_template
  variables:
    TEST_FRAMEWORK: "jest"
    TEST_COVERAGE_THRESHOLD: "90"
  coverage: ' / ^\s * Lines:\s * \d + \.\d + % / '
