# Acme AI Platform Release Automation

This tool automates dependency-ordered release, validation, and CI/CD for all Acme AI Platform projects.

## Features
- Validates, pushes, and merges each project in strict dependency order
- Waits for CI to pass before proceeding to the next project
- Logs all actions and results for traceability
- Enforces OpenAPI and CI/CD compliance

## Usage

1. Install dependencies:
   ```sh
   npm install
   ```
2. Build the tool:
   ```sh
   npm run build
   ```
3. Run the release automation:
   ```sh
   npm start
   ```

## Requirements
- Node.js 18+
- GitLab API access token (for MR and CI operations)
- llmcli installed and available in PATH

## Configuration
- Update `src/release.ts` for project-specific validation and release logic.

---

This tool is intended for use by Acme AI Platform maintainers to ensure stable, compliant, and observable releases across all components. 