import { defineUserConfig } from 'vuepress';
import { defaultTheme } from '@vuepress/theme-default';
import { viteBundler } from '@vuepress/bundler-vite';

export default defineUserConfig({
  lang: 'en-US',
  title: 'BFCI Components',
  description: 'BlueFly CI Components Documentation',
  bundler: viteBundler(),
  theme: defaultTheme({
    navbar: [
      { text: 'Home', link: '/' },
      { text: 'Guide', link: '/guide/' },
      { text: 'Components', link: '/components/' },
    ],
    sidebar: [
      {
        text: 'Guide',
        children: [
          '/guide/README.md',
          '/guide/getting-started.md',
          '/guide/configuration.md',
          '/guide/contributing.md',
        ],
      },
      {
        text: 'Components',
        children: ['/components/README.md'],
      },
    ],
  }),
});
