---
id: components-bfcicomponents-CLAUDE
---
# BFCIComponents Commands

This file contains useful commands that Claude can use to maintain the BFCIComponents repository.

## Validation

To validate all CI components:

```bash
npm run validate
```

## Migration

To migrate a project from BFCommon CI to BFCIComponents:

```bash
npm run migrate-project /path/to/project/.gitlab-ci.yml
```

## Verification

To verify Docker image usage in a CI configuration:

```bash
npm run verify-image /path/to/project/.gitlab-ci.yml
```

## llmcli Integration

BFCIComponents is integrated with llmcli through these commands:

```bash
# Migrate CI configuration for all projects
llmcli dev migrate-ci

# Migrate CI configuration for specific projects
llmcli dev migrate-ci --projects BFAPI,llm-ui

# Verify Docker image usage for all projects
llmcli dev verify-ci

# Verify Docker image usage for specific projects
llmcli dev verify-ci --projects BFAPI,llm-ui
```

## Building

There is no build step for BFCIComponents as it's a collection of CI/CD component templates rather than compiled code.

## Testing

To manually test the components, include them in a test project's `.gitlab-ci.yml`:

```yaml
include:
  - component: 'gitlab://blueflyio/BFCIComponents/components/nodejs-base.yml'
    inputs:
      node_version: '20'
      project_type: 'app'
      use_custom_image: true
      custom_image_path: 'registry.gitlab.bluefly.io/blueflyio/internal-projects/core-assets/bluefly-docker-image:latest'
```
