---
home: true
title: BFCI Components
description: BlueFly CI Components Documentation
actions:
  - text: Get Started
    link: /guide/getting-started.html
    type: primary
  - text: Components
    link: /components/
    type: secondary
features:
  - title: Standardized CI/CD Components
    details: Pre-built, tested, and maintained CI/CD components for GitLab pipelines
  - title: Easy Integration
    details: Simple configuration and seamless integration with GitLab projects
  - title: Security Best Practices
    details: Built-in security features and compliance with industry standards
footer: MIT Licensed | Copyright © 2024 BlueFly
---

# BFCI Components

Welcome to the BFCI Components documentation! This guide will help you get started with using our standardized CI/CD components in your GitLab projects.

## Quick Start

1. Add the component registry to your project:

```yaml
variables:
  COMPONENT_REGISTRY: registry.gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents
```

2. Install the npm package:

```bash
npm install @bfci/components
```

## Documentation

- [Getting Started Guide](/guide/getting-started.html)
- [Configuration Guide](/guide/configuration.html)
- [Contributing Guide](/guide/contributing.html)
- [Components Reference](/components/)

## Support

If you need help or have questions:

1. Check the [documentation](/guide/)
2. Search existing [issues](https://gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/-/issues)
3. Create a new issue if needed

## License

This project is licensed under the [MIT License](https://gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/-/blob/main/LICENSE).
