---
id: components-bfcicomponents-components-README
---
# BFCI Components

This section documents all available BFCI Components and their usage.

## Available Components

### Test Component

The test component provides standardized testing configuration for your projects.

```yaml
include:
  - component: registry.gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/test@1.0.0
    inputs:
      test_command: 'npm test'
      coverage_path: 'coverage'
```

### Lint Component

The lint component provides standardized linting configuration.

```yaml
include:
  - component: registry.gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/lint@1.0.0
    inputs:
      lint_command: 'npm run lint'
```

### Build Component

The build component provides standardized build configuration.

```yaml
include:
  - component: registry.gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/build@1.0.0
    inputs:
      build_command: 'npm run build'
```

### Deploy Component

The deploy component provides standardized deployment configuration.

```yaml
include:
  - component: registry.gitlab.bluefly.io/blueflyio/internal-projects/llm/bfcicomponents/deploy@1.0.0
    inputs:
      environment: 'production'
      deploy_command: 'npm run deploy'
```

## Component Configuration

Each component accepts various configuration options. Check the individual component documentation for details.

## Versioning

Components follow semantic versioning (MAJOR.MINOR.PATCH):

- MAJOR: Breaking changes
- MINOR: New features (backward compatible)
- PATCH: Bug fixes (backward compatible)

## Contributing

To contribute new components or improve existing ones, please see our [Contributing Guide](../../guide/contributing).
