---
id: components-bfrfp-README
---
# Project Documentation

This directory contains the documentation for this project. The documentation is automatically synced with the main BFDOCS repository.

## Directory Structure

- `api/` - API documentation
- `architecture/` - Architecture documentation
- `ci/` - CI/CD documentation
- `cli/` - CLI documentation
- `examples/` - Example code and usage
- `features/` - Feature documentation
- `guides/` - User and developer guides
- `integration/` - Integration documentation
- `ml/` - Machine learning documentation
- `monitoring/` - Monitoring documentation
- `projects/` - Project-specific documentation
- `scripts/` - Script documentation and tests
- `templates/` - Template files
- `technical/` - Technical documentation

## Syncing with BFDOCS

Documentation is automatically synced with the main BFDOCS repository through GitLab CI/CD. The sync process runs on a schedule and when documentation changes are pushed to the main branch.

## Contributing

When adding or updating documentation:

1. Place files in the appropriate directory
2. Follow the existing documentation style
3. Include frontmatter with title, description, and date
4. Use relative links to other documentation
5. Update the table of contents if necessary
