/**
 * Setup for integration tests
 * This file runs before the integration tests
 */

// Set longer timeout for integration tests
jest.setTimeout(30000);

// Global setup
global.testSetup = {
  apiUrl: process.env.TEST_API_URL || 'http://localhost:3000',
  testFilePath: './__tests__/fixtures/sample-rfp.txt',
};

// Cleanup function that runs after all tests
afterAll(async () => {
  console.log('Integration tests completed, cleaning up...');
});
