---
title: API Documentation
description: API reference and documentation
id: components-bluefly_insights-api-README
---

# API Documentation

## Overview

This section contains the complete API reference for the component.

## Endpoints

### REST API

- [Authentication](./rest/auth)
- [Core Endpoints](./rest/core)
- [Error Handling](./rest/errors)

### GraphQL API

- [Schema](./graphql/schema)
- [Queries](./graphql/queries)
- [Mutations](./graphql/mutations)

## Authentication

Details about authentication methods and security.

## Rate Limiting

Information about rate limits and quotas.

## Error Codes

List of error codes and their meanings.

## Examples

Code examples for common use cases.
