# VuePress to Docusaurus Plugin Migration Guide

## Plugin Mappings

### @vuepress/plugin-search
**Docusaurus Equivalent**: @docusaurus/plugin-content-docs

**Note**: Use Algolia DocSearch or @easyops-cn/docusaurus-search-local

**Setup**:
```javascript
// For Algolia DocSearch:
themeConfig: {
  algolia: {
    appId: 'YOUR_APP_ID',
    apiKey: 'YOUR_API_KEY',
    indexName: 'YOUR_INDEX_NAME',
  },
}

// For local search:
// npm install @easyops-cn/docusaurus-search-local
plugins: [
  [
    require.resolve("@easyops-cn/docusaurus-search-local"),
    {
      hashed: true,
      language: ["en"],
    },
  ],
]
```
