---
id: modules-README
---
# Drupal Modules Documentation

This directory contains comprehensive documentation for all Drupal modules in the LLM Platform AI platform.

## Production Modules (85%+ Complete)
- **[api_normalization](./production/api_normalization/)** - 95% - Field API integration, plugin system, Views integration
- **[llm](./production/llm/)** - 90% - Enterprise LLM platform with multi-model support
- **[secure_drupal](./production/secure_drupal/)** - 85% - Enterprise security framework

## Development Modules (50-85% Complete)
- **[drupal_migration_plus](./development/drupal_migration_plus/)** - AI-assisted migration tools
- **[field_eca_bridge](./development/field_eca_bridge/)** - Field API to ECA workflow bridge
- **[langchain](./development/langchain/)** - LangChain PHP implementation
- **[blockchain_manager](./development/blockchain_manager/)** - Multi-chain integration
- **[native_ai](./development/native_ai/)** - Native AI integration framework
- **[experience_builder_converter](./development/experience_builder_converter/)** - Site Studio migration

## Archived Modules
- **[ai_swarm_intelligence](./archived/ai_swarm_intelligence/)** - Replaced by AI + ECA approach
- **[alternative_services](./archived/alternative_services/)** - Functionality covered by core DI

For detailed module assessments, see [MODULE_ASSESSMENTS_DETAILED.md](./MODULE_ASSESSMENTS_DETAILED).
