---
id: modules-development-drupal_migration_plus-DRUPAL_ORG_PAGE
---
# Drupal Migration Plus

Drupal Migration Plus is an advanced migration framework for Drupal, extending core migration capabilities with enhanced field mapping, multi-CMS support, and improved migration workflows. It simplifies complex migrations and provides a structured approach to moving content between systems.

## Features

- **Enhanced Field Mapping**: Visual field mapping tools and intelligent field type detection
- **Multi-CMS Support**: Migration adapters for Drupal, WordPress, and other CMS platforms
- **Migration Clustering**: Smart grouping of related migration tasks
- **Workflow Automation**: Step-by-step migration processes with validation and preview
- **Custom Process Plugins**: Additional process plugins for complex transformations
- **Recipe System**: Recipe-based migration configurations for common scenarios
- **Performance Optimization**: Improved migration performance and monitoring

## Use Cases

- **Site Upgrades**: Migrate from older Drupal versions to the latest release
- **CMS Migration**: Move content from WordPress, Joomla, or other platforms to Drupal
- **Content Restructuring**: Transform content during migration to match new site architecture
- **Data Integration**: Import content from external systems into Drupal
- **Multi-site Consolidation**: Combine multiple sites into a single Drupal installation
- **Incremental Migration**: Migrate content in stages with validation between phases
- **Complex Field Mapping**: Handle complex field transformations during migration

## Requirements

- Drupal 10.1 or later
- PHP 8.1 or later
- Required modules:
  - Migrate (Drupal core)
  - Migrate Drupal (Drupal core)
  - Migrate Drupal UI (Drupal core)
  - Migrate Plus
  - Migrate Tools

## Similar Modules

- **Migrate Plus**: Provides extensions to core migration framework (required by this module)
- **Migrate Tools**: Provides additional Drush commands for migration (required by this module)
- **Migrate Upgrade**: Focused specifically on Drupal-to-Drupal upgrades
- **Migrate Source CSV/JSON**: For specific source formats, can be used with this module

## Credits

The Drupal Migration Plus module was developed by the Drupal Migration Plus Team with contributions from the Drupal migration community.

## Maintainers

- [Drupal Migration Plus Team](https://www.drupal.org/project/drupal_migration_plus/maintainers)

## Supporting Organizations

- [Drupal Association](https://www.drupal.org/association)
- [Drupal Migration Group](https://groups.drupal.org/migration)
