---
id: modules-development-drupal_migration_plus-INDEX
---
# Drupal Migration Plus Documentation Index

## Stable Features (100% Built & Tested)

- **Drupal-to-Drupal Migration**: Migrate content, config, and users between Drupal sites. [See details](DRUPAL_TO_DRUPAL_MIGRATION)
- **Field Mapping**: Advanced field mapping and transformation for complex migrations. [See details](FIELD_MAPPING_TUTORIAL)
- **Parallel Processing**: High-performance, parallelized migration engine. [See details](PARALLEL_PROCESSING_IMPLEMENTATION_STATUS)
- **Visual Migration Dashboard**: Real-time migration status and metrics via UI. [See details](VISUAL_MIGRATION_SUMMARY)
- **Recipe-Based Onboarding**: Guided migration setup using recipes. [See details](RECIPE_ONBOARDING)
- **API Endpoints**: REST/OpenAPI endpoints for migration control and monitoring. [See details](API_DOCUMENTATION)
- **CLI/Drush Commands**: Drush commands for migration execution, validation, and reporting. [See details](README.md#drush-commands)
- **Comprehensive Error Handling**: Robust error reporting and recovery for all migration phases. [See details](USER_GUIDE.md#error-handling)
- **Testing & Debugging Tools**: Built-in tools for migration validation and debugging. [See details](TROUBLESHOOTING)

## Release Readiness

- [x] All features above are fully implemented and tested
- [x] 95%+ test coverage (unit, kernel, functional)
- [x] All CI/CD checks pass
- [x] No deprecated or experimental APIs in this release
- [x] Documentation is up to date

## Quick Start

1. `composer require bluefly/drupal-migration-plus`
2. `drush en drupal_migration_plus`
3. Configure migrations via Admin UI or recipes
4. Use Drush or REST API to execute and monitor migrations

## Support & Contribution

- [Troubleshooting](TROUBLESHOOTING)
- [Contributing](../CONTRIBUTING)
- [Issue Queue](https://www.drupal.org/project/issues/drupal_migration_plus) 
