---
title: Package Information
description: NPM package details for apple-fm
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/apple-fm`
- **Version**: `0.1.8`
- **Description**: Apple Foundation Models SDK for Node.js and Drupal integration
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/apple-fm)

## Available Scripts
- **`npm run build`**: npm run build:esm && npm run build:cjs
- **`npm run build:esm`**: tsc
- **`npm run build:cjs`**: tsc --module commonjs --outDir dist-cjs && for f in dist-cjs/*.js; do mv "$f" "[f%.js].cjs"; done && cp -r dist-cjs/*.cjs dist/
- **`npm run clean`**: rm -rf dist dist-cjs coverage
- **`npm run test`**: jest
- **`npm run test:watch`**: jest --watch
- **`npm run test:coverage`**: jest --coverage
- **`npm run lint`**: eslint src/**/*.ts
- **`npm run lint:fix`**: eslint src/**/*.ts --fix
- **`npm run typecheck`**: tsc --noEmit
- **`npm run prepublishOnly`**: npm run clean && npm run build
- **`npm run tdd`**: tddai tdd workflow
- **`npm run tdd:validate`**: tddai validate --strict
- **`npm run audit`**: npm audit --audit-level=moderate
- **`npm run audit:fix`**: npm audit fix
- **`npm run apple:fm:acceleration:worker`**: node scripts/apple-fm-acceleration-worker.cjs
- **`npm run test:multimodal`**: node scripts/test-multimodal.js

## Dependencies (3)
- axios
- cockatiel
- jsonwebtoken

## Dev Dependencies (10)
- @bluefly/tddai
- @types/jest
- @types/node
- @typescript-eslint/eslint-plugin
- @typescript-eslint/parser
- chalk
- eslint
- jest
- ts-jest
- typescript

