---
title: Package Information
description: NPM package details for llm-mcp
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/llm-mcp`
- **Version**: `0.1.3`
- **Description**: Model Context Protocol server for LLM Platform ecosystem
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/llm-mcp)

## Available Scripts
- **`npm run build`**: tsc
- **`npm run test`**: jest
- **`npm run test:watch`**: jest --watch
- **`npm run test:coverage`**: jest --coverage
- **`npm run test:unit`**: jest --testPathPattern=unit
- **`npm run test:integration`**: jest --testPathPattern=integration
- **`npm run test:ci`**: jest --ci --coverage --maxWorkers=2
- **`npm run test:e2e`**: nightwatch --config nightwatch.conf.js
- **`npm run docker:build`**: docker build -t registry.gitlab.bluefly.io/llm/llm-mcp:latest .
- **`npm run docker:push`**: docker push registry.gitlab.bluefly.io/llm/llm-mcp:latest
- **`npm run katenary:convert`**: cd ../llm-gateway && katenary convert -f deployment/katenary/docker-compose.katenary.yml -o deployment/helm-charts/llm-mcp
- **`npm run katenary:deploy`**: cd ../llm-gateway && katenary deploy -f deployment/katenary/docker-compose.katenary.yml
- **`npm run k8s:generate`**: npm run docker:build && npm run katenary:convert
- **`npm run k8s:deploy`**: npm run docker:push && npm run katenary:deploy
- **`npm run deploy:staging`**: npm run k8s:generate && kubectl apply -f ../llm-gateway/deployment/helm-charts/llm-mcp --namespace=llm-staging
- **`npm run deploy:production`**: npm run k8s:generate && kubectl apply -f ../llm-gateway/deployment/helm-charts/llm-mcp --namespace=llm-production

## Dependencies (13)
- jsonwebtoken
- bcrypt
- pg
- ioredis
- bull
- lru-cache
- dotenv
- @langchain/openai
- @langchain/anthropic
- @langchain/core
- @langchain/community
- langchain
- @modelcontextprotocol/sdk

## Dev Dependencies (8)
- @types/jest
- @types/node
- @types/bcrypt
- @types/jsonwebtoken
- @types/pg
- jest
- ts-jest
- typescript

