# System Administrator Email Templates

> Note: This document replaces a symlink that previously pointed to `./llm-mcp/docs/troubleshooting/sysadmin-email.md` which doesn't exist.

This document provides templates for system administrators to use when communicating about the Model Control Plane system.

## Service Outage Notification

```
Subject: [ALERT] Model Control Plane Service Disruption

Dear Team,

We are currently experiencing a disruption with the Model Control Plane service. 
Our team is actively investigating the issue.

Impact:
- AI model inference services are currently unavailable
- Applications depending on MCP may experience timeouts

Current Status:
- Incident identified at [TIME]
- Engineers are investigating
- Estimated resolution time: [TIME] (if known)

We will provide updates as more information becomes available.

For urgent matters, please contact the on-call engineer at [CONTACT].

Regards,
MCP Operations Team
```

## Maintenance Notification

```
Subject: Scheduled Maintenance - Model Control Plane

Dear Team,

We will be performing scheduled maintenance on the Model Control Plane infrastructure.

Maintenance Window:
- Start: [DATE/TIME]
- End: [DATE/TIME]
- Estimated Downtime: [DURATION]

Impact:
- MCP services will be unavailable during this period
- Applications should implement fallback strategies

Reason for Maintenance:
- [REASON]

If you have any questions or concerns, please contact [CONTACT].

Regards,
MCP Operations Team
```

## API Key Rotation Notification

```
Subject: Action Required - MCP API Key Rotation

Dear MCP System User,

As part of our security protocol, we will be rotating all Model Control Plane API keys.

Key Rotation Schedule:
- New keys available: [DATE]
- Old keys deprecated: [DATE]
- Old keys deactivated: [DATE]

Actions Required:
1. Generate new API keys in the MCP admin portal
2. Update your applications with the new keys
3. Verify functionality with the new keys

For assistance, please contact [CONTACT].

Regards,
MCP Security Team
```