# BFUI Integration Documentation

This directory contains documents related to integrating BFUI components with various projects in the LLM Platform LLM ecosystem.

## Integration Strategies

- [BFUI Integration Strategy](./bfui-integration-strategy.md) - Core strategy for integrating BFUI across projects
- [Project-Specific Integration](./project-specific-integration.md) - Detailed integration strategies for individual projects including bfllm, llm-mcp, bfrfp, llmcli, and Drupal modules

## Component Integrations

- [ReelCode Integration](./reelcode-integration.md) - Guide for integrating BFUI with the ReelCode AI coding standards tool
- [ReelCode Integration Plan](./REELCODE_INTEGRATION_PLAN.md) - Detailed plan for ReelCode integration

## Extensibility

- [Extensibility Guide](./extensibility.md) - Information about extending BFUI components for project-specific needs

## Project Guides

- [Project Integration Guide](./project-guide.md) - General guidelines for integrating BFUI with various project types

## Related Documents

- [BFUI Integration Master Plan](/docs/planning/BFUI_INTEGRATION_MASTER_PLAN.md) - Comprehensive approach to integrate React-based BFUI components with Drupal projects
- [BFUI Integration Revised Plan](/docs/planning/BFUI_INTEGRATION_REVISED_PLAN.md) - Revised approach using llmcli as the integration point
- [Comprehensive Integration Strategy](/docs/comprehensive_integration_strategy.md) - Strategic approach to maximize BFUI usage across all projects
- [Integration Guide](/docs/integration_guide.md) - Detailed instructions for integrating BFUI components
- [Tailwind Migration Summary](/docs/tailwind-migration-summary.md) - Progress on Tailwind CSS migration which affects integration