// Nightwatch E2E: Secure Drupal Security Modules Enablement

module.exports = {
  '@tags': ['secure_drupal', 'modules', 'enablement'],

  'Verify All Security Modules Are Enabled and Configured': function (browser) {
    // 1. Log in as admin
    browser
      .drupalLogin({username: 'admin', password: 'admin'});

    // 2. Visit the modules page
    browser
      .url(browser.launchUrl + '/admin/modules')
      .waitForElementVisible('body', 2000);

    // 3. Assert all required security modules are enabled
    [
      'Security Review',
      'Password Policy',
      'Autologout',
      'TFA',
      'Login Security',
      'SecKit',
      'Captcha',
      'Honeypot',
      'Shield',
      'Paranoia',
      'GDPR',
      'Encrypt',
      'Key',
      'Field Encrypt',
      'CSP'
    ].forEach(moduleName => {
      browser.assert.containsText('body', moduleName);
      browser.assert.attributeContains(
        `input[type="checkbox"][data-drupal-selector="edit-modules-${moduleName.toLowerCase().replace(/ /g, '-')}-enable"]`,
        'checked',
        'checked'
      );
    });

    // 4. Optionally, check for configuration links
    browser
      .assert.containsText('body', 'Configure')
      .end();
  }
};