---
title: Package Information
description: NPM package details for tddai
sidebar_position: 99
---

# Package Information

## Basic Info
- **Name**: `@bluefly/tddai`
- **Version**: `0.1.5`
- **Description**: TDD AI module for LLM Platform ecosystem
- **License**: MIT
- **Repository**: [GitLab](https://gitlab.bluefly.io/llm/tddai)

## Available Scripts
- **`npm run build`**: tsc
- **`npm run test`**: NODE_OPTIONS='--experimental-vm-modules' jest
- **`npm run test:e2e`**: nightwatch --config nightwatch.conf.js
- **`npm run test:watch`**: NODE_OPTIONS='--experimental-vm-modules' jest --watch
- **`npm run test:coverage`**: NODE_OPTIONS='--experimental-vm-modules' jest --coverage
- **`npm run test:ci`**: NODE_OPTIONS='--experimental-vm-modules' jest --ci --coverage --watchAll=false
- **`npm run test:mutation`**: stryker run
- **`npm run test:property`**: NODE_OPTIONS='--experimental-vm-modules' jest --testPathPattern=property
- **`npm run test:quality`**: npm run test:mutation && npm run test:property
- **`npm run validate:standards`**: node scripts/stub-monitor.js --strict
- **`npm run ai:analyze`**: node dist/ai/code-analyzer.js
- **`npm run ai:enhance`**: node dist/ai/test-enhancer.js
- **`npm run ai:report`**: node dist/ai/quality-reporter.js
- **`npm run setup:ai`**: node scripts/setup-ai-features.js

## Dependencies (19)
- @anthropic-ai/sdk
- @langchain/core
- @langchain/openai
- @types/glob
- @typescript-eslint/eslint-plugin
- @typescript-eslint/parser
- axios
- chalk
- cli-table3
- commander
- dotenv
- eslint
- figlet
- glob
- inquirer
- js-yaml
- openai
- ora
- typescript

## Dev Dependencies (13)
- @stryker-mutator/core
- @stryker-mutator/jest-runner
- @stryker-mutator/typescript-checker
- @types/jest
- @types/js-yaml
- fast-check
- jest
- jest-extended
- listr2
- tiktoken

... and 3 more
