module.exports = {
  preset: 'ts-jest',
  testEnvironment: 'node',
  roots: ['<rootDir>/src', '<rootDir>/__tests__'],
  testMatch: [
    '**/__tests__/**/*.test.ts',
    '**/__tests__/**/*.spec.ts'
  ],
  transform: {
    '^.+\.ts$': 'ts-jest',
  },
  collectCoverageFrom: [
    'src/**/*.ts',
    '!src/**/*.d.ts',
    '!src/**/*.test.ts'
  ],
  coverageDirectory: 'coverage',
  coverageReporters: ['text', 'lcov', 'html'],
  coverageThreshold: {
    global: {
      branches: 95,
      functions: 95,
      lines: 95,
      statements: 95
    }
  },
  testTimeout: 10000,
  testPathIgnorePatterns: [
    '/node_modules/',
    '/vendor/',
    '/dist/',
    '/build/',
    '/coverage/',
    '/__mocks__/',
    '/__mock_compiled__/',
    '/__DELETE_LATER/',
    '/.git/',
    '/.cache/',
    '/.next/',
    '/.output/',
    '/.turbo/',
    '/.vercel/',
    '/.ddev/',
    '/.idea/',
    '/.vscode/',
    '/.DS_Store/',
    '/.env/',
    '/.log/',
    '/.bak/',
    '/.swp/',
    '/.tmp/',
    '/.lock/',
    '/.sqlite/',
    '/.db/',
    '/.zip/',
    '/.tar/',
    '/.gz/',
    '/.tgz/',
    '/.rar/',
    '/.7z/',
    '/.bin/',
    '/.exe/',
    '/.dll/',
    '/.so/',
    '/.dylib/',
    '/.pyc/',
    '/.pyo/',
    '/.pyd/',
    '/.class/',
    '/.jar/',
    '/.war/',
    '/.ear/',
    '/.apk/',
    '/.ipa/',
    '/.xcodeproj/',
    '/.xcworkspace/',
    '/Pods/',
    '/Carthage/',
    '/DerivedData/',
    '/out/',
    '/tmp/',
    '/temp/',
    '/logs/',
    '/test-output/',
    '/test-results/',
    '/test-coverage/',
    '/test-report/',
    '/test-reports/',
    '/test-logs/',
    '/test-data/',
    '/test-fixtures/',
    '/test-snapshots/',
    '/test-artifacts/',
    '/test-assets/',
    '/test-images/',
    '/test-videos/',
    '/test-audio/',
    '/test-docs/',
    '/test-files/',
    '/test-folders/',
    '/test-helpers/',
    '/test-utils/',
    '/test-mocks/',
    '/test-stubs/',
    '/test-doubles/',
    '/test-fakes/',
    '/test-spies/',
    '/test-shims/',
    '/test-harness/',
    '/test-drivers/',
    '/test-adapters/',
    '/test-plugins/',
    '/test-modules/',
    '/test-components/',
    '/test-services/',
    '/test-controllers/',
    '/test-models/',
    '/test-views/',
    '/test-routes/',
    '/test-middlewares/',
    '/test-hooks/',
    '/test-scripts/',
    '/test-tasks/',
    '/tes/',
    '\\.d\.ts$'
  ]
};