const dotenv = require('dotenv');

// Load environment variables
dotenv.config();

module.exports = {
  jwtSecret: process.env.JWT_SECRET || 'your-secret-key',
  jwtExpiresIn: process.env.JWT_EXPIRES_IN || '1h',
  rateLimit: {
    authWindow: 60 * 1000, // 1 minute
    authMax: 10, // 10 requests per minute per IP
    standardWindow: 60 * 1000, // 1 minute
    standardMax: 60, // 60 requests per minute per user
    bulkWindow: 60 * 1000, // 1 minute
    bulkMax: 10 // 10 requests per minute per user
  }
};