// @ts-check

/** @type {import('@docusaurus/plugin-content-docs').SidebarsConfig} */
const sidebars = {
  tutorialSidebar: [
    // Main documentation hub
    {
      type: 'doc',
      id: 'index',
      label: '🏠 Documentation Hub',
    },

    // NPM Packages - Only the main packages
    {
      type: 'category',
      label: '📦 NPM Packages',
      collapsed: false,
      items: [
        {
          type: 'link',
          label: '🚀 LLM Gateway',
          href: 'packages/llm-gateway/',
        },
        {
          type: 'link',
          label: '🔗 Gateway SDK',
          href: 'packages/llm-gateway-sdk/',
        },
        {
          type: 'link',
          label: '🤖 MCP Server',
          href: 'packages/llm-mcp/',
        },
        {
          type: 'link',
          label: '🍎 Apple Foundation Models',
          href: 'packages/apple-fm/',
        },
        {
          type: 'link',
          label: '📄 RFP Generator',
          href: 'packages/bfrfp/',
        },
        {
          type: 'link',
          label: '🧪 TDD AI Framework',
          href: 'packages/tddai/',
        },
        {
          type: 'link',
          label: '⚡ CLI Tools',
          href: 'packages/llmcli/',
        },
        {
          type: 'link',
          label: '🎨 UI Components',
          href: 'packages/llm-ui/',
        },
        {
          type: 'link',
          label: '🔒 Security Project',
          href: 'packages/secure-project/',
        },
      ],
    },

    // AI Models
    {
      type: 'category',
      label: '🤖 AI Models',
      collapsed: true,
      items: [
        {
          type: 'link',
          label: 'TDDAI Model',
          href: 'models/tddai-model/',
        },
      ],
    },

    // CI/CD Components
    {
      type: 'category',
      label: '🔧 CI/CD Components',
      collapsed: true,
      items: [
        {
          type: 'link',
          label: 'BF CI Components',
          href: 'cicd/bfcicomponents/',
        },
      ],
    },
  ],
};

module.exports = sidebars;
