import React from 'react';
import clsx from 'clsx';
import styles from './styles.module.css';

const FeatureList = [
  {
    "title": "Standardized CI/CD Components",
    "description": "Pre-built, tested, and maintained CI/CD components for GitLab pipelines"
  },
  {
    "title": "Easy Integration",
    "description": "Simple configuration and seamless integration with GitLab projects"
  },
  {
    "title": "Security Best Practices",
    "description": "Built-in security features and compliance with industry standards"
  }
];

function Feature({title, description}) {
  return (
    <div className={clsx('col col--4')}>
      <div className="text--center padding-horiz--md">
        <h3>{title}</h3>
        <p>{description}</p>
      </div>
    </div>
  );
}

export default function HomepageFeatures() {
  return (
    <section className={styles.features}>
      <div className="container">
        <div className="row">
          {FeatureList.map((props, idx) => (
            <Feature key={idx} {...props} />
          ))}
        </div>
      </div>
    </section>
  );
}