/**
 * Bluefly Documentation Library
 * 
 * This module provides utilities for documentation generation and validation.
 */

export interface DocConfig {
  title: string;
  description: string;
  version: string;
}

export const defaultConfig: DocConfig = {
  title: 'Bluefly Platform Documentation',
  description: 'Technical documentation for the Bluefly Platform',
  version: '0.1.0'
};

export const validateConfig = (config: DocConfig): boolean => {
  return !!(config.title && config.description && config.version);
};